// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.Azure.Graph.RBAC;
using Microsoft.Azure.Graph.RBAC.Models;

namespace Microsoft.Azure.Graph.RBAC
{
    public static partial class ApplicationOperationsExtensions
    {
        /// <summary>
        /// Create a new application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters to create an application.
        /// </param>
        /// <returns>
        /// Server response for Get application information API call
        /// </returns>
        public static ApplicationGetResult Create(this IApplicationOperations operations, ApplicationCreateParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationOperations)s).CreateAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Create a new application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters to create an application.
        /// </param>
        /// <returns>
        /// Server response for Get application information API call
        /// </returns>
        public static Task<ApplicationGetResult> CreateAsync(this IApplicationOperations operations, ApplicationCreateParameters parameters)
        {
            return operations.CreateAsync(parameters, CancellationToken.None);
        }
        
        /// <summary>
        /// Delete an application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='applicationObjectId'>
        /// Required. Application object id
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse Delete(this IApplicationOperations operations, string applicationObjectId)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationOperations)s).DeleteAsync(applicationObjectId);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Delete an application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='applicationObjectId'>
        /// Required. Application object id
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> DeleteAsync(this IApplicationOperations operations, string applicationObjectId)
        {
            return operations.DeleteAsync(applicationObjectId, CancellationToken.None);
        }
        
        /// <summary>
        /// Get an application by object Id.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='applicationObjectId'>
        /// Required. Application object id
        /// </param>
        /// <returns>
        /// Server response for Get application information API call
        /// </returns>
        public static ApplicationGetResult Get(this IApplicationOperations operations, string applicationObjectId)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationOperations)s).GetAsync(applicationObjectId);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Get an application by object Id.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='applicationObjectId'>
        /// Required. Application object id
        /// </param>
        /// <returns>
        /// Server response for Get application information API call
        /// </returns>
        public static Task<ApplicationGetResult> GetAsync(this IApplicationOperations operations, string applicationObjectId)
        {
            return operations.GetAsync(applicationObjectId, CancellationToken.None);
        }
        
        /// <summary>
        /// Get applications by filters.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Application filter parameters
        /// </param>
        /// <returns>
        /// Server response for List application information API call
        /// </returns>
        public static ApplicationListResult List(this IApplicationOperations operations, ApplicationFilterParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationOperations)s).ListAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Get applications by filters.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Application filter parameters
        /// </param>
        /// <returns>
        /// Server response for List application information API call
        /// </returns>
        public static Task<ApplicationListResult> ListAsync(this IApplicationOperations operations, ApplicationFilterParameters parameters)
        {
            return operations.ListAsync(parameters, CancellationToken.None);
        }
        
        /// <summary>
        /// Update existing application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='applicationObjectId'>
        /// Required. Application object id
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters to create an application.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse Update(this IApplicationOperations operations, string applicationObjectId, ApplicationCreateParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationOperations)s).UpdateAsync(applicationObjectId, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Update existing application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IApplicationOperations.
        /// </param>
        /// <param name='applicationObjectId'>
        /// Required. Application object id
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters to create an application.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> UpdateAsync(this IApplicationOperations operations, string applicationObjectId, ApplicationCreateParameters parameters)
        {
            return operations.UpdateAsync(applicationObjectId, parameters, CancellationToken.None);
        }
    }
}
