// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.Azure.Graph.RBAC.Models;

namespace Microsoft.Azure.Graph.RBAC
{
    /// <summary>
    /// Operations for working with applications in Azure Active Directory
    /// Graph API.  (see
    /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for more
    /// information)
    /// </summary>
    public partial interface IApplicationOperations
    {
        /// <summary>
        /// Create a new application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='parameters'>
        /// Parameters to create an application.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Server response for Get application information API call
        /// </returns>
        Task<ApplicationGetResult> CreateAsync(ApplicationCreateParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Delete an application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='applicationObjectId'>
        /// Application object id
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<AzureOperationResponse> DeleteAsync(string applicationObjectId, CancellationToken cancellationToken);
        
        /// <summary>
        /// Get an application by object Id.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='applicationObjectId'>
        /// Application object id
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Server response for Get application information API call
        /// </returns>
        Task<ApplicationGetResult> GetAsync(string applicationObjectId, CancellationToken cancellationToken);
        
        /// <summary>
        /// Get applications by filters.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='parameters'>
        /// Application filter parameters
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Server response for List application information API call
        /// </returns>
        Task<ApplicationListResult> ListAsync(ApplicationFilterParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Update existing application.  (see
        /// http://msdn.microsoft.com/en-us/library/azure/hh974476.aspx for
        /// more information)
        /// </summary>
        /// <param name='applicationObjectId'>
        /// Application object id
        /// </param>
        /// <param name='parameters'>
        /// Parameters to create an application.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<AzureOperationResponse> UpdateAsync(string applicationObjectId, ApplicationCreateParameters parameters, CancellationToken cancellationToken);
    }
}
