// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Graph.RBAC.Models
{
    /// <summary>
    /// Active Directory user information
    /// </summary>
    public partial class Application
    {
        private string _appId;
        
        /// <summary>
        /// Optional. Gets or sets application Id
        /// </summary>
        public string AppId
        {
            get { return this._appId; }
            set { this._appId = value; }
        }
        
        private IList<string> _appPermissions;
        
        /// <summary>
        /// Optional. Gets or sets application permissions
        /// </summary>
        public IList<string> AppPermissions
        {
            get { return this._appPermissions; }
            set { this._appPermissions = value; }
        }
        
        private bool _availableToOtherTenants;
        
        /// <summary>
        /// Optional. Indicates if the application will be available to other
        /// tenants
        /// </summary>
        public bool AvailableToOtherTenants
        {
            get { return this._availableToOtherTenants; }
            set { this._availableToOtherTenants = value; }
        }
        
        private string _displayName;
        
        /// <summary>
        /// Optional. Gets or sets the displayName
        /// </summary>
        public string DisplayName
        {
            get { return this._displayName; }
            set { this._displayName = value; }
        }
        
        private IList<string> _identifierUris;
        
        /// <summary>
        /// Optional. Gets or sets application identifierUris
        /// </summary>
        public IList<string> IdentifierUris
        {
            get { return this._identifierUris; }
            set { this._identifierUris = value; }
        }
        
        private string _objectId;
        
        /// <summary>
        /// Optional. Gets or sets object Id
        /// </summary>
        public string ObjectId
        {
            get { return this._objectId; }
            set { this._objectId = value; }
        }
        
        private string _objectType;
        
        /// <summary>
        /// Optional. Gets or sets object type
        /// </summary>
        public string ObjectType
        {
            get { return this._objectType; }
            set { this._objectType = value; }
        }
        
        private IList<string> _replyUrls;
        
        /// <summary>
        /// Optional. Gets or sets application replyUrls
        /// </summary>
        public IList<string> ReplyUrls
        {
            get { return this._replyUrls; }
            set { this._replyUrls = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Application class.
        /// </summary>
        public Application()
        {
            this.AppPermissions = new LazyList<string>();
            this.IdentifierUris = new LazyList<string>();
            this.ReplyUrls = new LazyList<string>();
        }
    }
}
