// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Graph.RBAC.Models;

namespace Microsoft.Azure.Graph.RBAC.Models
{
    /// <summary>
    /// Request parameters for create a new application
    /// </summary>
    public partial class ApplicationCreateParameters
    {
        private bool _availableToOtherTenants;
        
        /// <summary>
        /// Required. Indicates if the application will be available to other
        /// tenants
        /// </summary>
        public bool AvailableToOtherTenants
        {
            get { return this._availableToOtherTenants; }
            set { this._availableToOtherTenants = value; }
        }
        
        private string _displayName;
        
        /// <summary>
        /// Required. Application display name
        /// </summary>
        public string DisplayName
        {
            get { return this._displayName; }
            set { this._displayName = value; }
        }
        
        private string _homepage;
        
        /// <summary>
        /// Required. Application homepage
        /// </summary>
        public string Homepage
        {
            get { return this._homepage; }
            set { this._homepage = value; }
        }
        
        private IList<string> _identifierUris;
        
        /// <summary>
        /// Required. Application Uris
        /// </summary>
        public IList<string> IdentifierUris
        {
            get { return this._identifierUris; }
            set { this._identifierUris = value; }
        }
        
        private IList<KeyCredential> _keyCredentials;
        
        /// <summary>
        /// Optional. Gets or sets the list of KeyCredential objects
        /// </summary>
        public IList<KeyCredential> KeyCredentials
        {
            get { return this._keyCredentials; }
            set { this._keyCredentials = value; }
        }
        
        private IList<PasswordCredential> _passwordCredentials;
        
        /// <summary>
        /// Optional. Gets or sets the list of PasswordCredential objects
        /// </summary>
        public IList<PasswordCredential> PasswordCredentials
        {
            get { return this._passwordCredentials; }
            set { this._passwordCredentials = value; }
        }
        
        private IList<string> _replyUrls;
        
        /// <summary>
        /// Optional. Application reply Urls
        /// </summary>
        public IList<string> ReplyUrls
        {
            get { return this._replyUrls; }
            set { this._replyUrls = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ApplicationCreateParameters class.
        /// </summary>
        public ApplicationCreateParameters()
        {
            this.IdentifierUris = new LazyList<string>();
            this.KeyCredentials = new LazyList<KeyCredential>();
            this.PasswordCredentials = new LazyList<PasswordCredential>();
            this.ReplyUrls = new LazyList<string>();
        }
    }
}
