// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Graph.RBAC.Models
{
    /// <summary>
    /// Request parameters for GetObjectsByObjectIds API call
    /// </summary>
    public partial class GetObjectsParameters
    {
        private IList<string> _ids;
        
        /// <summary>
        /// Optional. Requested object Ids
        /// </summary>
        public IList<string> Ids
        {
            get { return this._ids; }
            set { this._ids = value; }
        }
        
        private bool _includeDirectoryObjectReferences;
        
        /// <summary>
        /// Required. If true, also searches for object ids in the partner
        /// tenant
        /// </summary>
        public bool IncludeDirectoryObjectReferences
        {
            get { return this._includeDirectoryObjectReferences; }
            set { this._includeDirectoryObjectReferences = value; }
        }
        
        private IList<string> _types;
        
        /// <summary>
        /// Optional. Requested object types
        /// </summary>
        public IList<string> Types
        {
            get { return this._types; }
            set { this._types = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the GetObjectsParameters class.
        /// </summary>
        public GetObjectsParameters()
        {
            this.Ids = new LazyList<string>();
            this.Types = new LazyList<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the GetObjectsParameters class with
        /// required arguments.
        /// </summary>
        public GetObjectsParameters(bool includeDirectoryObjectReferences)
            : this()
        {
            this.IncludeDirectoryObjectReferences = includeDirectoryObjectReferences;
        }
    }
}
