// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Graph.RBAC.Models
{
    /// <summary>
    /// Request parameters for create a new service principal
    /// </summary>
    public partial class ServicePrincipalCreateParameters
    {
        private bool _accountEnabled;
        
        /// <summary>
        /// Required. Specifies if the account is enabled
        /// </summary>
        public bool AccountEnabled
        {
            get { return this._accountEnabled; }
            set { this._accountEnabled = value; }
        }
        
        private string _appId;
        
        /// <summary>
        /// Required. Gets or sets application Id
        /// </summary>
        public string AppId
        {
            get { return this._appId; }
            set { this._appId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServicePrincipalCreateParameters
        /// class.
        /// </summary>
        public ServicePrincipalCreateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ServicePrincipalCreateParameters
        /// class with required arguments.
        /// </summary>
        public ServicePrincipalCreateParameters(string appId, bool accountEnabled)
            : this()
        {
            if (appId == null)
            {
                throw new ArgumentNullException("appId");
            }
            this.AppId = appId;
            this.AccountEnabled = accountEnabled;
        }
    }
}
