// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Graph.RBAC;
using Microsoft.Azure.Graph.RBAC.Models;

namespace Microsoft.Azure.Graph.RBAC
{
    public static partial class ObjectOperationsExtensions
    {
        /// <summary>
        /// Gets the details for current logged in user
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IObjectOperations.
        /// </param>
        /// <returns>
        /// Server response for Active Directory objects inquiry API calls
        /// </returns>
        public static GetCurrentUserResult GetCurrentUser(this IObjectOperations operations)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IObjectOperations)s).GetCurrentUserAsync();
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets the details for current logged in user
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IObjectOperations.
        /// </param>
        /// <returns>
        /// Server response for Active Directory objects inquiry API calls
        /// </returns>
        public static Task<GetCurrentUserResult> GetCurrentUserAsync(this IObjectOperations operations)
        {
            return operations.GetCurrentUserAsync(CancellationToken.None);
        }
        
        /// <summary>
        /// Gets AD group membership by provided AD object Ids
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IObjectOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Objects filtering parameters.
        /// </param>
        /// <returns>
        /// Server response for Active Directory objects inquiry API calls
        /// </returns>
        public static GetObjectsResult GetObjectsByObjectIds(this IObjectOperations operations, GetObjectsParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IObjectOperations)s).GetObjectsByObjectIdsAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets AD group membership by provided AD object Ids
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Graph.RBAC.IObjectOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. Objects filtering parameters.
        /// </param>
        /// <returns>
        /// Server response for Active Directory objects inquiry API calls
        /// </returns>
        public static Task<GetObjectsResult> GetObjectsByObjectIdsAsync(this IObjectOperations operations, GetObjectsParameters parameters)
        {
            return operations.GetObjectsByObjectIdsAsync(parameters, CancellationToken.None);
        }
    }
}
