// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.ApiApps.Models;

namespace Microsoft.Azure.Management.ApiApps
{
    /// <summary>
    /// ApiApp operations  (see
    /// http://azure.microsoft.com/en-us/services/app-service/api/ for more
    /// information)
    /// </summary>
    public partial interface IApiAppOperations
    {
        /// <summary>
        /// Get information about a specific ApiApp
        /// </summary>
        /// <param name='resourceGroup'>
        /// The resource group containing the api app
        /// </param>
        /// <param name='name'>
        /// The instance name of the apiapp
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<GetApiAppResponse> GetAsync(string resourceGroup, string name, CancellationToken cancellationToken);
        
        /// <summary>
        /// Return list of the deployed ApiApps for the resource group
        /// </summary>
        /// <param name='resourceGroup'>
        /// Name of the resource group containing the apiapps to list
        /// </param>
        /// <param name='expand'>
        /// Option controlling how much data to return, valid options are
        /// "basic" or "detail"
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<ListApiAppsResponse> ListAsync(string resourceGroup, string expand, CancellationToken cancellationToken);
        
        /// <summary>
        /// Return list of the deployed ApiApps for this subscription
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<ListApiAppsResponse> ListAllAsync(CancellationToken cancellationToken);
        
        /// <summary>
        /// List the next set of ApiApps from the previous list call.
        /// </summary>
        /// <param name='nextLink'>
        /// NextLink from a previous successful call to List operation.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<ListApiAppsResponse> ListNextAsync(string nextLink, CancellationToken cancellationToken);
    }
}
