// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.ApiApps.Models;

namespace Microsoft.Azure.Management.ApiApps.Models
{
    /// <summary>
    /// Data about an individual microservice
    /// </summary>
    public partial class MicroserviceMetadata
    {
        private string _displayName;
        
        /// <summary>
        /// Optional. Gets or sets display name
        /// </summary>
        public string DisplayName
        {
            get { return this._displayName; }
            set { this._displayName = value; }
        }
        
        private string _microserviceId;
        
        /// <summary>
        /// Optional. Gets or sets service id
        /// </summary>
        public string MicroserviceId
        {
            get { return this._microserviceId; }
            set { this._microserviceId = value; }
        }
        
        private IList<ParameterMetadata> _parameters;
        
        /// <summary>
        /// Optional. Gets or sets parameters
        /// </summary>
        public IList<ParameterMetadata> Parameters
        {
            get { return this._parameters; }
            set { this._parameters = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MicroserviceMetadata class.
        /// </summary>
        public MicroserviceMetadata()
        {
            this.Parameters = new LazyList<ParameterMetadata>();
        }
    }
}
