// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.ApiManagement.SmapiModels;

namespace Microsoft.Azure.Management.ApiManagement.SmapiModels
{
    /// <summary>
    /// Error Body contract.
    /// </summary>
    public partial class ErrorBodyContract
    {
        private string _code;
        
        /// <summary>
        /// Optional. Gets or sets Service-defined error code. This code serves
        /// as a sub-status for the HTTP error code specified in the response.
        /// </summary>
        public string Code
        {
            get { return this._code; }
            set { this._code = value; }
        }
        
        private IList<ErrorFieldContract> _details;
        
        /// <summary>
        /// Optional. Gets or sets the list of invalid fields send in request,
        /// in case of validation error.
        /// </summary>
        public IList<ErrorFieldContract> Details
        {
            get { return this._details; }
            set { this._details = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Optional. Gets or sets Human-readable representation of the error.
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ErrorBodyContract class.
        /// </summary>
        public ErrorBodyContract()
        {
            this.Details = new LazyList<ErrorFieldContract>();
        }
    }
}
