// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.ApiManagement.SmapiModels;

namespace Microsoft.Azure.Management.ApiManagement.SmapiModels
{
    /// <summary>
    /// Operation Result.
    /// </summary>
    public partial class OperationResultContract
    {
        private ErrorBodyContract _error;
        
        /// <summary>
        /// Optional. Gets or sets Errors that have occured during the
        /// operation execution.
        /// </summary>
        public ErrorBodyContract Error
        {
            get { return this._error; }
            set { this._error = value; }
        }
        
        private string _idPath;
        
        /// <summary>
        /// Optional. Gets or sets Operation result identifier.
        /// </summary>
        public string IdPath
        {
            get { return this._idPath; }
            set { this._idPath = value; }
        }
        
        private string _resultInfo;
        
        /// <summary>
        /// Optional. Gets or sets Optional result info.
        /// </summary>
        public string ResultInfo
        {
            get { return this._resultInfo; }
            set { this._resultInfo = value; }
        }
        
        private DateTime _started;
        
        /// <summary>
        /// Optional. Gets or sets Start time of an async operation.
        /// </summary>
        public DateTime Started
        {
            get { return this._started; }
            set { this._started = value; }
        }
        
        private AsyncOperationState _status;
        
        /// <summary>
        /// Optional. Gets or sets Status of an async operation.
        /// </summary>
        public AsyncOperationState Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private DateTime _updated;
        
        /// <summary>
        /// Optional. Gets or sets Last update time of an async operation.
        /// </summary>
        public DateTime Updated
        {
            get { return this._updated; }
            set { this._updated = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OperationResultContract class.
        /// </summary>
        public OperationResultContract()
        {
        }
    }
}
