// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.ApiManagement.SmapiModels
{
    /// <summary>
    /// Report data.
    /// </summary>
    public partial class ReportRecordContract
    {
        private string _apiIdPath;
        
        /// <summary>
        /// Optional. Gets or sets API identifier path. /apis/{apiId}
        /// </summary>
        public string ApiIdPath
        {
            get { return this._apiIdPath; }
            set { this._apiIdPath = value; }
        }
        
        private string _apiRegion;
        
        /// <summary>
        /// Optional. Gets or sets API region identifier.
        /// </summary>
        public string ApiRegion
        {
            get { return this._apiRegion; }
            set { this._apiRegion = value; }
        }
        
        private double _apiTimeAvg;
        
        /// <summary>
        /// Optional. Gets or sets Average time it took to process request.
        /// </summary>
        public double ApiTimeAvg
        {
            get { return this._apiTimeAvg; }
            set { this._apiTimeAvg = value; }
        }
        
        private double _apiTimeMax;
        
        /// <summary>
        /// Optional. Gets or sets Maximum time it took to process request.
        /// </summary>
        public double ApiTimeMax
        {
            get { return this._apiTimeMax; }
            set { this._apiTimeMax = value; }
        }
        
        private double _apiTimeMin;
        
        /// <summary>
        /// Optional. Gets or sets Minimum time it took to process request.
        /// </summary>
        public double ApiTimeMin
        {
            get { return this._apiTimeMin; }
            set { this._apiTimeMin = value; }
        }
        
        private long _bandwidth;
        
        /// <summary>
        /// Optional. Gets or sets Bandwidth consumed.
        /// </summary>
        public long Bandwidth
        {
            get { return this._bandwidth; }
            set { this._bandwidth = value; }
        }
        
        private int _cacheHitCount;
        
        /// <summary>
        /// Optional. Gets or sets Number of times when content was served from
        /// cache policy.
        /// </summary>
        public int CacheHitCount
        {
            get { return this._cacheHitCount; }
            set { this._cacheHitCount = value; }
        }
        
        private int _cacheMissCount;
        
        /// <summary>
        /// Optional. Gets or sets Number of times content was fetched from
        /// backend.
        /// </summary>
        public int CacheMissCount
        {
            get { return this._cacheMissCount; }
            set { this._cacheMissCount = value; }
        }
        
        private int _callCountBlocked;
        
        /// <summary>
        /// Optional. Gets or sets Number of calls blocked due to invalid
        /// credentials.
        /// </summary>
        public int CallCountBlocked
        {
            get { return this._callCountBlocked; }
            set { this._callCountBlocked = value; }
        }
        
        private int _callCountFailed;
        
        /// <summary>
        /// Optional. Gets or sets number of calls failed due to proxy or
        /// backend errors.
        /// </summary>
        public int CallCountFailed
        {
            get { return this._callCountFailed; }
            set { this._callCountFailed = value; }
        }
        
        private int _callCountOther;
        
        /// <summary>
        /// Optional. Gets or sets Number of other calls.
        /// </summary>
        public int CallCountOther
        {
            get { return this._callCountOther; }
            set { this._callCountOther = value; }
        }
        
        private int _callCountSuccess;
        
        /// <summary>
        /// Optional. Gets or sets Number of succesful calls.
        /// </summary>
        public int CallCountSuccess
        {
            get { return this._callCountSuccess; }
            set { this._callCountSuccess = value; }
        }
        
        private int _callCountTotal;
        
        /// <summary>
        /// Optional. Gets or sets Total number of calls.
        /// </summary>
        public int CallCountTotal
        {
            get { return this._callCountTotal; }
            set { this._callCountTotal = value; }
        }
        
        private string _country;
        
        /// <summary>
        /// Optional. Gets or sets Country to which this record data is related.
        /// </summary>
        public string Country
        {
            get { return this._country; }
            set { this._country = value; }
        }
        
        private TimeSpan _interval;
        
        /// <summary>
        /// Optional. Gets or sets Length of agregation period.
        /// </summary>
        public TimeSpan Interval
        {
            get { return this._interval; }
            set { this._interval = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets name depending on report endpoint specifies
        /// product, API, operation or developer name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _operationIdPath;
        
        /// <summary>
        /// Optional. Gets or sets Operation identifier path.
        /// /apis/{aid}/operations/{oid}
        /// </summary>
        public string OperationIdPath
        {
            get { return this._operationIdPath; }
            set { this._operationIdPath = value; }
        }
        
        private string _productIdPath;
        
        /// <summary>
        /// Optional. Gets or sets Product identifier path.
        /// /products/{productId}
        /// </summary>
        public string ProductIdPath
        {
            get { return this._productIdPath; }
            set { this._productIdPath = value; }
        }
        
        private string _region;
        
        /// <summary>
        /// Optional. Gets or sets Country region to which this record data is
        /// related.
        /// </summary>
        public string Region
        {
            get { return this._region; }
            set { this._region = value; }
        }
        
        private double _serviceTimeAvg;
        
        /// <summary>
        /// Optional. Gets or sets Average time it took to process request on
        /// backend.
        /// </summary>
        public double ServiceTimeAvg
        {
            get { return this._serviceTimeAvg; }
            set { this._serviceTimeAvg = value; }
        }
        
        private double _serviceTimeMax;
        
        /// <summary>
        /// Optional. Gets or sets Maximum time it took to process request on
        /// backend.
        /// </summary>
        public double ServiceTimeMax
        {
            get { return this._serviceTimeMax; }
            set { this._serviceTimeMax = value; }
        }
        
        private double _serviceTimeMin;
        
        /// <summary>
        /// Optional. Gets or sets Minimum time it took to process request on
        /// backend.
        /// </summary>
        public double ServiceTimeMin
        {
            get { return this._serviceTimeMin; }
            set { this._serviceTimeMin = value; }
        }
        
        private string _subscriptionIdPath;
        
        /// <summary>
        /// Optional. Gets or sets Subscription identifier path.
        /// /subscriptions/{subscriptionId}
        /// </summary>
        public string SubscriptionIdPath
        {
            get { return this._subscriptionIdPath; }
            set { this._subscriptionIdPath = value; }
        }
        
        private DateTime _timestamp;
        
        /// <summary>
        /// Optional. Gets or sets Start of aggregation period.
        /// </summary>
        public DateTime Timestamp
        {
            get { return this._timestamp; }
            set { this._timestamp = value; }
        }
        
        private string _userIdPath;
        
        /// <summary>
        /// Optional. Gets or sets User identifier path. /users/{userId}
        /// </summary>
        public string UserIdPath
        {
            get { return this._userIdPath; }
            set { this._userIdPath = value; }
        }
        
        private string _zip;
        
        /// <summary>
        /// Optional. Gets or sets Zip code to which this record data is
        /// related.
        /// </summary>
        public string Zip
        {
            get { return this._zip; }
            set { this._zip = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ReportRecordContract class.
        /// </summary>
        public ReportRecordContract()
        {
        }
    }
}
