// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// The properties of the create Advanced Schedule.
    /// </summary>
    public partial class AdvancedSchedule
    {
        private IList<int> _monthDays;
        
        /// <summary>
        /// Optional. Days of the month that the job should execute on. Must be
        /// between 1 and 31.
        /// </summary>
        public IList<int> MonthDays
        {
            get { return this._monthDays; }
            set { this._monthDays = value; }
        }
        
        private IList<AdvancedScheduleMonthlyOccurrence> _monthlyOccurrences;
        
        /// <summary>
        /// Optional. Occurrences of days within a month.
        /// </summary>
        public IList<AdvancedScheduleMonthlyOccurrence> MonthlyOccurrences
        {
            get { return this._monthlyOccurrences; }
            set { this._monthlyOccurrences = value; }
        }
        
        private IList<string> _weekDays;
        
        /// <summary>
        /// Optional. Days of the week that the job should execute on.
        /// </summary>
        public IList<string> WeekDays
        {
            get { return this._weekDays; }
            set { this._weekDays = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AdvancedSchedule class.
        /// </summary>
        public AdvancedSchedule()
        {
            this.MonthDays = new LazyList<int>();
            this.MonthlyOccurrences = new LazyList<AdvancedScheduleMonthlyOccurrence>();
            this.WeekDays = new LazyList<string>();
        }
    }
}
