// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the dsc node type.
    /// </summary>
    public partial class DscNode : ResourceBase
    {
        private Guid _accountId;
        
        /// <summary>
        /// Optional. Gets or sets the account id of the node.
        /// </summary>
        public Guid AccountId
        {
            get { return this._accountId; }
            set { this._accountId = value; }
        }
        
        private string _ip;
        
        /// <summary>
        /// Optional. Gets or sets the ip of the node.
        /// </summary>
        public string Ip
        {
            get { return this._ip; }
            set { this._ip = value; }
        }
        
        private DateTimeOffset _lastSeen;
        
        /// <summary>
        /// Optional. Gets or sets the last seen time of the node.
        /// </summary>
        public DateTimeOffset LastSeen
        {
            get { return this._lastSeen; }
            set { this._lastSeen = value; }
        }
        
        private DscNodeConfigurationAssociationProperty _nodeConfiguration;
        
        /// <summary>
        /// Optional. Gets or sets the configuration of the node.
        /// </summary>
        public DscNodeConfigurationAssociationProperty NodeConfiguration
        {
            get { return this._nodeConfiguration; }
            set { this._nodeConfiguration = value; }
        }
        
        private Guid _nodeId;
        
        /// <summary>
        /// Optional. Gets or sets the node id.
        /// </summary>
        public Guid NodeId
        {
            get { return this._nodeId; }
            set { this._nodeId = value; }
        }
        
        private DateTimeOffset _registrationTime;
        
        /// <summary>
        /// Optional. Gets or sets the registration time of the node.
        /// </summary>
        public DateTimeOffset RegistrationTime
        {
            get { return this._registrationTime; }
            set { this._registrationTime = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Gets or sets the status of the node.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DscNode class.
        /// </summary>
        public DscNode()
        {
        }
    }
}
