// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the module property type.
    /// </summary>
    public partial class ModuleProperties : ResourceCommonPropertiesBase
    {
        private int _activityCount;
        
        /// <summary>
        /// Optional. Gets or sets the activity count of the module.
        /// </summary>
        public int ActivityCount
        {
            get { return this._activityCount; }
            set { this._activityCount = value; }
        }
        
        private ContentLink _contentLink;
        
        /// <summary>
        /// Optional. Gets or sets the contentLink of the module.
        /// </summary>
        public ContentLink ContentLink
        {
            get { return this._contentLink; }
            set { this._contentLink = value; }
        }
        
        private ModuleErrorInfo _error;
        
        /// <summary>
        /// Optional. Gets or sets the error info of the module.
        /// </summary>
        public ModuleErrorInfo Error
        {
            get { return this._error; }
            set { this._error = value; }
        }
        
        private bool _isGlobal;
        
        /// <summary>
        /// Optional. Gets or sets the isGlobal flag of the module.
        /// </summary>
        public bool IsGlobal
        {
            get { return this._isGlobal; }
            set { this._isGlobal = value; }
        }
        
        private ModuleProvisioningState _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets the provisioning state of the module.
        /// </summary>
        public ModuleProvisioningState ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private long _sizeInBytes;
        
        /// <summary>
        /// Optional. Gets or sets the size in bytes of the module.
        /// </summary>
        public long SizeInBytes
        {
            get { return this._sizeInBytes; }
            set { this._sizeInBytes = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Gets or sets the version of the module.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ModuleProperties class.
        /// </summary>
        public ModuleProperties()
        {
        }
    }
}
