// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of schedule parameters.
    /// </summary>
    public partial class ScheduleProperties : ResourceCommonPropertiesBase
    {
        private AdvancedSchedule _advancedSchedule;
        
        /// <summary>
        /// Optional. Gets or sets the advanced schedule.
        /// </summary>
        public AdvancedSchedule AdvancedSchedule
        {
            get { return this._advancedSchedule; }
            set { this._advancedSchedule = value; }
        }
        
        private DateTimeOffset _expiryTime;
        
        /// <summary>
        /// Optional. Gets or sets the end time of the schedule.
        /// </summary>
        public DateTimeOffset ExpiryTime
        {
            get { return this._expiryTime; }
            set { this._expiryTime = value; }
        }
        
        private double _expiryTimeOffsetMinutes;
        
        /// <summary>
        /// Optional. Gets or sets the expiry time's offset in minutes.
        /// </summary>
        public double ExpiryTimeOffsetMinutes
        {
            get { return this._expiryTimeOffsetMinutes; }
            set { this._expiryTimeOffsetMinutes = value; }
        }
        
        private string _frequency;
        
        /// <summary>
        /// Optional. Gets or sets the frequency of the schedule.
        /// </summary>
        public string Frequency
        {
            get { return this._frequency; }
            set { this._frequency = value; }
        }
        
        private byte? _interval;
        
        /// <summary>
        /// Optional. Gets or sets the interval of the schedule.
        /// </summary>
        public byte? Interval
        {
            get { return this._interval; }
            set { this._interval = value; }
        }
        
        private bool _isEnabled;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether this schedule is
        /// enabled.
        /// </summary>
        public bool IsEnabled
        {
            get { return this._isEnabled; }
            set { this._isEnabled = value; }
        }
        
        private System.DateTimeOffset? _nextRun;
        
        /// <summary>
        /// Optional. Gets or sets the next run time of the schedule.
        /// </summary>
        public System.DateTimeOffset? NextRun
        {
            get { return this._nextRun; }
            set { this._nextRun = value; }
        }
        
        private double _nextRunOffsetMinutes;
        
        /// <summary>
        /// Optional. Gets or sets the next run time's offset in minutes.
        /// </summary>
        public double NextRunOffsetMinutes
        {
            get { return this._nextRunOffsetMinutes; }
            set { this._nextRunOffsetMinutes = value; }
        }
        
        private DateTimeOffset _startTime;
        
        /// <summary>
        /// Optional. Gets or sets the start time of the schedule.
        /// </summary>
        public DateTimeOffset StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private double _startTimeOffsetMinutes;
        
        /// <summary>
        /// Optional. Gets or sets the start time's offset in minutes.
        /// </summary>
        public double StartTimeOffsetMinutes
        {
            get { return this._startTimeOffsetMinutes; }
            set { this._startTimeOffsetMinutes = value; }
        }
        
        private string _timeZone;
        
        /// <summary>
        /// Optional. Gets or sets the time zone of the schedule.
        /// </summary>
        public string TimeZone
        {
            get { return this._timeZone; }
            set { this._timeZone = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ScheduleProperties class.
        /// </summary>
        public ScheduleProperties()
        {
        }
    }
}
