// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// The parameters supplied to the create test job operation.
    /// </summary>
    public partial class TestJobCreateParameters
    {
        private IDictionary<string, string> _parameters;
        
        /// <summary>
        /// Optional. Gets or sets the parameters of the test job.
        /// </summary>
        public IDictionary<string, string> Parameters
        {
            get { return this._parameters; }
            set { this._parameters = value; }
        }
        
        private string _runbookName;
        
        /// <summary>
        /// Required. Gets or sets the runbook name.
        /// </summary>
        public string RunbookName
        {
            get { return this._runbookName; }
            set { this._runbookName = value; }
        }
        
        private string _runOn;
        
        /// <summary>
        /// Optional. Gets or sets the runOn which specifies the group name
        /// where the job is to be executed.
        /// </summary>
        public string RunOn
        {
            get { return this._runOn; }
            set { this._runOn = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the TestJobCreateParameters class.
        /// </summary>
        public TestJobCreateParameters()
        {
            this.Parameters = new LazyDictionary<string, string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the TestJobCreateParameters class
        /// with required arguments.
        /// </summary>
        public TestJobCreateParameters(string runbookName)
            : this()
        {
            if (runbookName == null)
            {
                throw new ArgumentNullException("runbookName");
            }
            this.RunbookName = runbookName;
        }
    }
}
