// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of Usage.
    /// </summary>
    public partial class Usage
    {
        private double _currentValue;
        
        /// <summary>
        /// Optional. Gets or sets the current usage value.
        /// </summary>
        public double CurrentValue
        {
            get { return this._currentValue; }
            set { this._currentValue = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Optional. Gets or sets the id of the resource.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private long _limit;
        
        /// <summary>
        /// Optional. Gets or sets max limit. -1 for unlimited
        /// </summary>
        public long Limit
        {
            get { return this._limit; }
            set { this._limit = value; }
        }
        
        private UsageCounterName _name;
        
        /// <summary>
        /// Optional. Gets or sets the usage counter name.
        /// </summary>
        public UsageCounterName Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _unit;
        
        /// <summary>
        /// Optional. Gets or sets the usage unit name.
        /// </summary>
        public string Unit
        {
            get { return this._unit; }
            set { this._unit = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Usage class.
        /// </summary>
        public Usage()
        {
        }
    }
}
