// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Specification.Models
{
    /// <summary>
    /// Definition of the DSC Meta Configuration.
    /// </summary>
    public partial class DscMetaConfiguration
    {
        private string _actionAfterReboot;
        
        /// <summary>
        /// Optional. Gets or sets the ActionAfterReboot value of the meta
        /// configuration.
        /// </summary>
        public string ActionAfterReboot
        {
            get { return this._actionAfterReboot; }
            set { this._actionAfterReboot = value; }
        }
        
        private bool? _allowModuleOverwrite;
        
        /// <summary>
        /// Optional. Gets or sets the AllowModuleOverwrite value of the meta
        /// configuration.
        /// </summary>
        public bool? AllowModuleOverwrite
        {
            get { return this._allowModuleOverwrite; }
            set { this._allowModuleOverwrite = value; }
        }
        
        private string _certificateId;
        
        /// <summary>
        /// Optional. Gets or sets the CertificateId value of the meta
        /// configuration.
        /// </summary>
        public string CertificateId
        {
            get { return this._certificateId; }
            set { this._certificateId = value; }
        }
        
        private string _configurationMode;
        
        /// <summary>
        /// Optional. Gets or sets the ConfigurationMode value of the meta
        /// configuration.
        /// </summary>
        public string ConfigurationMode
        {
            get { return this._configurationMode; }
            set { this._configurationMode = value; }
        }
        
        private int? _configurationModeFrequencyMins;
        
        /// <summary>
        /// Optional. Gets or sets the ConfigurationModeFrequencyMins value of
        /// the meta configuration.
        /// </summary>
        public int? ConfigurationModeFrequencyMins
        {
            get { return this._configurationModeFrequencyMins; }
            set { this._configurationModeFrequencyMins = value; }
        }
        
        private bool? _rebootNodeIfNeeded;
        
        /// <summary>
        /// Optional. Gets or sets the RebootNodeIfNeeded value of the meta
        /// configuration.
        /// </summary>
        public bool? RebootNodeIfNeeded
        {
            get { return this._rebootNodeIfNeeded; }
            set { this._rebootNodeIfNeeded = value; }
        }
        
        private int? _refreshFrequencyMins;
        
        /// <summary>
        /// Optional. Gets or sets the RefreshFrequencyMins value of the meta
        /// configuration.
        /// </summary>
        public int? RefreshFrequencyMins
        {
            get { return this._refreshFrequencyMins; }
            set { this._refreshFrequencyMins = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DscMetaConfiguration class.
        /// </summary>
        public DscMetaConfiguration()
        {
        }
    }
}
