// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Specification.Models
{
    /// <summary>
    /// Definition of the dsc node report error type.
    /// </summary>
    public partial class DscReportError
    {
        private string _errorCode;
        
        /// <summary>
        /// Optional. Gets or sets the error code.
        /// </summary>
        public string ErrorCode
        {
            get { return this._errorCode; }
            set { this._errorCode = value; }
        }
        
        private string _errorDetails;
        
        /// <summary>
        /// Optional. Gets or sets the error details.
        /// </summary>
        public string ErrorDetails
        {
            get { return this._errorDetails; }
            set { this._errorDetails = value; }
        }
        
        private string _errorMessage;
        
        /// <summary>
        /// Optional. Gets or sets the error message.
        /// </summary>
        public string ErrorMessage
        {
            get { return this._errorMessage; }
            set { this._errorMessage = value; }
        }
        
        private string _errorSource;
        
        /// <summary>
        /// Optional. Gets or sets the source of the error.
        /// </summary>
        public string ErrorSource
        {
            get { return this._errorSource; }
            set { this._errorSource = value; }
        }
        
        private string _locale;
        
        /// <summary>
        /// Optional. Gets or sets the locale of the error.
        /// </summary>
        public string Locale
        {
            get { return this._locale; }
            set { this._locale = value; }
        }
        
        private string _resourceId;
        
        /// <summary>
        /// Optional. Gets or sets the resource ID which generated the error.
        /// </summary>
        public string ResourceId
        {
            get { return this._resourceId; }
            set { this._resourceId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DscReportError class.
        /// </summary>
        public DscReportError()
        {
        }
    }
}
