// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of a AzureIaaSVMRecoveryInputsCSMObject Info object.
    /// </summary>
    public partial class AzureIaaSVMRecoveryInputsCSMObject : CSMBaseObject
    {
        private string _affinityGroup;
        
        /// <summary>
        /// Optional. affinityGroup of AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public string AffinityGroup
        {
            get { return this._affinityGroup; }
            set { this._affinityGroup = value; }
        }
        
        private string _cloudServiceName;
        
        /// <summary>
        /// Optional. cloudServiceName of AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public string CloudServiceName
        {
            get { return this._cloudServiceName; }
            set { this._cloudServiceName = value; }
        }
        
        private bool _continueProtection;
        
        /// <summary>
        /// Optional. ContinueProtection of AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public bool ContinueProtection
        {
            get { return this._continueProtection; }
            set { this._continueProtection = value; }
        }
        
        private bool _createNewCloudService;
        
        /// <summary>
        /// Optional. createNewCloudService of
        /// AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public bool CreateNewCloudService
        {
            get { return this._createNewCloudService; }
            set { this._createNewCloudService = value; }
        }
        
        private string _inputStorageAccountName;
        
        /// <summary>
        /// Required. inputStorageAccountName of
        /// AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public string InputStorageAccountName
        {
            get { return this._inputStorageAccountName; }
            set { this._inputStorageAccountName = value; }
        }
        
        private string _region;
        
        /// <summary>
        /// Required. region of AzureIaaSVMRecoveryInputsObject.
        /// </summary>
        public string Region
        {
            get { return this._region; }
            set { this._region = value; }
        }
        
        private string _subNetName;
        
        /// <summary>
        /// Optional. subNetName of AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public string SubNetName
        {
            get { return this._subNetName; }
            set { this._subNetName = value; }
        }
        
        private string _targetVNet;
        
        /// <summary>
        /// Optional. targetVNet of AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public string TargetVNet
        {
            get { return this._targetVNet; }
            set { this._targetVNet = value; }
        }
        
        private string _vmName;
        
        /// <summary>
        /// Optional. vmName of AzureIaaSVMRecoveryInputsCSMObject.
        /// </summary>
        public string VmName
        {
            get { return this._vmName; }
            set { this._vmName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureIaaSVMRecoveryInputsCSMObject class.
        /// </summary>
        public AzureIaaSVMRecoveryInputsCSMObject()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureIaaSVMRecoveryInputsCSMObject class with required arguments.
        /// </summary>
        public AzureIaaSVMRecoveryInputsCSMObject(string region, string inputStorageAccountName)
            : this()
        {
            if (region == null)
            {
                throw new ArgumentNullException("region");
            }
            if (inputStorageAccountName == null)
            {
                throw new ArgumentNullException("inputStorageAccountName");
            }
            this.Region = region;
            this.InputStorageAccountName = inputStorageAccountName;
        }
    }
}
