// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of a CSMAddProtectionPolicyRequestProperties object.
    /// </summary>
    public partial class CSMAddProtectionPolicyRequestProperties
    {
        private CSMBackupSchedule _backupSchedule;
        
        /// <summary>
        /// Optional. Backup Schedule of ProtectionPolicy.
        /// </summary>
        public CSMBackupSchedule BackupSchedule
        {
            get { return this._backupSchedule; }
            set { this._backupSchedule = value; }
        }
        
        private CSMLongTermRetentionPolicy _ltrRetentionPolicy;
        
        /// <summary>
        /// Optional. Long Term Retention Policy.
        /// </summary>
        public CSMLongTermRetentionPolicy LtrRetentionPolicy
        {
            get { return this._ltrRetentionPolicy; }
            set { this._ltrRetentionPolicy = value; }
        }
        
        private string _policyName;
        
        /// <summary>
        /// Optional. Name of ProtectionPolicy.
        /// </summary>
        public string PolicyName
        {
            get { return this._policyName; }
            set { this._policyName = value; }
        }
        
        private CSMRetentionPolicy _retentionPolicy;
        
        /// <summary>
        /// Optional. Retention Policy
        /// </summary>
        public CSMRetentionPolicy RetentionPolicy
        {
            get { return this._retentionPolicy; }
            set { this._retentionPolicy = value; }
        }
        
        private string _workloadType;
        
        /// <summary>
        /// Optional. WorkloadType of ProtectionPolicy.
        /// </summary>
        public string WorkloadType
        {
            get { return this._workloadType; }
            set { this._workloadType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// CSMAddProtectionPolicyRequestProperties class.
        /// </summary>
        public CSMAddProtectionPolicyRequestProperties()
        {
        }
    }
}
