// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of CSM BackupSchedule object.
    /// </summary>
    public partial class CSMBackupSchedule
    {
        private string _backupType;
        
        /// <summary>
        /// Required. BackupType of ProtectionPolicy.
        /// </summary>
        public string BackupType
        {
            get { return this._backupType; }
            set { this._backupType = value; }
        }
        
        private string _scheduleRun;
        
        /// <summary>
        /// Required. ScheduleRun of ProtectionPolicy.
        /// </summary>
        public string ScheduleRun
        {
            get { return this._scheduleRun; }
            set { this._scheduleRun = value; }
        }
        
        private IList<DayOfWeek> _scheduleRunDays;
        
        /// <summary>
        /// Optional. ScheduleRunDays of ProtectionPolicy.
        /// </summary>
        public IList<DayOfWeek> ScheduleRunDays
        {
            get { return this._scheduleRunDays; }
            set { this._scheduleRunDays = value; }
        }
        
        private IList<DateTime> _scheduleRunTimes;
        
        /// <summary>
        /// Required. ScheduleRunTimes of ProtectionPolicy.
        /// </summary>
        public IList<DateTime> ScheduleRunTimes
        {
            get { return this._scheduleRunTimes; }
            set { this._scheduleRunTimes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMBackupSchedule class.
        /// </summary>
        public CSMBackupSchedule()
        {
            this.ScheduleRunDays = new List<DayOfWeek>();
            this.ScheduleRunTimes = new List<DateTime>();
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMBackupSchedule class with
        /// required arguments.
        /// </summary>
        public CSMBackupSchedule(string backupType, string scheduleRun, IList<DateTime> scheduleRunTimes)
            : this()
        {
            if (backupType == null)
            {
                throw new ArgumentNullException("backupType");
            }
            if (scheduleRun == null)
            {
                throw new ArgumentNullException("scheduleRun");
            }
            if (scheduleRunTimes == null)
            {
                throw new ArgumentNullException("scheduleRunTimes");
            }
            this.BackupType = backupType;
            this.ScheduleRun = scheduleRun;
            this.ScheduleRunTimes = scheduleRunTimes;
        }
    }
}
