// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// Class that holds job details
    /// </summary>
    public partial class CSMJobDetailedProperties : CSMJobProperties
    {
        private string _dynamicErrorMessage;
        
        /// <summary>
        /// Optional. Error message composed specifically for this job instance
        /// </summary>
        public string DynamicErrorMessage
        {
            get { return this._dynamicErrorMessage; }
            set { this._dynamicErrorMessage = value; }
        }
        
        private double? _progressPercentage;
        
        /// <summary>
        /// Optional. Field that indicates progress of the job
        /// </summary>
        public double? ProgressPercentage
        {
            get { return this._progressPercentage; }
            set { this._progressPercentage = value; }
        }
        
        private IDictionary<string, string> _propertyBag;
        
        /// <summary>
        /// Optional. Hash table of properties for this job
        /// </summary>
        public IDictionary<string, string> PropertyBag
        {
            get { return this._propertyBag; }
            set { this._propertyBag = value; }
        }
        
        private IList<CSMJobTaskDetails> _tasksList;
        
        /// <summary>
        /// Optional. List of subtasks for this job
        /// </summary>
        public IList<CSMJobTaskDetails> TasksList
        {
            get { return this._tasksList; }
            set { this._tasksList = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMJobDetailedProperties class.
        /// </summary>
        public CSMJobDetailedProperties()
        {
            this.PropertyBag = new LazyDictionary<string, string>();
            this.TasksList = new LazyList<CSMJobTaskDetails>();
        }
    }
}
