// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// Definition of error details in a job
    /// </summary>
    public partial class CSMJobErrorInfo
    {
        private int _errorCode;
        
        /// <summary>
        /// Required. Error code for the job
        /// </summary>
        public int ErrorCode
        {
            get { return this._errorCode; }
            set { this._errorCode = value; }
        }
        
        private string _errorString;
        
        /// <summary>
        /// Optional. Error message
        /// </summary>
        public string ErrorString
        {
            get { return this._errorString; }
            set { this._errorString = value; }
        }
        
        private string _errorTitle;
        
        /// <summary>
        /// Optional. Title of the error
        /// </summary>
        public string ErrorTitle
        {
            get { return this._errorTitle; }
            set { this._errorTitle = value; }
        }
        
        private IList<string> _recommendations;
        
        /// <summary>
        /// Optional. Recommendations for this particular error
        /// </summary>
        public IList<string> Recommendations
        {
            get { return this._recommendations; }
            set { this._recommendations = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMJobErrorInfo class.
        /// </summary>
        public CSMJobErrorInfo()
        {
            this.Recommendations = new LazyList<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMJobErrorInfo class with
        /// required arguments.
        /// </summary>
        public CSMJobErrorInfo(int errorCode)
            : this()
        {
            this.ErrorCode = errorCode;
        }
    }
}
