// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// Definition of CSMJobProperties
    /// </summary>
    public partial class CSMJobProperties
    {
        private IList<JobSupportedAction> _actionsInfo;
        
        /// <summary>
        /// Required. Type of the workload on which this job is running
        /// </summary>
        public IList<JobSupportedAction> ActionsInfo
        {
            get { return this._actionsInfo; }
            set { this._actionsInfo = value; }
        }
        
        private TimeSpan _duration;
        
        /// <summary>
        /// Required. Type of the workload on which this job is running
        /// </summary>
        public TimeSpan Duration
        {
            get { return this._duration; }
            set { this._duration = value; }
        }
        
        private System.DateTime? _endTimestamp;
        
        /// <summary>
        /// Optional. Type of the workload on which this job is running
        /// </summary>
        public System.DateTime? EndTimestamp
        {
            get { return this._endTimestamp; }
            set { this._endTimestamp = value; }
        }
        
        private string _entityFriendlyName;
        
        /// <summary>
        /// Required. Type of the workload on which this job is running
        /// </summary>
        public string EntityFriendlyName
        {
            get { return this._entityFriendlyName; }
            set { this._entityFriendlyName = value; }
        }
        
        private IList<CSMJobErrorInfo> _errorDetails;
        
        /// <summary>
        /// Optional. Type of the workload on which this job is running
        /// </summary>
        public IList<CSMJobErrorInfo> ErrorDetails
        {
            get { return this._errorDetails; }
            set { this._errorDetails = value; }
        }
        
        private string _operation;
        
        /// <summary>
        /// Required. Type of the workload on which this job is running
        /// </summary>
        public string Operation
        {
            get { return this._operation; }
            set { this._operation = value; }
        }
        
        private DateTime _startTimestamp;
        
        /// <summary>
        /// Required. Type of the workload on which this job is running
        /// </summary>
        public DateTime StartTimestamp
        {
            get { return this._startTimestamp; }
            set { this._startTimestamp = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Required. Type of the workload on which this job is running
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private string _workloadType;
        
        /// <summary>
        /// Required. Type of the workload on which this job is running
        /// </summary>
        public string WorkloadType
        {
            get { return this._workloadType; }
            set { this._workloadType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMJobProperties class.
        /// </summary>
        public CSMJobProperties()
        {
            this.ActionsInfo = new LazyList<JobSupportedAction>();
            this.ErrorDetails = new LazyList<CSMJobErrorInfo>();
        }
    }
}
