// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of class that represents job query parameters.
    /// </summary>
    public partial class CSMJobQueryObject : CSMQueryObject
    {
        private string _endTime;
        
        /// <summary>
        /// Optional. EndTime of time range filter.
        /// </summary>
        public string EndTime
        {
            get { return this._endTime; }
            set { this._endTime = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Name of the  job. (ID)
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _operation;
        
        /// <summary>
        /// Optional. Operation type of job.
        /// </summary>
        public string Operation
        {
            get { return this._operation; }
            set { this._operation = value; }
        }
        
        private string _startTime;
        
        /// <summary>
        /// Optional. Start time of time range filter.
        /// </summary>
        public string StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Status of job.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private string _workloadType;
        
        /// <summary>
        /// Optional. Type of workload of job.
        /// </summary>
        public string WorkloadType
        {
            get { return this._workloadType; }
            set { this._workloadType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMJobQueryObject class.
        /// </summary>
        public CSMJobQueryObject()
        {
        }
    }
}
