// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of a CSMMonthlyRetentionSchedule object.
    /// </summary>
    public partial class CSMMonthlyRetentionSchedule : CSMRetentionScheduleBase
    {
        private CSMDailyRetentionFormat _retentionScheduleDaily;
        
        /// <summary>
        /// Optional. Daily Retention Format for monthly retention policy.
        /// </summary>
        public CSMDailyRetentionFormat RetentionScheduleDaily
        {
            get { return this._retentionScheduleDaily; }
            set { this._retentionScheduleDaily = value; }
        }
        
        private RetentionScheduleFormat _retentionScheduleType;
        
        /// <summary>
        /// Optional. Retention ScheduleType for monthly retention policy.
        /// </summary>
        public RetentionScheduleFormat RetentionScheduleType
        {
            get { return this._retentionScheduleType; }
            set { this._retentionScheduleType = value; }
        }
        
        private CSMWeeklyRetentionFormat _retentionScheduleWeekly;
        
        /// <summary>
        /// Optional. Weekly Retention format for monthly retention policy.
        /// </summary>
        public CSMWeeklyRetentionFormat RetentionScheduleWeekly
        {
            get { return this._retentionScheduleWeekly; }
            set { this._retentionScheduleWeekly = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMMonthlyRetentionSchedule class.
        /// </summary>
        public CSMMonthlyRetentionSchedule()
        {
        }
    }
}
