// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of CSMProtectedItemProperties.
    /// </summary>
    public partial class CSMProtectedItemProperties : CSMItemProperties
    {
        private string _lastBackupJobId;
        
        /// <summary>
        /// Optional. lastBackupJobId Properties
        /// </summary>
        public string LastBackupJobId
        {
            get { return this._lastBackupJobId; }
            set { this._lastBackupJobId = value; }
        }
        
        private string _lastBackupStatus;
        
        /// <summary>
        /// Optional. lastBackupStatus Properties
        /// </summary>
        public string LastBackupStatus
        {
            get { return this._lastBackupStatus; }
            set { this._lastBackupStatus = value; }
        }
        
        private System.DateTime? _lastBackupTime;
        
        /// <summary>
        /// Optional. lastBackupTime Properties
        /// </summary>
        public System.DateTime? LastBackupTime
        {
            get { return this._lastBackupTime; }
            set { this._lastBackupTime = value; }
        }
        
        private System.DateTime? _lastRecoveryPoint;
        
        /// <summary>
        /// Optional. lastRecoveryPoint Properties
        /// </summary>
        public System.DateTime? LastRecoveryPoint
        {
            get { return this._lastRecoveryPoint; }
            set { this._lastRecoveryPoint = value; }
        }
        
        private bool _policyInconsistent;
        
        /// <summary>
        /// Optional. policyInconsistent Properties
        /// </summary>
        public bool PolicyInconsistent
        {
            get { return this._policyInconsistent; }
            set { this._policyInconsistent = value; }
        }
        
        private string _protectionPolicyId;
        
        /// <summary>
        /// Optional. protectionPolicyId Properties
        /// </summary>
        public string ProtectionPolicyId
        {
            get { return this._protectionPolicyId; }
            set { this._protectionPolicyId = value; }
        }
        
        private string _protectionStatus;
        
        /// <summary>
        /// Optional. protectionStatus Properties
        /// </summary>
        public string ProtectionStatus
        {
            get { return this._protectionStatus; }
            set { this._protectionStatus = value; }
        }
        
        private int _recoveryPointsCount;
        
        /// <summary>
        /// Optional. recoveryPointsCount Properties
        /// </summary>
        public int RecoveryPointsCount
        {
            get { return this._recoveryPointsCount; }
            set { this._recoveryPointsCount = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMProtectedItemProperties class.
        /// </summary>
        public CSMProtectedItemProperties()
        {
        }
    }
}
