// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of CSMRestoreRequestProperties.
    /// </summary>
    public partial class CSMRestoreRequestProperties
    {
        private string _recoveryDSTypeSpecificInputs;
        
        /// <summary>
        /// Required. recoveryDSTypeSpecificInputs of
        /// CSMRestoreRequestProperties.
        /// </summary>
        public string RecoveryDSTypeSpecificInputs
        {
            get { return this._recoveryDSTypeSpecificInputs; }
            set { this._recoveryDSTypeSpecificInputs = value; }
        }
        
        private string _typeOfRecovery;
        
        /// <summary>
        /// Required. typeOfRecovery of CSMRestoreRequestProperties.
        /// </summary>
        public string TypeOfRecovery
        {
            get { return this._typeOfRecovery; }
            set { this._typeOfRecovery = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMRestoreRequestProperties class.
        /// </summary>
        public CSMRestoreRequestProperties()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the CSMRestoreRequestProperties class
        /// with required arguments.
        /// </summary>
        public CSMRestoreRequestProperties(string typeOfRecovery, string recoveryDSTypeSpecificInputs)
            : this()
        {
            if (typeOfRecovery == null)
            {
                throw new ArgumentNullException("typeOfRecovery");
            }
            if (recoveryDSTypeSpecificInputs == null)
            {
                throw new ArgumentNullException("recoveryDSTypeSpecificInputs");
            }
            this.TypeOfRecovery = typeOfRecovery;
            this.RecoveryDSTypeSpecificInputs = recoveryDSTypeSpecificInputs;
        }
    }
}
