// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of a Management List Response.
    /// </summary>
    public partial class DataSourceResponse : ManagementBaseObject, IEnumerable<DataSourceInfo>
    {
        private IList<DataSourceInfo> _objects;
        
        /// <summary>
        /// Optional. The ID of the source Server.
        /// </summary>
        public IList<DataSourceInfo> Objects
        {
            get { return this._objects; }
            set { this._objects = value; }
        }
        
        private int _resultCount;
        
        /// <summary>
        /// Optional. The ID of the source Server.
        /// </summary>
        public int ResultCount
        {
            get { return this._resultCount; }
            set { this._resultCount = value; }
        }
        
        private string _skiptoken;
        
        /// <summary>
        /// Optional. The ID of the source Server.
        /// </summary>
        public string Skiptoken
        {
            get { return this._skiptoken; }
            set { this._skiptoken = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DataSourceResponse class.
        /// </summary>
        public DataSourceResponse()
        {
            this.Objects = new LazyList<DataSourceInfo>();
        }
        
        /// <summary>
        /// Gets the sequence of Objects.
        /// </summary>
        public IEnumerator<DataSourceInfo> GetEnumerator()
        {
            return this.Objects.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Objects.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
