// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of a Protectable Object Info.
    /// </summary>
    public partial class ProtectableObjectInfo : ManagementResponseObject
    {
        private string _containerFriendlyName;
        
        /// <summary>
        /// Optional. ContainerFriendlyName of ProtectableObject.
        /// </summary>
        public string ContainerFriendlyName
        {
            get { return this._containerFriendlyName; }
            set { this._containerFriendlyName = value; }
        }
        
        private string _containerName;
        
        /// <summary>
        /// Optional. ContainerName of ProtectableObject.
        /// </summary>
        public string ContainerName
        {
            get { return this._containerName; }
            set { this._containerName = value; }
        }
        
        private string _containerType;
        
        /// <summary>
        /// Optional. ContainerType of ProtectableObject.
        /// </summary>
        public string ContainerType
        {
            get { return this._containerType; }
            set { this._containerType = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. FriendlyName of ProtectableObject.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _parentContainerFriendlyName;
        
        /// <summary>
        /// Optional. ParentContainerFriendlyName of ProtectableObject.
        /// </summary>
        public string ParentContainerFriendlyName
        {
            get { return this._parentContainerFriendlyName; }
            set { this._parentContainerFriendlyName = value; }
        }
        
        private string _parentContainerName;
        
        /// <summary>
        /// Optional. ParentContainerName of ProtectableObject.
        /// </summary>
        public string ParentContainerName
        {
            get { return this._parentContainerName; }
            set { this._parentContainerName = value; }
        }
        
        private string _parentContainerType;
        
        /// <summary>
        /// Optional. ParentContainerType of ProtectableObject.
        /// </summary>
        public string ParentContainerType
        {
            get { return this._parentContainerType; }
            set { this._parentContainerType = value; }
        }
        
        private string _protectionStatus;
        
        /// <summary>
        /// Optional. ProtectionStatus of ProtectableObject.
        /// </summary>
        public string ProtectionStatus
        {
            get { return this._protectionStatus; }
            set { this._protectionStatus = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. Type of ProtectableObject.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectableObjectInfo class.
        /// </summary>
        public ProtectableObjectInfo()
        {
        }
    }
}
