// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.BackupServices.Models;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The definition of a RemoveProtectionRequestInput Object.
    /// </summary>
    public partial class RemoveProtectionRequestInput : ManagementBaseObject
    {
        private string _comments;
        
        /// <summary>
        /// Optional. Comments  for disabling protection.
        /// </summary>
        public string Comments
        {
            get { return this._comments; }
            set { this._comments = value; }
        }
        
        private string _reason;
        
        /// <summary>
        /// Optional. Reason for disabling protection.
        /// </summary>
        public string Reason
        {
            get { return this._reason; }
            set { this._reason = value; }
        }
        
        private string _removeProtectionOption;
        
        /// <summary>
        /// Required. ProtectableObjects  for disabling protection.
        /// </summary>
        public string RemoveProtectionOption
        {
            get { return this._removeProtectionOption; }
            set { this._removeProtectionOption = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RemoveProtectionRequestInput
        /// class.
        /// </summary>
        public RemoveProtectionRequestInput()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the RemoveProtectionRequestInput
        /// class with required arguments.
        /// </summary>
        public RemoveProtectionRequestInput(string removeProtectionOption)
            : this()
        {
            if (removeProtectionOption == null)
            {
                throw new ArgumentNullException("removeProtectionOption");
            }
            this.RemoveProtectionOption = removeProtectionOption;
        }
    }
}
