// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.BackupServices.Models
{
    /// <summary>
    /// The resource certificate and ACS details.
    /// </summary>
    public partial class ResourceCertificateAndACSDetails
    {
        private string _certificate;
        
        /// <summary>
        /// Optional. Gets or sets the base64 encoded certificate raw data
        /// string.
        /// </summary>
        public string Certificate
        {
            get { return this._certificate; }
            set { this._certificate = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Certificate friendlyname.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _globalAcsHostName;
        
        /// <summary>
        /// Optional. Acs mgmt host name to connect to.
        /// </summary>
        public string GlobalAcsHostName
        {
            get { return this._globalAcsHostName; }
            set { this._globalAcsHostName = value; }
        }
        
        private string _globalAcsNamespace;
        
        /// <summary>
        /// Optional. ACS namespace name - tenant for our service.
        /// </summary>
        public string GlobalAcsNamespace
        {
            get { return this._globalAcsNamespace; }
            set { this._globalAcsNamespace = value; }
        }
        
        private string _globalAcsRPRealm;
        
        /// <summary>
        /// Optional. Global ACS namespace RP realm.
        /// </summary>
        public string GlobalAcsRPRealm
        {
            get { return this._globalAcsRPRealm; }
            set { this._globalAcsRPRealm = value; }
        }
        
        private string _issuer;
        
        /// <summary>
        /// Optional. Certificate issuer.
        /// </summary>
        public string Issuer
        {
            get { return this._issuer; }
            set { this._issuer = value; }
        }
        
        private long _resourceId;
        
        /// <summary>
        /// Optional. Resource ID.
        /// </summary>
        public long ResourceId
        {
            get { return this._resourceId; }
            set { this._resourceId = value; }
        }
        
        private string _subject;
        
        /// <summary>
        /// Optional. Certificate Subject Name.
        /// </summary>
        public string Subject
        {
            get { return this._subject; }
            set { this._subject = value; }
        }
        
        private string _thumbprint;
        
        /// <summary>
        /// Optional. Certificate thumbrprint.
        /// </summary>
        public string Thumbprint
        {
            get { return this._thumbprint; }
            set { this._thumbprint = value; }
        }
        
        private DateTime _validFrom;
        
        /// <summary>
        /// Optional. Certificate Validity start Date time.
        /// </summary>
        public DateTime ValidFrom
        {
            get { return this._validFrom; }
            set { this._validFrom = value; }
        }
        
        private DateTime _validTo;
        
        /// <summary>
        /// Optional. Certificate Validity End Date time.
        /// </summary>
        public DateTime ValidTo
        {
            get { return this._validTo; }
            set { this._validTo = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ResourceCertificateAndACSDetails
        /// class.
        /// </summary>
        public ResourceCertificateAndACSDetails()
        {
        }
    }
}
