// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;
using Microsoft.AzureStack.Management;

namespace Microsoft.AzureStack.Management
{
    public partial interface IAzureStackClient : IDisposable
    {
        /// <summary>
        /// Apiversion of the endpoint
        /// </summary>
        string ApiVersion
        {
            get; set; 
        }
        
        /// <summary>
        /// Resource Manager endpoint
        /// </summary>
        Uri BaseUri
        {
            get; set; 
        }
        
        /// <summary>
        /// Credentials to access resource manager endpoint
        /// </summary>
        SubscriptionCloudCredentials Credentials
        {
            get; set; 
        }
        
        /// <summary>
        /// Operations on the curation items  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        ICurationOperations Curation
        {
            get; 
        }
        
        /// <summary>
        /// Operations for extensions metadata.  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IExtensionMetadataOperations ExtensionsMetadata
        {
            get; 
        }
        
        /// <summary>
        /// Gallery item operations.  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IGalleryItemOperations GalleryItem
        {
            get; 
        }
        
        /// <summary>
        /// Managed locations operations for admin.  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IManagedLocationOperations ManagedLocations
        {
            get; 
        }
        
        /// <summary>
        /// Administrator Operations on the offer  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IManagedOfferOperations ManagedOffers
        {
            get; 
        }
        
        /// <summary>
        /// Administrator operations on the plan  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IManagedPlanOperations ManagedPlans
        {
            get; 
        }
        
        /// <summary>
        /// Administrator Operations on the subscription  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IManagedSubscriptionOperations ManagedSubscriptions
        {
            get; 
        }
        
        /// <summary>
        /// Operations on the offer  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IOfferOperations Offers
        {
            get; 
        }
        
        /// <summary>
        /// Operations on the plan  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IPlanOperations Plans
        {
            get; 
        }
        
        /// <summary>
        /// Resource provider manifest registration operations  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IProviderRegistrationOperations ProviderRegistrations
        {
            get; 
        }
        
        /// <summary>
        /// Public gallery items operations.  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IPublicGalleryItemOperations PublicGalleryItem
        {
            get; 
        }
        
        /// <summary>
        /// Operations on the resource group
        /// </summary>
        IResourceGroupOperations ResourceGroups
        {
            get; 
        }
        
        /// <summary>
        /// Operations on the subscription as a tenant  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        ISubscriptionOperations Subscriptions
        {
            get; 
        }
        
        /// <summary>
        /// Usage connection operations  (see
        /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
        /// more information)
        /// </summary>
        IUsageConnectionsOperations UsageConnections
        {
            get; 
        }
    }
}
