// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.AzureStack.Management.Models;

namespace Microsoft.AzureStack.Management
{
    /// <summary>
    /// Managed locations operations for admin.  (see
    /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
    /// more information)
    /// </summary>
    public partial interface IManagedLocationOperations
    {
        /// <summary>
        /// Create / Update the location.
        /// </summary>
        /// <param name='parameters'>
        /// Location properties
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The location update result.
        /// </returns>
        Task<ManagedLocationCreateOrUpdateResult> CreateOrUpdateAsync(ManagedLocationCreateOrUpdateParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Delete a location.
        /// </summary>
        /// <param name='locationName'>
        /// Name of location to delete.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<AzureOperationResponse> DeleteAsync(string locationName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Get the location.
        /// </summary>
        /// <param name='locationName'>
        /// The location name.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Location get result.
        /// </returns>
        Task<ManagedLocationGetResult> GetAsync(string locationName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Get locations under subscription.
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The location list result.
        /// </returns>
        Task<ManagedLocationListResult> ListAsync(CancellationToken cancellationToken);
        
        /// <summary>
        /// Gets locations with the next link.
        /// </summary>
        /// <param name='nextLink'>
        /// The url to get the next set of results.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The location list result.
        /// </returns>
        Task<ManagedLocationListResult> ListNextAsync(string nextLink, CancellationToken cancellationToken);
    }
}
