// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.AzureStack.Management.Models;

namespace Microsoft.AzureStack.Management
{
    /// <summary>
    /// Operations on the subscription as a tenant  (see
    /// http://msdn.microsoft.com/en-us/library/windowsazure/XXXX.aspx for
    /// more information)
    /// </summary>
    public partial interface ISubscriptionOperations
    {
        /// <summary>
        /// Creates or updates the subscription as a tenant
        /// </summary>
        /// <param name='parameters'>
        /// Parameters for creating or updating the subscription
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Subscription definition object after create or update operation
        /// </returns>
        Task<SubscriptionCreateOrUpdateResult> CreateOrUpdateAsync(SubscriptionCreateOrUpdateParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Delete operation of the subscription
        /// </summary>
        /// <param name='subscriptionId'>
        /// Subscription Id
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        Task<AzureOperationResponse> DeleteAsync(string subscriptionId, CancellationToken cancellationToken);
        
        /// <summary>
        /// Gets the subscription given the id
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Result of subscription get operation
        /// </returns>
        Task<SubscriptionGetResult> GetAsync(string subscriptionId, CancellationToken cancellationToken);
        
        /// <summary>
        /// Lists the subscriptions under the user account
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Result of subscription list operation
        /// </returns>
        Task<SubscriptionListResult> ListAsync(bool includeDetails, CancellationToken cancellationToken);
        
        /// <summary>
        /// Lists the next set of subscriptions
        /// </summary>
        /// <param name='nextLink'>
        /// URL to get the next set of results
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Result of subscription list operation
        /// </returns>
        Task<SubscriptionListResult> ListNextAsync(string nextLink, CancellationToken cancellationToken);
    }
}
