// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.AzureStack.Management.Models
{
    /// <summary>
    /// A plan represents a package of quotas and capabilities that are offered
    /// tenants
    /// </summary>
    public partial class AdminPlanPropertiesDefinition
    {
        private string _description;
        
        /// <summary>
        /// Optional. Description of the plan
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private string _displayName;
        
        /// <summary>
        /// Optional. Display name of the plan
        /// </summary>
        public string DisplayName
        {
            get { return this._displayName; }
            set { this._displayName = value; }
        }
        
        private string _externalReferenceId;
        
        /// <summary>
        /// Optional. The external reference identifier
        /// </summary>
        public string ExternalReferenceId
        {
            get { return this._externalReferenceId; }
            set { this._externalReferenceId = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Name of the plan
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private IList<string> _quotaIds;
        
        /// <summary>
        /// Optional. Quota Ids associated with the plan
        /// </summary>
        public IList<string> QuotaIds
        {
            get { return this._quotaIds; }
            set { this._quotaIds = value; }
        }
        
        private IList<string> _skuIds;
        
        /// <summary>
        /// Optional. SKU Ids associated with the plan
        /// </summary>
        public IList<string> SkuIds
        {
            get { return this._skuIds; }
            set { this._skuIds = value; }
        }
        
        private int? _subscriptionCount;
        
        /// <summary>
        /// Optional. The number of subscriptions associated with the plan
        /// </summary>
        public int? SubscriptionCount
        {
            get { return this._subscriptionCount; }
            set { this._subscriptionCount = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AdminPlanPropertiesDefinition
        /// class.
        /// </summary>
        public AdminPlanPropertiesDefinition()
        {
            this.QuotaIds = new LazyList<string>();
            this.SkuIds = new LazyList<string>();
        }
    }
}
