// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.AzureStack.Management.Models
{
    /// <summary>
    /// Definition template.
    /// </summary>
    public partial class DefinitionTemplates
    {
        private string _defaultDeploymentTemplateId;
        
        /// <summary>
        /// Optional. Default deployment template identity.
        /// </summary>
        public string DefaultDeploymentTemplateId
        {
            get { return this._defaultDeploymentTemplateId; }
            set { this._defaultDeploymentTemplateId = value; }
        }
        
        private IDictionary<string, string> _deploymentFragmentFileUris;
        
        /// <summary>
        /// Optional. Deployment fragment file uris.
        /// </summary>
        public IDictionary<string, string> DeploymentFragmentFileUris
        {
            get { return this._deploymentFragmentFileUris; }
            set { this._deploymentFragmentFileUris = value; }
        }
        
        private IDictionary<string, string> _deploymentTemplateFileUris;
        
        /// <summary>
        /// Optional. Deployment template file uris.
        /// </summary>
        public IDictionary<string, string> DeploymentTemplateFileUris
        {
            get { return this._deploymentTemplateFileUris; }
            set { this._deploymentTemplateFileUris = value; }
        }
        
        private string _uiDefinitionFileUri;
        
        /// <summary>
        /// Optional. UiDefinition file uri.
        /// </summary>
        public string UiDefinitionFileUri
        {
            get { return this._uiDefinitionFileUri; }
            set { this._uiDefinitionFileUri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DefinitionTemplates class.
        /// </summary>
        public DefinitionTemplates()
        {
            this.DeploymentFragmentFileUris = new LazyDictionary<string, string>();
            this.DeploymentTemplateFileUris = new LazyDictionary<string, string>();
        }
    }
}
