// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.AzureStack.Management.Models;

namespace Microsoft.AzureStack.Management.Models
{
    /// <summary>
    /// Gallery item model.
    /// </summary>
    public partial class GalleryItem
    {
        private IDictionary<string, string> _additionalProperties;
        
        /// <summary>
        /// Optional. Additional properties.
        /// </summary>
        public IDictionary<string, string> AdditionalProperties
        {
            get { return this._additionalProperties; }
            set { this._additionalProperties = value; }
        }
        
        private IList<string> _categoryIds;
        
        /// <summary>
        /// Optional. Category identities.
        /// </summary>
        public IList<string> CategoryIds
        {
            get { return this._categoryIds; }
            set { this._categoryIds = value; }
        }
        
        private DefinitionTemplates _definitionTemplates;
        
        /// <summary>
        /// Optional. Definition templates.
        /// </summary>
        public DefinitionTemplates DefinitionTemplates
        {
            get { return this._definitionTemplates; }
            set { this._definitionTemplates = value; }
        }
        
        private string _description;
        
        /// <summary>
        /// Optional. Description.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private IDictionary<IconKind, string> _iconFileUris;
        
        /// <summary>
        /// Optional. Icon file Uris.
        /// </summary>
        public IDictionary<IconKind, string> IconFileUris
        {
            get { return this._iconFileUris; }
            set { this._iconFileUris = value; }
        }
        
        private string _identity;
        
        /// <summary>
        /// Optional. Identity.
        /// </summary>
        public string Identity
        {
            get { return this._identity; }
            set { this._identity = value; }
        }
        
        private string _itemDisplayName;
        
        /// <summary>
        /// Optional. Item display name.
        /// </summary>
        public string ItemDisplayName
        {
            get { return this._itemDisplayName; }
            set { this._itemDisplayName = value; }
        }
        
        private string _itemName;
        
        /// <summary>
        /// Optional. Item name.
        /// </summary>
        public string ItemName
        {
            get { return this._itemName; }
            set { this._itemName = value; }
        }
        
        private IList<LinkProperties> _links;
        
        /// <summary>
        /// Optional. Links.
        /// </summary>
        public IList<LinkProperties> Links
        {
            get { return this._links; }
            set { this._links = value; }
        }
        
        private string _longSummary;
        
        /// <summary>
        /// Optional. Long summary.
        /// </summary>
        public string LongSummary
        {
            get { return this._longSummary; }
            set { this._longSummary = value; }
        }
        
        private string _publisher;
        
        /// <summary>
        /// Optional. Publisher.
        /// </summary>
        public string Publisher
        {
            get { return this._publisher; }
            set { this._publisher = value; }
        }
        
        private string _publisherDisplayName;
        
        /// <summary>
        /// Optional. Publisher display name.
        /// </summary>
        public string PublisherDisplayName
        {
            get { return this._publisherDisplayName; }
            set { this._publisherDisplayName = value; }
        }
        
        private string _resourceGroupName;
        
        /// <summary>
        /// Optional. Resource group name.
        /// </summary>
        public string ResourceGroupName
        {
            get { return this._resourceGroupName; }
            set { this._resourceGroupName = value; }
        }
        
        private IList<string> _screenshotUris;
        
        /// <summary>
        /// Optional. Screenshot Uris.
        /// </summary>
        public IList<string> ScreenshotUris
        {
            get { return this._screenshotUris; }
            set { this._screenshotUris = value; }
        }
        
        private string _summary;
        
        /// <summary>
        /// Optional. Summary.
        /// </summary>
        public string Summary
        {
            get { return this._summary; }
            set { this._summary = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Version.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the GalleryItem class.
        /// </summary>
        public GalleryItem()
        {
            this.AdditionalProperties = new LazyDictionary<string, string>();
            this.CategoryIds = new LazyList<string>();
            this.IconFileUris = new LazyDictionary<IconKind, string>();
            this.Links = new LazyList<LinkProperties>();
            this.ScreenshotUris = new LazyList<string>();
        }
    }
}
