// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.AzureStack.Management.Models;

namespace Microsoft.AzureStack.Management.Models
{
    /// <summary>
    /// Administratior view of offer parameters
    /// </summary>
    public partial class ManagedOfferCreateOrUpdateParameters
    {
        private AdminOfferModel _offer;
        
        /// <summary>
        /// Required. Administrator view of offer properties
        /// </summary>
        public AdminOfferModel Offer
        {
            get { return this._offer; }
            set { this._offer = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ManagedOfferCreateOrUpdateParameters class.
        /// </summary>
        public ManagedOfferCreateOrUpdateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ManagedOfferCreateOrUpdateParameters class with required arguments.
        /// </summary>
        public ManagedOfferCreateOrUpdateParameters(AdminOfferModel offer)
            : this()
        {
            if (offer == null)
            {
                throw new ArgumentNullException("offer");
            }
            this.Offer = offer;
        }
    }
}
