// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.AzureStack.Management.Models;

namespace Microsoft.AzureStack.Management.Models
{
    /// <summary>
    /// The resource type definition.
    /// </summary>
    public partial class ResourceType
    {
        private IList<string> _allowedUnauthorizedActions;
        
        /// <summary>
        /// Optional. Gets or sets the allowed unauthorized actions.
        /// </summary>
        public IList<string> AllowedUnauthorizedActions
        {
            get { return this._allowedUnauthorizedActions; }
            set { this._allowedUnauthorizedActions = value; }
        }
        
        private IList<ResourceProviderEndpoint> _endpoints;
        
        /// <summary>
        /// Optional. Gets or sets the resource provider endpoints.
        /// </summary>
        public IList<ResourceProviderEndpoint> Endpoints
        {
            get { return this._endpoints; }
            set { this._endpoints = value; }
        }
        
        private MarketplaceType _marketplaceType;
        
        /// <summary>
        /// Optional. Gets or sets the resource type behavior in the
        /// marketplace.
        /// </summary>
        public MarketplaceType MarketplaceType
        {
            get { return this._marketplaceType; }
            set { this._marketplaceType = value; }
        }
        
        private IList<string> _meteredResourceIds;
        
        /// <summary>
        /// Optional. Gets or sets the metered resource ids.
        /// </summary>
        public IList<string> MeteredResourceIds
        {
            get { return this._meteredResourceIds; }
            set { this._meteredResourceIds = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the resource type name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private ResourceDeletionPolicy _resourceDeletionPolicy;
        
        /// <summary>
        /// Optional. Gets or sets the resource deletion policy.
        /// </summary>
        public ResourceDeletionPolicy ResourceDeletionPolicy
        {
            get { return this._resourceDeletionPolicy; }
            set { this._resourceDeletionPolicy = value; }
        }
        
        private RoutingType _routingType;
        
        /// <summary>
        /// Optional. Gets or sets the routing type of the resource
        /// </summary>
        public RoutingType RoutingType
        {
            get { return this._routingType; }
            set { this._routingType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ResourceType class.
        /// </summary>
        public ResourceType()
        {
            this.AllowedUnauthorizedActions = new LazyList<string>();
            this.Endpoints = new LazyList<ResourceProviderEndpoint>();
            this.MeteredResourceIds = new LazyList<string>();
        }
    }
}
