// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.AzureStack.Management.Models;

namespace Microsoft.AzureStack.Management.Models
{
    /// <summary>
    /// The subscription definition object.
    /// </summary>
    public partial class SubscriptionDefinition
    {
        private string _displayName;
        
        /// <summary>
        /// Optional. Gets or sets the subscription name.
        /// </summary>
        public string DisplayName
        {
            get { return this._displayName; }
            set { this._displayName = value; }
        }
        
        private string _externalReferenceId;
        
        /// <summary>
        /// Optional. Gets or sets the External Reference Id
        /// </summary>
        public string ExternalReferenceId
        {
            get { return this._externalReferenceId; }
            set { this._externalReferenceId = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Optional. Gets or sets the fully qualified identifier
        /// (/subscriptions/{subscriptionId}).
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _offerId;
        
        /// <summary>
        /// Optional. Gets or sets the identifier of the offer under the scope
        /// of a delegated provider.
        /// </summary>
        public string OfferId
        {
            get { return this._offerId; }
            set { this._offerId = value; }
        }
        
        private Microsoft.AzureStack.Management.Models.SubscriptionState? _state;
        
        /// <summary>
        /// Optional. Gets or sets the subscription state.
        /// </summary>
        public Microsoft.AzureStack.Management.Models.SubscriptionState? State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _subscriptionId;
        
        /// <summary>
        /// Optional. Gets or sets the subscription Guid string.
        /// </summary>
        public string SubscriptionId
        {
            get { return this._subscriptionId; }
            set { this._subscriptionId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SubscriptionDefinition class.
        /// </summary>
        public SubscriptionDefinition()
        {
        }
    }
}
