// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.AzureStack.Management.Models
{
    /// <summary>
    /// Usage Connection Contract
    /// </summary>
    public partial class UsageConnection
    {
        private string _errorReportingQueue;
        
        /// <summary>
        /// Optional. Usage Error Reporting Queue
        /// </summary>
        public string ErrorReportingQueue
        {
            get { return this._errorReportingQueue; }
            set { this._errorReportingQueue = value; }
        }
        
        private string _errorReportingTable;
        
        /// <summary>
        /// Optional. Usage Error Reporting Table
        /// </summary>
        public string ErrorReportingTable
        {
            get { return this._errorReportingTable; }
            set { this._errorReportingTable = value; }
        }
        
        private string _providerLocation;
        
        /// <summary>
        /// Optional. Location of the provider
        /// </summary>
        public string ProviderLocation
        {
            get { return this._providerLocation; }
            set { this._providerLocation = value; }
        }
        
        private string _providerNamespace;
        
        /// <summary>
        /// Optional. Location of the provider
        /// </summary>
        public string ProviderNamespace
        {
            get { return this._providerNamespace; }
            set { this._providerNamespace = value; }
        }
        
        private string _usageReportingQueue;
        
        /// <summary>
        /// Optional. Usage Reporting Queue
        /// </summary>
        public string UsageReportingQueue
        {
            get { return this._usageReportingQueue; }
            set { this._usageReportingQueue = value; }
        }
        
        private string _usageReportingTable;
        
        /// <summary>
        /// Optional. Usage Data Reporting Table
        /// </summary>
        public string UsageReportingTable
        {
            get { return this._usageReportingTable; }
            set { this._usageReportingTable = value; }
        }
        
        private string _usageStorageConnectionString;
        
        /// <summary>
        /// Optional. Usage Storage Connection String
        /// </summary>
        public string UsageStorageConnectionString
        {
            get { return this._usageStorageConnectionString; }
            set { this._usageStorageConnectionString = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the UsageConnection class.
        /// </summary>
        public UsageConnection()
        {
        }
    }
}
