// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.AzureStack.Management;
using Microsoft.AzureStack.Management.Models;

namespace Microsoft.AzureStack.Management
{
    public static partial class PlanOperationsExtensions
    {
        /// <summary>
        /// Gets the plan for a given plan id
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.AzureStack.Management.IPlanOperations.
        /// </param>
        /// <param name='planId'>
        /// Required. Id of the plan
        /// </param>
        /// <returns>
        /// Resul of the plan get operation
        /// </returns>
        public static PlanGetResult Get(this IPlanOperations operations, string planId)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IPlanOperations)s).GetAsync(planId);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets the plan for a given plan id
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.AzureStack.Management.IPlanOperations.
        /// </param>
        /// <param name='planId'>
        /// Required. Id of the plan
        /// </param>
        /// <returns>
        /// Resul of the plan get operation
        /// </returns>
        public static Task<PlanGetResult> GetAsync(this IPlanOperations operations, string planId)
        {
            return operations.GetAsync(planId, CancellationToken.None);
        }
        
        /// <summary>
        /// Add on plans available for that subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.AzureStack.Management.IPlanOperations.
        /// </param>
        /// <returns>
        /// Plan list result.
        /// </returns>
        public static PlanListResult List(this IPlanOperations operations)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IPlanOperations)s).ListAsync();
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Add on plans available for that subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.AzureStack.Management.IPlanOperations.
        /// </param>
        /// <returns>
        /// Plan list result.
        /// </returns>
        public static Task<PlanListResult> ListAsync(this IPlanOperations operations)
        {
            return operations.ListAsync(CancellationToken.None);
        }
    }
}
