// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Azure;
using Microsoft.Azure.Management.Batch.Models;

namespace Microsoft.Azure.Management.Batch.Models
{
    /// <summary>
    /// Response to an ApplicationOperations.ListApplications request.
    /// </summary>
    public partial class ListApplicationsResponse : AzureOperationResponse
    {
        private IList<Application> _applications;
        
        /// <summary>
        /// Required. Gets or sets the list of applications.
        /// </summary>
        public IList<Application> Applications
        {
            get { return this._applications; }
            set { this._applications = value; }
        }
        
        private string _nextLink;
        
        /// <summary>
        /// Optional. Gets or sets the URL to get the next set of results.
        /// </summary>
        public string NextLink
        {
            get { return this._nextLink; }
            set { this._nextLink = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ListApplicationsResponse class.
        /// </summary>
        public ListApplicationsResponse()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ListApplicationsResponse class
        /// with required arguments.
        /// </summary>
        public ListApplicationsResponse(IList<Application> applications)
            : this()
        {
            if (applications == null)
            {
                throw new ArgumentNullException("applications");
            }
            this.Applications = applications;
        }
    }
}
