// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Batch.Models
{
    /// <summary>
    /// The current state of an application package.
    /// </summary>
    public enum PackageState
    {
        /// <summary>
        /// The application package has never been activated.
        /// </summary>
        Pending = 0,
        
        /// <summary>
        /// The application package is active and can be used by compute nodes.
        /// </summary>
        Active = 1,
        
        /// <summary>
        /// The service reported a state that is not recognized by this version
        /// of the Batch client.
        /// </summary>
        Unmapped = 2,
    }
}
