// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Batch;
using Microsoft.Azure.Management.Batch.Models;

namespace Microsoft.Azure.Management.Batch
{
    public static partial class SubscriptionOperationsExtensions
    {
        /// <summary>
        /// The Get Subscription Quotas operation returns the quotas of the
        /// subscription in the Batch service.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Batch.ISubscriptionOperations.
        /// </param>
        /// <param name='locationName'>
        /// Required.
        /// </param>
        /// <returns>
        /// Values returned by the Get Subscription Quotas operation.
        /// </returns>
        public static SubscriptionQuotasGetResponse GetSubscriptionQuotas(this ISubscriptionOperations operations, string locationName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((ISubscriptionOperations)s).GetSubscriptionQuotasAsync(locationName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Get Subscription Quotas operation returns the quotas of the
        /// subscription in the Batch service.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Batch.ISubscriptionOperations.
        /// </param>
        /// <param name='locationName'>
        /// Required.
        /// </param>
        /// <returns>
        /// Values returned by the Get Subscription Quotas operation.
        /// </returns>
        public static Task<SubscriptionQuotasGetResponse> GetSubscriptionQuotasAsync(this ISubscriptionOperations operations, string locationName)
        {
            return operations.GetSubscriptionQuotasAsync(locationName, CancellationToken.None);
        }
    }
}
