// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute
{
    /// <summary>
    /// Operations for managing the virtual machine images in compute
    /// management.
    /// </summary>
    public partial interface IVirtualMachineImageOperations
    {
        /// <summary>
        /// Gets a virtual machine image.
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The get vm image operation response.
        /// </returns>
        Task<VirtualMachineImageGetResponse> GetAsync(VirtualMachineImageGetParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Gets a list of virtual machine images.
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        Task<VirtualMachineImageResourceList> ListAsync(VirtualMachineImageListParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Gets a list of virtual machine image offers.
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        Task<VirtualMachineImageResourceList> ListOffersAsync(VirtualMachineImageListOffersParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Gets a list of virtual machine image publishers.
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        Task<VirtualMachineImageResourceList> ListPublishersAsync(VirtualMachineImageListPublishersParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Gets a list of virtual machine image skus.
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        Task<VirtualMachineImageResourceList> ListSkusAsync(VirtualMachineImageListSkusParameters parameters, CancellationToken cancellationToken);
    }
}
