// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Create or update Availability Set parameters.
    /// </summary>
    public partial class AvailabilitySet : ResourceBaseExtended
    {
        private int? _platformFaultDomainCount;
        
        /// <summary>
        /// Optional. Gets or sets Fault Domain count.
        /// </summary>
        public int? PlatformFaultDomainCount
        {
            get { return this._platformFaultDomainCount; }
            set { this._platformFaultDomainCount = value; }
        }
        
        private int? _platformUpdateDomainCount;
        
        /// <summary>
        /// Optional. Gets or sets Update Domain count.
        /// </summary>
        public int? PlatformUpdateDomainCount
        {
            get { return this._platformUpdateDomainCount; }
            set { this._platformUpdateDomainCount = value; }
        }
        
        private IList<InstanceViewStatus> _statuses;
        
        /// <summary>
        /// Optional. Gets or sets the resource status information.
        /// </summary>
        public IList<InstanceViewStatus> Statuses
        {
            get { return this._statuses; }
            set { this._statuses = value; }
        }
        
        private IList<VirtualMachineReference> _virtualMachinesReferences;
        
        /// <summary>
        /// Optional. Gets or sets a list containing reference to all Virtual
        /// Machines  created under this Availability Set.
        /// </summary>
        public IList<VirtualMachineReference> VirtualMachinesReferences
        {
            get { return this._virtualMachinesReferences; }
            set { this._virtualMachinesReferences = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AvailabilitySet class.
        /// </summary>
        public AvailabilitySet()
        {
            this.Statuses = new LazyList<InstanceViewStatus>();
            this.VirtualMachinesReferences = new LazyList<VirtualMachineReference>();
        }
        
        /// <summary>
        /// Initializes a new instance of the AvailabilitySet class with
        /// required arguments.
        /// </summary>
        public AvailabilitySet(string location)
            : this()
        {
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Location = location;
        }
    }
}
