// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// The image reference.
    /// </summary>
    public partial class ImageReference
    {
        private string _offer;
        
        /// <summary>
        /// Optional. Gets or sets the image offer.
        /// </summary>
        public string Offer
        {
            get { return this._offer; }
            set { this._offer = value; }
        }
        
        private string _publisher;
        
        /// <summary>
        /// Optional. Gets or sets the image publisher.
        /// </summary>
        public string Publisher
        {
            get { return this._publisher; }
            set { this._publisher = value; }
        }
        
        private string _sku;
        
        /// <summary>
        /// Optional. Gets or sets the image sku.
        /// </summary>
        public string Sku
        {
            get { return this._sku; }
            set { this._sku = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Gets or sets the image version. The allowed formats are
        /// Major.Minor.Build or 'latest'. Major, Minor and Build being
        /// decimal numbers. Specify 'latest' to use the latest version of
        /// image.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ImageReference class.
        /// </summary>
        public ImageReference()
        {
        }
    }
}
