// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Describes an Operating System disk.
    /// </summary>
    public partial class OSDisk : Disk
    {
        private DiskEncryptionSettings _encryptionSettings;
        
        /// <summary>
        /// Optional. Gets or sets the disk encryption settings.
        /// </summary>
        public DiskEncryptionSettings EncryptionSettings
        {
            get { return this._encryptionSettings; }
            set { this._encryptionSettings = value; }
        }
        
        private string _operatingSystemType;
        
        /// <summary>
        /// Optional. Gets or sets the Operating System type.
        /// </summary>
        public string OperatingSystemType
        {
            get { return this._operatingSystemType; }
            set { this._operatingSystemType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OSDisk class.
        /// </summary>
        public OSDisk()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the OSDisk class with required
        /// arguments.
        /// </summary>
        public OSDisk(string name, VirtualHardDisk virtualHardDisk, string createOption)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (virtualHardDisk == null)
            {
                throw new ArgumentNullException("virtualHardDisk");
            }
            if (createOption == null)
            {
                throw new ArgumentNullException("createOption");
            }
            this.Name = name;
            this.VirtualHardDisk = virtualHardDisk;
            this.CreateOption = createOption;
        }
    }
}
