// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Contains the os disk image information.
    /// </summary>
    public partial class OSDiskImage
    {
        private string _operatingSystem;
        
        /// <summary>
        /// Required. Gets or sets the operating system of the osDiskImage.
        /// </summary>
        public string OperatingSystem
        {
            get { return this._operatingSystem; }
            set { this._operatingSystem = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OSDiskImage class.
        /// </summary>
        public OSDiskImage()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the OSDiskImage class with required
        /// arguments.
        /// </summary>
        public OSDiskImage(string operatingSystem)
            : this()
        {
            if (operatingSystem == null)
            {
                throw new ArgumentNullException("operatingSystem");
            }
            this.OperatingSystem = operatingSystem;
        }
    }
}
