// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Describes a storage profile.
    /// </summary>
    public partial class StorageProfile
    {
        private IList<DataDisk> _dataDisks;
        
        /// <summary>
        /// Optional. Gets or sets the data disks.
        /// </summary>
        public IList<DataDisk> DataDisks
        {
            get { return this._dataDisks; }
            set { this._dataDisks = value; }
        }
        
        private ImageReference _imageReference;
        
        /// <summary>
        /// Optional. Gets or sets the image reference.
        /// </summary>
        public ImageReference ImageReference
        {
            get { return this._imageReference; }
            set { this._imageReference = value; }
        }
        
        private OSDisk _oSDisk;
        
        /// <summary>
        /// Optional. Gets or sets the OS disk.
        /// </summary>
        public OSDisk OSDisk
        {
            get { return this._oSDisk; }
            set { this._oSDisk = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the StorageProfile class.
        /// </summary>
        public StorageProfile()
        {
            this.DataDisks = new LazyList<DataDisk>();
        }
    }
}
