// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// The instance view of the VM Agent running on the virtual machine.
    /// </summary>
    public partial class VirtualMachineAgentInstanceView : ResourceInstanceView
    {
        private IList<VirtualMachineExtensionHandlerInstanceView> _extensionHandlers;
        
        /// <summary>
        /// Optional. Gets or sets the virtual machine extension handler
        /// instance view.
        /// </summary>
        public IList<VirtualMachineExtensionHandlerInstanceView> ExtensionHandlers
        {
            get { return this._extensionHandlers; }
            set { this._extensionHandlers = value; }
        }
        
        private string _vMAgentVersion;
        
        /// <summary>
        /// Optional. Gets or sets the VM Agent full version.
        /// </summary>
        public string VMAgentVersion
        {
            get { return this._vMAgentVersion; }
            set { this._vMAgentVersion = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualMachineAgentInstanceView
        /// class.
        /// </summary>
        public VirtualMachineAgentInstanceView()
        {
            this.ExtensionHandlers = new LazyList<VirtualMachineExtensionHandlerInstanceView>();
        }
    }
}
