// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Capture Virtual Machine parameters.
    /// </summary>
    public partial class VirtualMachineCaptureParameters
    {
        private string _destinationContainerName;
        
        /// <summary>
        /// Required. Gets or sets the destination container name.
        /// </summary>
        public string DestinationContainerName
        {
            get { return this._destinationContainerName; }
            set { this._destinationContainerName = value; }
        }
        
        private bool _overwrite;
        
        /// <summary>
        /// Required. Gets or sets whether it overwrites destination
        /// VirtualHardDisk if true, in case of conflict.
        /// </summary>
        public bool Overwrite
        {
            get { return this._overwrite; }
            set { this._overwrite = value; }
        }
        
        private string _virtualHardDiskNamePrefix;
        
        /// <summary>
        /// Required. Gets or sets the captured VirtualHardDisk's name prefix.
        /// </summary>
        public string VirtualHardDiskNamePrefix
        {
            get { return this._virtualHardDiskNamePrefix; }
            set { this._virtualHardDiskNamePrefix = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualMachineCaptureParameters
        /// class.
        /// </summary>
        public VirtualMachineCaptureParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualMachineCaptureParameters
        /// class with required arguments.
        /// </summary>
        public VirtualMachineCaptureParameters(string virtualHardDiskNamePrefix, string destinationContainerName, bool overwrite)
            : this()
        {
            if (virtualHardDiskNamePrefix == null)
            {
                throw new ArgumentNullException("virtualHardDiskNamePrefix");
            }
            if (destinationContainerName == null)
            {
                throw new ArgumentNullException("destinationContainerName");
            }
            this.VirtualHardDiskNamePrefix = virtualHardDiskNamePrefix;
            this.DestinationContainerName = destinationContainerName;
            this.Overwrite = overwrite;
        }
    }
}
