// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Describes a Virtual Machine Extension Image.
    /// </summary>
    public partial class VirtualMachineExtensionImage : VirtualMachineImageResource
    {
        private string _computeRole;
        
        /// <summary>
        /// Required. Gets or sets the type of role (IaaS or PaaS) this
        /// extension supports.
        /// </summary>
        public string ComputeRole
        {
            get { return this._computeRole; }
            set { this._computeRole = value; }
        }
        
        private string _handlerSchema;
        
        /// <summary>
        /// Required. Gets or sets the schema defined by publisher, where
        /// extension consumers should provide settings in a matching schema.
        /// </summary>
        public string HandlerSchema
        {
            get { return this._handlerSchema; }
            set { this._handlerSchema = value; }
        }
        
        private string _operatingSystem;
        
        /// <summary>
        /// Required. Gets or sets the operating system this extension supports.
        /// </summary>
        public string OperatingSystem
        {
            get { return this._operatingSystem; }
            set { this._operatingSystem = value; }
        }
        
        private bool _supportsMultipleExtensions;
        
        /// <summary>
        /// Optional. Gets or sets whether the handler can support multiple
        /// extensions.
        /// </summary>
        public bool SupportsMultipleExtensions
        {
            get { return this._supportsMultipleExtensions; }
            set { this._supportsMultipleExtensions = value; }
        }
        
        private bool _vMScaleSetEnabled;
        
        /// <summary>
        /// Optional. Gets or sets whether the extension can be used on xRP
        /// VMScaleSets.By default existing extensions are usable on
        /// scalesets, but there might be cases where a publisher wants to
        /// explicitly indicate the extension is only enabled for CRP VMs but
        /// not VMSS.
        /// </summary>
        public bool VMScaleSetEnabled
        {
            get { return this._vMScaleSetEnabled; }
            set { this._vMScaleSetEnabled = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualMachineExtensionImage
        /// class.
        /// </summary>
        public VirtualMachineExtensionImage()
        {
        }
    }
}
