// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Describes a Virtual Machine Image.
    /// </summary>
    public partial class VirtualMachineImage : VirtualMachineImageResource
    {
        private IList<DataDiskImage> _dataDiskImages;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public IList<DataDiskImage> DataDiskImages
        {
            get { return this._dataDiskImages; }
            set { this._dataDiskImages = value; }
        }
        
        private OSDiskImage _oSDiskImage;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public OSDiskImage OSDiskImage
        {
            get { return this._oSDiskImage; }
            set { this._oSDiskImage = value; }
        }
        
        private PurchasePlan _purchasePlan;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public PurchasePlan PurchasePlan
        {
            get { return this._purchasePlan; }
            set { this._purchasePlan = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualMachineImage class.
        /// </summary>
        public VirtualMachineImage()
        {
            this.DataDiskImages = new LazyList<DataDiskImage>();
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualMachineImage class with
        /// required arguments.
        /// </summary>
        public VirtualMachineImage(string id, string name, string location)
            : this()
        {
            if (id == null)
            {
                throw new ArgumentNullException("id");
            }
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Id = id;
            this.Name = name;
            this.Location = location;
        }
    }
}
