// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Contains the parameters required to list virtual machine image versions.
    /// </summary>
    public partial class VirtualMachineImageListParameters : VirtualMachineImageListDetailsParameters
    {
        private string _filterExpression;
        
        /// <summary>
        /// Optional. ODAta filter
        /// expression.https://msdn.microsoft.com/en-us/library/hh169248(v=nav.70).aspxSupported
        /// operatives: -eq -startswith Examples:    To list the all version
        /// that begin with 1.0 $filter=startswith(name, ‘1.0’)    To get the
        /// latest version $filter= name eq ‘latest’
        /// </summary>
        public string FilterExpression
        {
            get { return this._filterExpression; }
            set { this._filterExpression = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualMachineImageListParameters
        /// class.
        /// </summary>
        public VirtualMachineImageListParameters()
        {
        }
    }
}
