// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Contains the parameters required to list skus.
    /// </summary>
    public partial class VirtualMachineImageListSkusParameters : VirtualMachineImageListOffersParameters
    {
        private string _offer;
        
        /// <summary>
        /// Required. Unique identifier to distinguish an image. The
        /// vmImageName must be unique within publisher’s namespace. Example:
        /// WindowsServer2012
        /// </summary>
        public string Offer
        {
            get { return this._offer; }
            set { this._offer = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineImageListSkusParameters class.
        /// </summary>
        public VirtualMachineImageListSkusParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineImageListSkusParameters class with required
        /// arguments.
        /// </summary>
        public VirtualMachineImageListSkusParameters(string offer, string publisherName, string location)
            : this()
        {
            if (offer == null)
            {
                throw new ArgumentNullException("offer");
            }
            if (publisherName == null)
            {
                throw new ArgumentNullException("publisherName");
            }
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Offer = offer;
            this.PublisherName = publisherName;
            this.Location = location;
        }
    }
}
