// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute.Models
{
    /// <summary>
    /// Describes Windows Configuration of the OS Profile.
    /// </summary>
    public partial class WindowsConfiguration
    {
        private IList<AdditionalUnattendContent> _additionalUnattendContents;
        
        /// <summary>
        /// Optional. Gets or sets the additional base-64 encoded XML formatted
        /// information that can be included in the Unattend.xml file.
        /// </summary>
        public IList<AdditionalUnattendContent> AdditionalUnattendContents
        {
            get { return this._additionalUnattendContents; }
            set { this._additionalUnattendContents = value; }
        }
        
        private bool? _enableAutomaticUpdates;
        
        /// <summary>
        /// Optional. Gets or sets whether Windows updates are automatically
        /// installed on the VM
        /// </summary>
        public bool? EnableAutomaticUpdates
        {
            get { return this._enableAutomaticUpdates; }
            set { this._enableAutomaticUpdates = value; }
        }
        
        private bool? _provisionVMAgent;
        
        /// <summary>
        /// Optional. Gets or sets whether VM Agent should be provisioned on
        /// the Virtual Machine.
        /// </summary>
        public bool? ProvisionVMAgent
        {
            get { return this._provisionVMAgent; }
            set { this._provisionVMAgent = value; }
        }
        
        private string _timeZone;
        
        /// <summary>
        /// Optional. Gets or sets the Time Zone of the VM
        /// </summary>
        public string TimeZone
        {
            get { return this._timeZone; }
            set { this._timeZone = value; }
        }
        
        private WinRMConfiguration _winRMConfiguration;
        
        /// <summary>
        /// Optional. Gets or sets the Windows Remote Management configuration
        /// of the VM
        /// </summary>
        public WinRMConfiguration WinRMConfiguration
        {
            get { return this._winRMConfiguration; }
            set { this._winRMConfiguration = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WindowsConfiguration class.
        /// </summary>
        public WindowsConfiguration()
        {
            this.AdditionalUnattendContents = new LazyList<AdditionalUnattendContent>();
        }
    }
}
