// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Compute;
using Microsoft.Azure.Management.Compute.Models;

namespace Microsoft.Azure.Management.Compute
{
    /// <summary>
    /// The Compute Management Client.
    /// </summary>
    public static partial class VirtualMachineExtensionImageOperationsExtensions
    {
        /// <summary>
        /// Gets a virtual machine extension image.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Compute.IVirtualMachineExtensionImageOperations.
        /// </param>
        /// <param name='parameters'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The get virtual machine extension image operation response.
        /// </returns>
        public static VirtualMachineExtensionImageGetResponse Get(this IVirtualMachineExtensionImageOperations operations, VirtualMachineExtensionImageGetParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualMachineExtensionImageOperations)s).GetAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets a virtual machine extension image.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Compute.IVirtualMachineExtensionImageOperations.
        /// </param>
        /// <param name='parameters'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The get virtual machine extension image operation response.
        /// </returns>
        public static Task<VirtualMachineExtensionImageGetResponse> GetAsync(this IVirtualMachineExtensionImageOperations operations, VirtualMachineExtensionImageGetParameters parameters)
        {
            return operations.GetAsync(parameters, CancellationToken.None);
        }
        
        /// <summary>
        /// Gets a list of virtual machine extension image types.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Compute.IVirtualMachineExtensionImageOperations.
        /// </param>
        /// <param name='parameters'>
        /// Optional.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        public static VirtualMachineImageResourceList ListTypes(this IVirtualMachineExtensionImageOperations operations, VirtualMachineExtensionImageListTypesParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualMachineExtensionImageOperations)s).ListTypesAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets a list of virtual machine extension image types.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Compute.IVirtualMachineExtensionImageOperations.
        /// </param>
        /// <param name='parameters'>
        /// Optional.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        public static Task<VirtualMachineImageResourceList> ListTypesAsync(this IVirtualMachineExtensionImageOperations operations, VirtualMachineExtensionImageListTypesParameters parameters)
        {
            return operations.ListTypesAsync(parameters, CancellationToken.None);
        }
        
        /// <summary>
        /// Gets a list of virtual machine extension image versions.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Compute.IVirtualMachineExtensionImageOperations.
        /// </param>
        /// <param name='parameters'>
        /// Optional.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        public static VirtualMachineImageResourceList ListVersions(this IVirtualMachineExtensionImageOperations operations, VirtualMachineExtensionImageListVersionsParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IVirtualMachineExtensionImageOperations)s).ListVersionsAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets a list of virtual machine extension image versions.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Compute.IVirtualMachineExtensionImageOperations.
        /// </param>
        /// <param name='parameters'>
        /// Optional.
        /// </param>
        /// <returns>
        /// A list of virtual machine image resource information.
        /// </returns>
        public static Task<VirtualMachineImageResourceList> ListVersionsAsync(this IVirtualMachineExtensionImageOperations operations, VirtualMachineExtensionImageListVersionsParameters parameters)
        {
            return operations.ListVersionsAsync(parameters, CancellationToken.None);
        }
    }
}
