// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Common.Models
{
    /// <summary>
    /// An activity input.
    /// </summary>
    public partial class ActivityInput
    {
        private string _endTime;
        
        /// <summary>
        /// Optional. EndTime.
        /// </summary>
        public string EndTime
        {
            get { return this._endTime; }
            set { this._endTime = value; }
        }
        
        private System.TimeSpan? _length;
        
        /// <summary>
        /// Optional. Length.
        /// </summary>
        public System.TimeSpan? Length
        {
            get { return this._length; }
            set { this._length = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Referenced dataset name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _startTime;
        
        /// <summary>
        /// Optional. Start time.
        /// </summary>
        public string StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityInput class.
        /// </summary>
        public ActivityInput()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityInput class with required
        /// arguments.
        /// </summary>
        public ActivityInput(string name)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            this.Name = name;
        }
    }
}
