// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Core.Registration.Models
{
    /// <summary>
    /// Parameters specifying how to return an ActivityType definition for a
    /// Get operation.
    /// </summary>
    public partial class ActivityTypeGetParameters
    {
        private string _activityTypeName;
        
        /// <summary>
        /// Required. An ActivityType name.
        /// </summary>
        public string ActivityTypeName
        {
            get { return this._activityTypeName; }
            set { this._activityTypeName = value; }
        }
        
        private string _registrationScope;
        
        /// <summary>
        /// Required. The scope for which to get an ActivityType definition.
        /// </summary>
        public string RegistrationScope
        {
            get { return this._registrationScope; }
            set { this._registrationScope = value; }
        }
        
        private bool _resolved;
        
        /// <summary>
        /// Optional. If true, gets the properties of any base types an
        /// ActivityType inherits from.
        /// </summary>
        public bool Resolved
        {
            get { return this._resolved; }
            set { this._resolved = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityTypeGetParameters class.
        /// </summary>
        public ActivityTypeGetParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityTypeGetParameters class
        /// with required arguments.
        /// </summary>
        public ActivityTypeGetParameters(string registrationScope, string activityTypeName)
            : this()
        {
            if (registrationScope == null)
            {
                throw new ArgumentNullException("registrationScope");
            }
            if (activityTypeName == null)
            {
                throw new ArgumentNullException("activityTypeName");
            }
            this.RegistrationScope = registrationScope;
            this.ActivityTypeName = activityTypeName;
        }
    }
}
