// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Core.Registration.Models
{
    /// <summary>
    /// Parameters specifying how to return a list of ActivityType definitions
    /// for a List operation.
    /// </summary>
    public partial class ActivityTypeListParameters
    {
        private string _activityTypeName;
        
        /// <summary>
        /// Optional. The name of the ActivityType to list.
        /// </summary>
        public string ActivityTypeName
        {
            get { return this._activityTypeName; }
            set { this._activityTypeName = value; }
        }
        
        private string _registrationScope;
        
        /// <summary>
        /// Optional. The scope for which to list the ActivityType definitions.
        /// </summary>
        public string RegistrationScope
        {
            get { return this._registrationScope; }
            set { this._registrationScope = value; }
        }
        
        private bool _resolved;
        
        /// <summary>
        /// Optional. If true, gets the properties of any base types each
        /// ActivityType inherits from.
        /// </summary>
        public bool Resolved
        {
            get { return this._resolved; }
            set { this._resolved = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityTypeListParameters class.
        /// </summary>
        public ActivityTypeListParameters()
        {
        }
    }
}
