// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataFactories.Core.Registration.Models;

namespace Microsoft.Azure.Management.DataFactories.Core.Registration.Models
{
    /// <summary>
    /// Compute type properties.
    /// </summary>
    public partial class ComputeTypeProperties
    {
        private string _schema;
        
        /// <summary>
        /// Required. Schema for type specfic properties of the ComputeType.
        /// </summary>
        public string Schema
        {
            get { return this._schema; }
            set { this._schema = value; }
        }
        
        private string _scope;
        
        /// <summary>
        /// Required. The scope of the ComputeType.
        /// </summary>
        public string Scope
        {
            get { return this._scope; }
            set { this._scope = value; }
        }
        
        private IList<string> _supportedActivities;
        
        /// <summary>
        /// Required. The ActivityTypes that this ComputeType can execute.
        /// </summary>
        public IList<string> SupportedActivities
        {
            get { return this._supportedActivities; }
            set { this._supportedActivities = value; }
        }
        
        private ComputeTransport _transport;
        
        /// <summary>
        /// Required. The protocol definition for communication with this
        /// ComputeType.
        /// </summary>
        public ComputeTransport Transport
        {
            get { return this._transport; }
            set { this._transport = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ComputeTypeProperties class.
        /// </summary>
        public ComputeTypeProperties()
        {
            this.SupportedActivities = new LazyList<string>();
        }
    }
}
