// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Core.Registration.Models;

namespace Microsoft.Azure.Management.DataFactories.Core.Registration.Models
{
    /// <summary>
    /// The definition of a Service Bus endpoint for communication with a
    /// ComputeType.
    /// </summary>
    public partial class ServiceBusTransport : ComputeTransport
    {
        private string _activityRequestQueue;
        
        /// <summary>
        /// Required. Azure ServiceBus queue where ADF will submit activity
        /// slice execution jobs.
        /// </summary>
        public string ActivityRequestQueue
        {
            get { return this._activityRequestQueue; }
            set { this._activityRequestQueue = value; }
        }
        
        private string _activityStatusQueue;
        
        /// <summary>
        /// Required. Azure ServiceBus session queue where activity executor
        /// should report slice status.
        /// </summary>
        public string ActivityStatusQueue
        {
            get { return this._activityStatusQueue; }
            set { this._activityStatusQueue = value; }
        }
        
        private string _serviceBusEndpoint;
        
        /// <summary>
        /// Required. Azure ServiceBus endpoint.
        /// </summary>
        public string ServiceBusEndpoint
        {
            get { return this._serviceBusEndpoint; }
            set { this._serviceBusEndpoint = value; }
        }
        
        private string _serviceBusSharedAccessKey;
        
        /// <summary>
        /// Required. Azure ServiceBus shared access key.
        /// </summary>
        public string ServiceBusSharedAccessKey
        {
            get { return this._serviceBusSharedAccessKey; }
            set { this._serviceBusSharedAccessKey = value; }
        }
        
        private string _serviceBusSharedAccessKeyName;
        
        /// <summary>
        /// Required. Azure ServiceBus shared access key name.
        /// </summary>
        public string ServiceBusSharedAccessKeyName
        {
            get { return this._serviceBusSharedAccessKeyName; }
            set { this._serviceBusSharedAccessKeyName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServiceBusTransport class.
        /// </summary>
        public ServiceBusTransport()
        {
        }
    }
}
