// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// The List activity windows operation response.
    /// </summary>
    public partial class ActivityWindowListResponse : AzureOperationResponse
    {
        private ActivityWindowListResponseValue _activityWindowListResponseValue;
        
        /// <summary>
        /// Optional. The List activity windows operation response value.
        /// </summary>
        public ActivityWindowListResponseValue ActivityWindowListResponseValue
        {
            get { return this._activityWindowListResponseValue; }
            set { this._activityWindowListResponseValue = value; }
        }
        
        private string _nextLink;
        
        /// <summary>
        /// Required. The link (URL) to the next page of results.
        /// </summary>
        public string NextLink
        {
            get { return this._nextLink; }
            set { this._nextLink = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityWindowListResponse class.
        /// </summary>
        public ActivityWindowListResponse()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityWindowListResponse class
        /// with required arguments.
        /// </summary>
        public ActivityWindowListResponse(string nextLink)
            : this()
        {
            if (nextLink == null)
            {
                throw new ArgumentNullException("nextLink");
            }
            this.NextLink = nextLink;
        }
    }
}
