// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// The List activity windows operation response value.
    /// </summary>
    public partial class ActivityWindowListResponseValue : AzureOperationResponse
    {
        private IList<ActivityWindow> _activityWindows;
        
        /// <summary>
        /// Optional. A list of the returned activity window instances.
        /// </summary>
        public IList<ActivityWindow> ActivityWindows
        {
            get { return this._activityWindows; }
            set { this._activityWindows = value; }
        }
        
        private string _lastUpdate;
        
        /// <summary>
        /// Optional. The approximate time for the last activity windows
        /// refresh.
        /// </summary>
        public string LastUpdate
        {
            get { return this._lastUpdate; }
            set { this._lastUpdate = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ActivityWindowListResponseValue
        /// class.
        /// </summary>
        public ActivityWindowListResponseValue()
        {
            this.ActivityWindows = new LazyList<ActivityWindow>();
        }
    }
}
