// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// Filter parameters for the activity windows list.
    /// </summary>
    public partial class ActivityWindowsByDatasetListParameters : ActivityWindowsListParameters
    {
        private string _datasetName;
        
        /// <summary>
        /// Required. The dataset name.
        /// </summary>
        public string DatasetName
        {
            get { return this._datasetName; }
            set { this._datasetName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ActivityWindowsByDatasetListParameters class.
        /// </summary>
        public ActivityWindowsByDatasetListParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ActivityWindowsByDatasetListParameters class with required
        /// arguments.
        /// </summary>
        public ActivityWindowsByDatasetListParameters(string datasetName, string resourceGroupName, string dataFactoryName)
            : this()
        {
            if (datasetName == null)
            {
                throw new ArgumentNullException("datasetName");
            }
            if (resourceGroupName == null)
            {
                throw new ArgumentNullException("resourceGroupName");
            }
            if (dataFactoryName == null)
            {
                throw new ArgumentNullException("dataFactoryName");
            }
            this.DatasetName = datasetName;
            this.ResourceGroupName = resourceGroupName;
            this.DataFactoryName = dataFactoryName;
        }
    }
}
