// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// An OAuth authorization session is used to initiate the authorization
    /// code grant flow to allow ADF to access resources on your behalf.
    /// </summary>
    public partial class AuthorizationSession
    {
        private Uri _endpoint;
        
        /// <summary>
        /// Required. Use the OAuth authorization endpoint to log-in and
        /// acquire an authorization that may be used by ADF to access
        /// resources on your behalf. Each authorization is unique and may
        /// only be used once.
        /// </summary>
        public Uri Endpoint
        {
            get { return this._endpoint; }
            set { this._endpoint = value; }
        }
        
        private string _sessionId;
        
        /// <summary>
        /// Required. Provide this value when creating an OAuth linked service.
        /// Each session id is unique and may only be used once.
        /// </summary>
        public string SessionId
        {
            get { return this._sessionId; }
            set { this._sessionId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AuthorizationSession class.
        /// </summary>
        public AuthorizationSession()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the AuthorizationSession class with
        /// required arguments.
        /// </summary>
        public AuthorizationSession(Uri endpoint, string sessionId)
            : this()
        {
            if (endpoint == null)
            {
                throw new ArgumentNullException("endpoint");
            }
            if (sessionId == null)
            {
                throw new ArgumentNullException("sessionId");
            }
            this.Endpoint = endpoint;
            this.SessionId = sessionId;
        }
    }
}
