// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// Parameters specifying the filters for the list data slices operation.
    /// </summary>
    public partial class DataSliceListParameters
    {
        private string _dataSliceRangeEndTime;
        
        /// <summary>
        /// Required. The data slice range end time in round-trip ISO 8601
        /// format.
        /// </summary>
        public string DataSliceRangeEndTime
        {
            get { return this._dataSliceRangeEndTime; }
            set { this._dataSliceRangeEndTime = value; }
        }
        
        private string _dataSliceRangeStartTime;
        
        /// <summary>
        /// Required. The data slice range start time in round-trip ISO 8601
        /// format.
        /// </summary>
        public string DataSliceRangeStartTime
        {
            get { return this._dataSliceRangeStartTime; }
            set { this._dataSliceRangeStartTime = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DataSliceListParameters class.
        /// </summary>
        public DataSliceListParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the DataSliceListParameters class
        /// with required arguments.
        /// </summary>
        public DataSliceListParameters(string dataSliceRangeStartTime, string dataSliceRangeEndTime)
            : this()
        {
            if (dataSliceRangeStartTime == null)
            {
                throw new ArgumentNullException("dataSliceRangeStartTime");
            }
            if (dataSliceRangeEndTime == null)
            {
                throw new ArgumentNullException("dataSliceRangeEndTime");
            }
            this.DataSliceRangeStartTime = dataSliceRangeStartTime;
            this.DataSliceRangeEndTime = dataSliceRangeEndTime;
        }
    }
}
