// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// Current state of the pipeline.
    /// </summary>
    public static partial class PipelineState
    {
        /// <summary>
        /// Not Specified.
        /// </summary>
        public const string NotSpecified = "NotSpecified";
        
        /// <summary>
        /// The pipeline has a pending initialization task.
        /// </summary>
        public const string Initializing = "Initializing";
        
        /// <summary>
        /// The pipeline has a pending update task.
        /// </summary>
        public const string Updating = "Updating";
        
        /// <summary>
        /// The pipeline has a pending deletion task.
        /// </summary>
        public const string Deleting = "Deleting";
        
        /// <summary>
        /// The pipeline is not active. No active period is set or active
        /// period is in future.
        /// </summary>
        public const string Inactive = "Inactive";
        
        /// <summary>
        /// The pipeline is active and executing activities.
        /// </summary>
        public const string Running = "Running";
        
        /// <summary>
        /// The pipeline has completed all the scheduled runs for its
        /// activities.
        /// </summary>
        public const string Completed = "Completed";
        
        /// <summary>
        /// The pipeline is paused.
        /// </summary>
        public const string Paused = "Paused";
    }
}
