// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// The enum for all the supported activity window states.
    /// </summary>
    public static partial class WindowState
    {
        /// <summary>
        /// No state specified.
        /// </summary>
        public const string None = "None";
        
        /// <summary>
        /// The activity window is awaiting execution because either the input
        /// is not ready or the execution time has not yet passed. For more
        /// information on the reason see <cref="WindowSubstate"/>.
        /// </summary>
        public const string Waiting = "Waiting";
        
        /// <summary>
        /// The activity window is being processed.
        /// </summary>
        public const string InProgress = "InProgress";
        
        /// <summary>
        /// The activity window finished running and the result is ready to be
        /// consumed.
        /// </summary>
        public const string Ready = "Ready";
        
        /// <summary>
        /// The activity window failed to validate/generate results.
        /// </summary>
        public const string Failed = "Failed";
        
        /// <summary>
        /// The activity window was not processed. For more information on the
        /// reason please see <cref="WindowSubstate"/>.
        /// </summary>
        public const string Skipped = "Skipped";
    }
}
