// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// The enum for all the supported activity window states.
    /// </summary>
    public static partial class WindowSubstate
    {
        /// <summary>
        /// Canceled by user action.
        /// </summary>
        public const string Canceled = "Canceled";
        
        /// <summary>
        /// Execution took longer than allowed by the activity's timeout period.
        /// </summary>
        public const string TimedOut = "TimedOut";
        
        /// <summary>
        /// Validation in progress.
        /// </summary>
        public const string Validating = "Validating";
        
        /// <summary>
        /// The scheduled time for the activity window to run has not yet
        /// passed.
        /// </summary>
        public const string ScheduledTime = "ScheduledTime";
        
        /// <summary>
        /// The upstream dependencies are not ready.
        /// </summary>
        public const string DatasetDependencies = "DatasetDependencies";
        
        /// <summary>
        /// The compute resources are not available.
        /// </summary>
        public const string ComputeResources = "ComputeResources";
        
        /// <summary>
        /// All the activity instances are busy running other activity windows.
        /// </summary>
        public const string ConcurrencyLimit = "ConcurrencyLimit";
        
        /// <summary>
        /// The activity is paused and cannot run the slices until it is
        /// resumed.
        /// </summary>
        public const string ActivityResume = "ActivityResume";
        
        /// <summary>
        /// The activity execution will be retried.
        /// </summary>
        public const string Retry = "Retry";
        
        /// <summary>
        /// Validation has not started yet, can be used with Failed state as
        /// well.
        /// </summary>
        public const string Validation = "Validation";
        
        /// <summary>
        /// Waiting for the validation to be retried.
        /// </summary>
        public const string ValidationRetry = "ValidationRetry";
    }
}
