// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models
{
    /// <summary>
    /// A Data Lake Analytics catalog item list.
    /// </summary>
    public abstract partial class CatalogItemList
    {
        private int _count;
        
        /// <summary>
        /// Optional. Gets or sets the count of items in the list.
        /// </summary>
        public int Count
        {
            get { return this._count; }
            set { this._count = value; }
        }
        
        private string _itemType;
        
        /// <summary>
        /// Optional. Gets or sets the job type of the current job (i.e. Hive
        /// or USql).
        /// </summary>
        public string ItemType
        {
            get { return this._itemType; }
            set { this._itemType = value; }
        }
        
        private string _nextLink;
        
        /// <summary>
        /// Optional. Gets or sets the link to the next page of results.
        /// </summary>
        public string NextLink
        {
            get { return this._nextLink; }
            set { this._nextLink = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CatalogItemList class.
        /// </summary>
        public CatalogItemList()
        {
        }
    }
}
