// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models
{
    /// <summary>
    /// Enumeration of Data Lake Analytics catalog item types.
    /// </summary>
    public static partial class CatalogItemType
    {
        /// <summary>
        /// U-SQL Database type
        /// </summary>
        public const string USqlDatabase = "usqlDatabase";
        
        /// <summary>
        /// U-SQL schema type
        /// </summary>
        public const string USqlSchema = "usqlSchema";
        
        /// <summary>
        /// U-SQL assembly type
        /// </summary>
        public const string USqlAssembly = "usqlAssembly";
        
        /// <summary>
        /// U-SQL table type
        /// </summary>
        public const string USqlTable = "usqlTable";
        
        /// <summary>
        /// U-SQL view type
        /// </summary>
        public const string USqlView = "uSqlView";
        
        /// <summary>
        /// U-SQL procedure type
        /// </summary>
        public const string USqlProcedure = "uSqlProcedure";
        
        /// <summary>
        /// U-SQL credential type
        /// </summary>
        public const string USqlCredential = "uSqlCredential";
        
        /// <summary>
        /// U-SQL table valued function type
        /// </summary>
        public const string USqlTableValuedFunction = "usqlTableValuedFunction";
        
        /// <summary>
        /// U-SQL table statistics type
        /// </summary>
        public const string USqlTableStatistics = "usqlTableStatistics";
        
        /// <summary>
        /// U-SQL secret type
        /// </summary>
        public const string USqlSecret = "usqlSecret";
        
        /// <summary>
        /// U-SQL External datasource type
        /// </summary>
        public const string USqlExternalDataSource = "usqlExternalDataSource";
        
        /// <summary>
        /// U-SQL Type type
        /// </summary>
        public const string USqlType = "usqlType";
    }
}
