// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models
{
    /// <summary>
    /// DataLakeAnalytics DataLakeAnalyticsAccount information.
    /// </summary>
    public partial class DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters
    {
        private string _password;
        
        /// <summary>
        /// Required. Gets or sets the password for the secret to pass in
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _secretName;
        
        /// <summary>
        /// Required. Gets or sets the name of the secret to create.
        /// </summary>
        public string SecretName
        {
            get { return this._secretName; }
            set { this._secretName = value; }
        }
        
        private string _uri;
        
        /// <summary>
        /// Optional. Gets or sets the URI identifier for the secret in the
        /// format https://<hostname>:<port>
        /// </summary>
        public string Uri
        {
            get { return this._uri; }
            set { this._uri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters class.
        /// </summary>
        public DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters class with
        /// required arguments.
        /// </summary>
        public DataLakeAnalyticsCatalogSecretCreateOrUpdateParameters(string secretName, string password)
            : this()
        {
            if (secretName == null)
            {
                throw new ArgumentNullException("secretName");
            }
            if (password == null)
            {
                throw new ArgumentNullException("password");
            }
            this.SecretName = secretName;
            this.Password = password;
        }
    }
}
