// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models;

namespace Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models
{
    /// <summary>
    /// A Data Lake Analytics catalog U-SQL external datasource item.
    /// </summary>
    public partial class USqlExternalDataSource : CatalogItem
    {
        private string _databaseName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the database.
        /// </summary>
        public string DatabaseName
        {
            get { return this._databaseName; }
            set { this._databaseName = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the external data source.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _provider;
        
        /// <summary>
        /// Optional. Gets or sets the name of the provider for the external
        /// data source.
        /// </summary>
        public string Provider
        {
            get { return this._provider; }
            set { this._provider = value; }
        }
        
        private string _providerString;
        
        /// <summary>
        /// Optional. Gets or sets the name of the provider string for the
        /// external data source.
        /// </summary>
        public string ProviderString
        {
            get { return this._providerString; }
            set { this._providerString = value; }
        }
        
        private IList<string> _pushdownTypes;
        
        /// <summary>
        /// Optional. Gets or sets the list of types to push down from the
        /// external data source.
        /// </summary>
        public IList<string> PushdownTypes
        {
            get { return this._pushdownTypes; }
            set { this._pushdownTypes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the USqlExternalDataSource class.
        /// </summary>
        public USqlExternalDataSource()
        {
            this.PushdownTypes = new LazyList<string>();
        }
    }
}
