// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models;

namespace Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models
{
    /// <summary>
    /// A Data Lake Analytics catalog U-SQL table index item.
    /// </summary>
    public partial class USqlIndex
    {
        private IList<string> _columns;
        
        /// <summary>
        /// Optional. Gets or sets the list of columns in the index
        /// </summary>
        public IList<string> Columns
        {
            get { return this._columns; }
            set { this._columns = value; }
        }
        
        private USqlDistributionInfo _distributionInfo;
        
        /// <summary>
        /// Optional. Gets or sets the distributions info of the index
        /// </summary>
        public USqlDistributionInfo DistributionInfo
        {
            get { return this._distributionInfo; }
            set { this._distributionInfo = value; }
        }
        
        private int? _indexId;
        
        /// <summary>
        /// Optional. Gets or sets the ID of this index within the table.
        /// </summary>
        public int? IndexId
        {
            get { return this._indexId; }
            set { this._indexId = value; }
        }
        
        private IList<USqlDirectedColumn> _indexKeys;
        
        /// <summary>
        /// Optional. Gets or sets the list of directed columns in the index
        /// </summary>
        public IList<USqlDirectedColumn> IndexKeys
        {
            get { return this._indexKeys; }
            set { this._indexKeys = value; }
        }
        
        private bool? _isCoIsUniquelumnstore;
        
        /// <summary>
        /// Optional. Gets or sets the switch indicating if this index is a
        /// unique index.
        /// </summary>
        public bool? IsCoIsUniquelumnstore
        {
            get { return this._isCoIsUniquelumnstore; }
            set { this._isCoIsUniquelumnstore = value; }
        }
        
        private bool? _isColumnstore;
        
        /// <summary>
        /// Optional. Gets or sets the switch indicating if this index is a
        /// columnstore index.
        /// </summary>
        public bool? IsColumnstore
        {
            get { return this._isColumnstore; }
            set { this._isColumnstore = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the index in the table.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private System.Guid? _partitionFunction;
        
        /// <summary>
        /// Optional. Gets or sets partition function ID for the index.
        /// </summary>
        public System.Guid? PartitionFunction
        {
            get { return this._partitionFunction; }
            set { this._partitionFunction = value; }
        }
        
        private IList<string> _partitionKeyList;
        
        /// <summary>
        /// Optional. Gets or sets the list of partion keys in the index
        /// </summary>
        public IList<string> PartitionKeyList
        {
            get { return this._partitionKeyList; }
            set { this._partitionKeyList = value; }
        }
        
        private IList<string> _streamNames;
        
        /// <summary>
        /// Optional. Gets or sets the list of full paths to the streams that
        /// contain this index in the DataLake account.
        /// </summary>
        public IList<string> StreamNames
        {
            get { return this._streamNames; }
            set { this._streamNames = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the USqlIndex class.
        /// </summary>
        public USqlIndex()
        {
            this.Columns = new LazyList<string>();
            this.IndexKeys = new LazyList<USqlDirectedColumn>();
            this.PartitionKeyList = new LazyList<string>();
            this.StreamNames = new LazyList<string>();
        }
    }
}
