// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models;

namespace Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models
{
    /// <summary>
    /// A Data Lake Analytics catalog U-SQL secret item.
    /// </summary>
    public partial class USqlSecret : CatalogItem
    {
        private System.DateTimeOffset? _creationTime;
        
        /// <summary>
        /// Optional. Gets or sets the creation time of the credential object.
        /// This is the only information returned about a secret from a GET.
        /// </summary>
        public System.DateTimeOffset? CreationTime
        {
            get { return this._creationTime; }
            set { this._creationTime = value; }
        }
        
        private string _databaseName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the database.
        /// </summary>
        public string DatabaseName
        {
            get { return this._databaseName; }
            set { this._databaseName = value; }
        }
        
        private Guid _identity;
        
        /// <summary>
        /// Optional. Gets or sets the Identity of the secret.
        /// </summary>
        public Guid Identity
        {
            get { return this._identity; }
            set { this._identity = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the secret.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _userName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the user who set the secret.
        /// </summary>
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the USqlSecret class.
        /// </summary>
        public USqlSecret()
        {
        }
    }
}
