// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models;

namespace Microsoft.Azure.Management.DataLake.AnalyticsCatalog.Models
{
    /// <summary>
    /// A Data Lake Analytics catalog U-SQL table statistics item.
    /// </summary>
    public partial class USqlTableStatistics : CatalogItem
    {
        private IList<string> _colNames;
        
        /// <summary>
        /// Optional. Gets or sets the list of column names associated with
        /// these statistics.
        /// </summary>
        public IList<string> ColNames
        {
            get { return this._colNames; }
            set { this._colNames = value; }
        }
        
        private System.DateTimeOffset? _createTime;
        
        /// <summary>
        /// Optional. Gets or sets the creation time of the statistics.
        /// </summary>
        public System.DateTimeOffset? CreateTime
        {
            get { return this._createTime; }
            set { this._createTime = value; }
        }
        
        private string _databaseName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the database.
        /// </summary>
        public string DatabaseName
        {
            get { return this._databaseName; }
            set { this._databaseName = value; }
        }
        
        private string _filterDefinition;
        
        /// <summary>
        /// Optional. Gets or sets the filter definition for the statistics.
        /// </summary>
        public string FilterDefinition
        {
            get { return this._filterDefinition; }
            set { this._filterDefinition = value; }
        }
        
        private bool _hasFilter;
        
        /// <summary>
        /// Optional. Gets or sets the switch indicating if these statistics
        /// have a filter.
        /// </summary>
        public bool HasFilter
        {
            get { return this._hasFilter; }
            set { this._hasFilter = value; }
        }
        
        private bool _isAutoCreated;
        
        /// <summary>
        /// Optional. Gets or sets the switch indicating if these statistics
        /// are automatically created.
        /// </summary>
        public bool IsAutoCreated
        {
            get { return this._isAutoCreated; }
            set { this._isAutoCreated = value; }
        }
        
        private bool _isUserCreated;
        
        /// <summary>
        /// Optional. Gets or sets the switch indicating if these statistics
        /// are user created.
        /// </summary>
        public bool IsUserCreated
        {
            get { return this._isUserCreated; }
            set { this._isUserCreated = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the table statistics.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _schemaName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the schema associated with this
        /// table and database.
        /// </summary>
        public string SchemaName
        {
            get { return this._schemaName; }
            set { this._schemaName = value; }
        }
        
        private string _statDataPath;
        
        /// <summary>
        /// Optional. Gets or sets the path to the statistics data.
        /// </summary>
        public string StatDataPath
        {
            get { return this._statDataPath; }
            set { this._statDataPath = value; }
        }
        
        private string _tableName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the table.
        /// </summary>
        public string TableName
        {
            get { return this._tableName; }
            set { this._tableName = value; }
        }
        
        private System.DateTimeOffset? _updateTime;
        
        /// <summary>
        /// Optional. Gets or sets the last time the statistics were updated.
        /// </summary>
        public System.DateTimeOffset? UpdateTime
        {
            get { return this._updateTime; }
            set { this._updateTime = value; }
        }
        
        private string _userStatName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the user statistics.
        /// </summary>
        public string UserStatName
        {
            get { return this._userStatName; }
            set { this._userStatName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the USqlTableStatistics class.
        /// </summary>
        public USqlTableStatistics()
        {
            this.ColNames = new LazyList<string>();
        }
    }
}
