// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// A Data Lake Analytics U-SQL job diagnostics information item.
    /// </summary>
    public partial class Diagnostics
    {
        private int _columnNumber;
        
        /// <summary>
        /// Optional. Gets or sets the Column where the error occured.
        /// </summary>
        public int ColumnNumber
        {
            get { return this._columnNumber; }
            set { this._columnNumber = value; }
        }
        
        private int _end;
        
        /// <summary>
        /// Optional. Gets or sets the ending index of the error.
        /// </summary>
        public int End
        {
            get { return this._end; }
            set { this._end = value; }
        }
        
        private int _lineNumber;
        
        /// <summary>
        /// Optional. Gets or sets the line number the error occured on.
        /// </summary>
        public int LineNumber
        {
            get { return this._lineNumber; }
            set { this._lineNumber = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Optional. Gets or sets the error message.
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private string _severity;
        
        /// <summary>
        /// Optional. Gets or sets the severity of the error.
        /// </summary>
        public string Severity
        {
            get { return this._severity; }
            set { this._severity = value; }
        }
        
        private int _start;
        
        /// <summary>
        /// Optional. Gets or sets the starting index of the error.
        /// </summary>
        public int Start
        {
            get { return this._start; }
            set { this._start = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Diagnostics class.
        /// </summary>
        public Diagnostics()
        {
        }
    }
}
