// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// A Data Lake Analytics Hive job statement information item.
    /// </summary>
    public partial class HiveJobStatementInfo
    {
        private string _errorMessage;
        
        /// <summary>
        /// Optional. Gets or sets the error message for this statement.
        /// </summary>
        public string ErrorMessage
        {
            get { return this._errorMessage; }
            set { this._errorMessage = value; }
        }
        
        private string _logLocation;
        
        /// <summary>
        /// Optional. Gets or sets the log location for this statement.
        /// </summary>
        public string LogLocation
        {
            get { return this._logLocation; }
            set { this._logLocation = value; }
        }
        
        private string _resultLocation;
        
        /// <summary>
        /// Optional. Gets or sets the result location for this statement.
        /// </summary>
        public string ResultLocation
        {
            get { return this._resultLocation; }
            set { this._resultLocation = value; }
        }
        
        private string _resultPreviewLocation;
        
        /// <summary>
        /// Optional. Gets or sets the result preview location for this
        /// statement.
        /// </summary>
        public string ResultPreviewLocation
        {
            get { return this._resultPreviewLocation; }
            set { this._resultPreviewLocation = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HiveJobStatementInfo class.
        /// </summary>
        public HiveJobStatementInfo()
        {
        }
    }
}
