// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataLake.AnalyticsJob.Models;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// A Data Lake Analytics Hive job properties item.
    /// </summary>
    public partial class HiveProperties : JobProperties
    {
        private int? _executedStatementCount;
        
        /// <summary>
        /// Optional. Gets or sets the number of statements that have been run
        /// based on the script
        /// </summary>
        public int? ExecutedStatementCount
        {
            get { return this._executedStatementCount; }
            set { this._executedStatementCount = value; }
        }
        
        private string _logsLocation;
        
        /// <summary>
        /// Optional. Gets or sets the Hive logs location
        /// </summary>
        public string LogsLocation
        {
            get { return this._logsLocation; }
            set { this._logsLocation = value; }
        }
        
        private int? _statementCount;
        
        /// <summary>
        /// Optional. Gets or sets the number of statements that will be run
        /// based on the script
        /// </summary>
        public int? StatementCount
        {
            get { return this._statementCount; }
            set { this._statementCount = value; }
        }
        
        private IList<HiveJobStatementInfo> _statementInfo;
        
        /// <summary>
        /// Optional. Gets or sets the statement information for each statement
        /// in the script
        /// </summary>
        public IList<HiveJobStatementInfo> StatementInfo
        {
            get { return this._statementInfo; }
            set { this._statementInfo = value; }
        }
        
        private string _warehouseLocation;
        
        /// <summary>
        /// Optional. Gets or sets the Hive warehouse location
        /// </summary>
        public string WarehouseLocation
        {
            get { return this._warehouseLocation; }
            set { this._warehouseLocation = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HiveProperties class.
        /// </summary>
        public HiveProperties()
        {
            this.StatementInfo = new LazyList<HiveJobStatementInfo>();
        }
        
        /// <summary>
        /// Initializes a new instance of the HiveProperties class with
        /// required arguments.
        /// </summary>
        public HiveProperties(string script)
            : this()
        {
            if (script == null)
            {
                throw new ArgumentNullException("script");
            }
            this.Script = script;
        }
    }
}
