// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// A Data Lake Analytics U-SQL job data path item.
    /// </summary>
    public partial class JobDataPath
    {
        private string _command;
        
        /// <summary>
        /// Optional. Gets or sets the command that this job data relates to.
        /// </summary>
        public string Command
        {
            get { return this._command; }
            set { this._command = value; }
        }
        
        private Guid _jobId;
        
        /// <summary>
        /// Optional. Gets or sets the id of the job this data is for.
        /// </summary>
        public Guid JobId
        {
            get { return this._jobId; }
            set { this._jobId = value; }
        }
        
        private IList<string> _paths;
        
        /// <summary>
        /// Optional. Gets or sets the list of paths to all of the job data.
        /// </summary>
        public IList<string> Paths
        {
            get { return this._paths; }
            set { this._paths = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobDataPath class.
        /// </summary>
        public JobDataPath()
        {
            this.Paths = new LazyList<string>();
        }
    }
}
