// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// The Data Lake Analytics job error details.
    /// </summary>
    public partial class JobErrorDetails
    {
        private string _description;
        
        /// <summary>
        /// Optional. Gets or sets the error message description
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private string _details;
        
        /// <summary>
        /// Optional. Gets or sets the details of the error message.
        /// </summary>
        public string Details
        {
            get { return this._details; }
            set { this._details = value; }
        }
        
        private int? _endOffset;
        
        /// <summary>
        /// Optional. Gets or sets the end offset in the job where the error
        /// was found.
        /// </summary>
        public int? EndOffset
        {
            get { return this._endOffset; }
            set { this._endOffset = value; }
        }
        
        private string _errorId;
        
        /// <summary>
        /// Optional. Gets or sets the specific identifier for the type of
        /// error encountered in the job.
        /// </summary>
        public string ErrorId
        {
            get { return this._errorId; }
            set { this._errorId = value; }
        }
        
        private string _filePath;
        
        /// <summary>
        /// Optional. Gets or sets the path to any supplemental error files, if
        /// any.
        /// </summary>
        public string FilePath
        {
            get { return this._filePath; }
            set { this._filePath = value; }
        }
        
        private string _helpLink;
        
        /// <summary>
        /// Optional. Gets or sets the link to MSDN or Azure help for this type
        /// of error, if any.
        /// </summary>
        public string HelpLink
        {
            get { return this._helpLink; }
            set { this._helpLink = value; }
        }
        
        private string _internalDiagnostics;
        
        /// <summary>
        /// Optional. Gets or sets the internal diagnostic stack trace if the
        /// user requesting the job error details has sufficient permissions
        /// it will be retrieved, otherwise it will be empty.
        /// </summary>
        public string InternalDiagnostics
        {
            get { return this._internalDiagnostics; }
            set { this._internalDiagnostics = value; }
        }
        
        private int? _lineNumber;
        
        /// <summary>
        /// Optional. Gets or sets the specific line number in the job where
        /// the error occured.
        /// </summary>
        public int? LineNumber
        {
            get { return this._lineNumber; }
            set { this._lineNumber = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Optional. Gets or sets the user friendly error message for the
        /// failure.
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private string _resolution;
        
        /// <summary>
        /// Optional. Gets or sets the recommended resolution for the failure,
        /// if any.
        /// </summary>
        public string Resolution
        {
            get { return this._resolution; }
            set { this._resolution = value; }
        }
        
        private string _severity;
        
        /// <summary>
        /// Optional. Gets or sets the severity level of the failure.
        /// </summary>
        public string Severity
        {
            get { return this._severity; }
            set { this._severity = value; }
        }
        
        private string _source;
        
        /// <summary>
        /// Optional. Gets or sets the ultimate source of the failure (usually
        /// either SYSTEM or USER).
        /// </summary>
        public string Source
        {
            get { return this._source; }
            set { this._source = value; }
        }
        
        private string _startOffset;
        
        /// <summary>
        /// Optional. Gets or sets the end offset in the job where the error
        /// was found
        /// </summary>
        public string StartOffset
        {
            get { return this._startOffset; }
            set { this._startOffset = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobErrorDetails class.
        /// </summary>
        public JobErrorDetails()
        {
        }
    }
}
