// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// Job information parameters for listing jobs.
    /// </summary>
    public partial class JobListParameters
    {
        private string _filter;
        
        /// <summary>
        /// Optional. Gets or sets OData filter. Optional.
        /// </summary>
        public string Filter
        {
            get { return this._filter; }
            set { this._filter = value; }
        }
        
        private string _orderBy;
        
        /// <summary>
        /// Optional. Gets or sets OData orderBy clause. Optional.
        /// </summary>
        public string OrderBy
        {
            get { return this._orderBy; }
            set { this._orderBy = value; }
        }
        
        private string _select;
        
        /// <summary>
        /// Optional. Gets or sets OData selection criteria, which is a comma
        /// delimited list of properties to select (e.g. 'name,id,type').
        /// Optional.
        /// </summary>
        public string Select
        {
            get { return this._select; }
            set { this._select = value; }
        }
        
        private int? _skip;
        
        /// <summary>
        /// Optional. Gets or sets the number of items to skip over before
        /// returning elements. Optional.
        /// </summary>
        public int? Skip
        {
            get { return this._skip; }
            set { this._skip = value; }
        }
        
        private int? _top;
        
        /// <summary>
        /// Optional. Gets or sets the number of items to return. Optional.
        /// </summary>
        public int? Top
        {
            get { return this._top; }
            set { this._top = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobListParameters class.
        /// </summary>
        public JobListParameters()
        {
        }
    }
}
