// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// The Data Lake Analytics U-SQL job state audit records for tracking the
    /// lifecycle of a job.
    /// </summary>
    public partial class JobStateAuditRecord
    {
        private string _details;
        
        /// <summary>
        /// Optional. Gets or sets  the details of the audit log.
        /// </summary>
        public string Details
        {
            get { return this._details; }
            set { this._details = value; }
        }
        
        private string _newState;
        
        /// <summary>
        /// Optional. Gets or sets the new state the job is in.
        /// </summary>
        public string NewState
        {
            get { return this._newState; }
            set { this._newState = value; }
        }
        
        private string _requestedByUser;
        
        /// <summary>
        /// Optional. Gets or sets the user who requests the change.
        /// </summary>
        public string RequestedByUser
        {
            get { return this._requestedByUser; }
            set { this._requestedByUser = value; }
        }
        
        private DateTimeOffset _timeStamp;
        
        /// <summary>
        /// Optional. Gets or sets the time stamp that the state change took
        /// place.
        /// </summary>
        public DateTimeOffset TimeStamp
        {
            get { return this._timeStamp; }
            set { this._timeStamp = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobStateAuditRecord class.
        /// </summary>
        public JobStateAuditRecord()
        {
        }
    }
}
