// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataLake.AnalyticsJob.Models;

namespace Microsoft.Azure.Management.DataLake.AnalyticsJob.Models
{
    /// <summary>
    /// The Data Lake Analytics U-SQL job execution statistics.
    /// </summary>
    public partial class JobStatistics
    {
        private DateTimeOffset _lastUpdateTimeUtc;
        
        /// <summary>
        /// Optional. Gets or sets the last update time for the statistics.
        /// </summary>
        public DateTimeOffset LastUpdateTimeUtc
        {
            get { return this._lastUpdateTimeUtc; }
            set { this._lastUpdateTimeUtc = value; }
        }
        
        private IList<JobStatisticsVertexStage> _stages;
        
        /// <summary>
        /// Optional. Gets or sets the list of stages for the job.
        /// </summary>
        public IList<JobStatisticsVertexStage> Stages
        {
            get { return this._stages; }
            set { this._stages = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobStatistics class.
        /// </summary>
        public JobStatistics()
        {
            this.Stages = new LazyList<JobStatisticsVertexStage>();
        }
    }
}
