// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataLake.Store.Models;

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    /// <summary>
    /// Data Lake Store account properties information
    /// </summary>
    public partial class DataLakeStoreAccountProperties
    {
        private DateTime _creationTime;
        
        /// <summary>
        /// Optional. Gets or sets the account creation time.
        /// </summary>
        public DateTime CreationTime
        {
            get { return this._creationTime; }
            set { this._creationTime = value; }
        }
        
        private string _defaultGroup;
        
        /// <summary>
        /// Optional. Gets or sets the default owner group for all new folders
        /// and files created in the DataLake.
        /// </summary>
        public string DefaultGroup
        {
            get { return this._defaultGroup; }
            set { this._defaultGroup = value; }
        }
        
        private string _endpoint;
        
        /// <summary>
        /// Optional. Gets or sets the gateway host.
        /// </summary>
        public string Endpoint
        {
            get { return this._endpoint; }
            set { this._endpoint = value; }
        }
        
        private DateTime _lastModifiedTime;
        
        /// <summary>
        /// Optional. Gets or sets the account last modified time.
        /// </summary>
        public DateTime LastModifiedTime
        {
            get { return this._lastModifiedTime; }
            set { this._lastModifiedTime = value; }
        }
        
        private Microsoft.Azure.Management.DataLake.Store.Models.DataLakeStoreAccountStatus? _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets the status of the Data Lake Store account
        /// while being provisioned.
        /// </summary>
        public Microsoft.Azure.Management.DataLake.Store.Models.DataLakeStoreAccountStatus? ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private Microsoft.Azure.Management.DataLake.Store.Models.DataLakeStoreAccountState? _state;
        
        /// <summary>
        /// Optional. Gets or sets the status of the Data Lake Account after
        /// provisioning has completed.
        /// </summary>
        public Microsoft.Azure.Management.DataLake.Store.Models.DataLakeStoreAccountState? State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DataLakeStoreAccountProperties
        /// class.
        /// </summary>
        public DataLakeStoreAccountProperties()
        {
        }
    }
}
