// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataLake.Store.Models;

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    /// <summary>
    /// Data Lake firewall rule information
    /// </summary>
    public partial class FirewallRule
    {
        private string _id;
        
        /// <summary>
        /// Optional. Gets or sets the Firewall Rule's subscription ID.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Optional. Gets or sets the Firewall Rule's regional location.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the Firewall Rule's name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private FirewallRuleProperties _properties;
        
        /// <summary>
        /// Optional. Gets or sets the properties defined by Data Lake all
        /// properties are specific to each resource provider.
        /// </summary>
        public FirewallRuleProperties Properties
        {
            get { return this._properties; }
            set { this._properties = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. Gets or sets the namespace and type of the Firewall Rule.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the FirewallRule class.
        /// </summary>
        public FirewallRule()
        {
        }
    }
}
