// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.DataLake.StoreFileSystem.Models
{
    /// <summary>
    /// Data Lake ACL status information
    /// </summary>
    public partial class AclStatus
    {
        private IList<string> _entries;
        
        /// <summary>
        /// Optional. Gets or sets the list of ACLSpec entries on a file or
        /// folder.
        /// </summary>
        public IList<string> Entries
        {
            get { return this._entries; }
            set { this._entries = value; }
        }
        
        private string _group;
        
        /// <summary>
        /// Optional. Gets or sets the group owner.
        /// </summary>
        public string Group
        {
            get { return this._group; }
            set { this._group = value; }
        }
        
        private string _owner;
        
        /// <summary>
        /// Optional. Gets or sets the user who is the owner.
        /// </summary>
        public string Owner
        {
            get { return this._owner; }
            set { this._owner = value; }
        }
        
        private bool _stickyBit;
        
        /// <summary>
        /// Optional. Gets or sets the indicator of whether the sticky bit is
        /// on or off.
        /// </summary>
        public bool StickyBit
        {
            get { return this._stickyBit; }
            set { this._stickyBit = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AclStatus class.
        /// </summary>
        public AclStatus()
        {
            this.Entries = new LazyList<string>();
        }
    }
}
