// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.StoreFileSystem.Models
{
    /// <summary>
    /// Data Lake content summary information
    /// </summary>
    public partial class ContentSummary
    {
        private long _directoryCount;
        
        /// <summary>
        /// Optional. Gets or sets the number of directories.
        /// </summary>
        public long DirectoryCount
        {
            get { return this._directoryCount; }
            set { this._directoryCount = value; }
        }
        
        private long _fileCount;
        
        /// <summary>
        /// Optional. Gets or sets the number of files.
        /// </summary>
        public long FileCount
        {
            get { return this._fileCount; }
            set { this._fileCount = value; }
        }
        
        private long _length;
        
        /// <summary>
        /// Optional. Gets or sets the number of bytes used by the contet.
        /// </summary>
        public long Length
        {
            get { return this._length; }
            set { this._length = value; }
        }
        
        private long _quota;
        
        /// <summary>
        /// Optional. Gets or sets the namespace quota of this directory.
        /// </summary>
        public long Quota
        {
            get { return this._quota; }
            set { this._quota = value; }
        }
        
        private long _spaceConsumed;
        
        /// <summary>
        /// Optional. Gets or sets the disk space consumed by the content.
        /// </summary>
        public long SpaceConsumed
        {
            get { return this._spaceConsumed; }
            set { this._spaceConsumed = value; }
        }
        
        private long _spaceQuota;
        
        /// <summary>
        /// Optional. Gets or sets the disk space quota.
        /// </summary>
        public long SpaceQuota
        {
            get { return this._spaceQuota; }
            set { this._spaceQuota = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ContentSummary class.
        /// </summary>
        public ContentSummary()
        {
        }
    }
}
