// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.StoreFileSystem.Models
{
    /// <summary>
    /// Parameters used when creating a file
    /// </summary>
    public partial class FileCreateParameters
    {
        private long? _blockSize;
        
        /// <summary>
        /// Optional. Gets or sets the block size of a file, in bytes
        /// </summary>
        public long? BlockSize
        {
            get { return this._blockSize; }
            set { this._blockSize = value; }
        }
        
        private long? _bufferSize;
        
        /// <summary>
        /// Optional. Gets or sets the size of the buffer used in transferring
        /// data.
        /// </summary>
        public long? BufferSize
        {
            get { return this._bufferSize; }
            set { this._bufferSize = value; }
        }
        
        private bool? _overwrite;
        
        /// <summary>
        /// Optional. Gets or sets the indication of if the file should be
        /// overwritten
        /// </summary>
        public bool? Overwrite
        {
            get { return this._overwrite; }
            set { this._overwrite = value; }
        }
        
        private string _permission;
        
        /// <summary>
        /// Optional. Gets or sets the permissions of a file or directory
        /// </summary>
        public string Permission
        {
            get { return this._permission; }
            set { this._permission = value; }
        }
        
        private short? _replication;
        
        /// <summary>
        /// Optional. Gets or sets the number of replications of a file
        /// </summary>
        public short? Replication
        {
            get { return this._replication; }
            set { this._replication = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the FileCreateParameters class.
        /// </summary>
        public FileCreateParameters()
        {
        }
    }
}
