// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataLake.StoreFileSystem.Models
{
    /// <summary>
    /// Parameters used when opening a file for read
    /// </summary>
    public partial class FileOpenParameters
    {
        private long? _bufferSize;
        
        /// <summary>
        /// Optional. Gets or sets the size of the buffer used when
        /// transferring data
        /// </summary>
        public long? BufferSize
        {
            get { return this._bufferSize; }
            set { this._bufferSize = value; }
        }
        
        private long? _length;
        
        /// <summary>
        /// Optional. Gets or sets the length of the file that should be read,
        /// in bytes
        /// </summary>
        public long? Length
        {
            get { return this._length; }
            set { this._length = value; }
        }
        
        private long? _offset;
        
        /// <summary>
        /// Optional. Gets or sets the offset to begin reading the file at
        /// </summary>
        public long? Offset
        {
            get { return this._offset; }
            set { this._offset = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the FileOpenParameters class.
        /// </summary>
        public FileOpenParameters()
        {
        }
    }
}
