// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Dns.Models
{
    /// <summary>
    /// An SRV record.
    /// </summary>
    public partial class SrvRecord
    {
        private int _port;
        
        /// <summary>
        /// Required. Gets or sets the port of the service for this record.
        /// </summary>
        public int Port
        {
            get { return this._port; }
            set { this._port = value; }
        }
        
        private int _priority;
        
        /// <summary>
        /// Required. Gets or sets the priority metric for this record.
        /// </summary>
        public int Priority
        {
            get { return this._priority; }
            set { this._priority = value; }
        }
        
        private string _target;
        
        /// <summary>
        /// Required. Gets or sets the domain name of the target for this
        /// record, without a terminating dot.
        /// </summary>
        public string Target
        {
            get { return this._target; }
            set { this._target = value; }
        }
        
        private int _weight;
        
        /// <summary>
        /// Required. Gets or sets the weight metric for this this record.
        /// </summary>
        public int Weight
        {
            get { return this._weight; }
            set { this._weight = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SrvRecord class.
        /// </summary>
        public SrvRecord()
        {
        }
    }
}
