﻿// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

namespace Microsoft.Azure.Management.HDInsight
{
    public static class ConfigurationKey
    {
        /// <summary>
        /// The constant for Core site configs.
        /// </summary>
        public const string CoreSite = "core-site";

        /// <summary>
        /// The constant for Hive site configs.
        /// </summary>
        public const string HiveSite = "hive-site";

        /// <summary>
        /// The constant for hive environment configs.
        /// </summary>
        public const string HiveEnv = "hive-env";

        /// <summary>
        /// The constant for Oozie site configs.
        /// </summary>
        public const string OozieSite = "oozie-site";

        /// <summary>
        /// The constant for Oozie environment configs.
        /// </summary>
        public const string OozieEnv = "oozie-env";

        /// <summary>
        /// The constant for WebHCAT site configs.
        /// </summary>
        public const string WebHCatSite = "webhcat-site";

        /// <summary>
        /// The constant for HBase environment configs.
        /// </summary>
        public const string HBaseEnv = "hbase-env";

        /// <summary>
        /// The constant for HBase site configs.
        /// </summary>
        public const string HBaseSite = "hbase-site";

        /// <summary>
        /// The constant for Storm site configs.
        /// </summary>
        public const string StormSite = "storm-site";

        /// <summary>
        /// The constant for Yarn site configs.
        /// </summary>
        public const string YarnSite = "yarn-site";

        /// <summary>
        /// The constant for MapRed site configs.
        /// </summary>
        public const string MapRedSite = "mapred-site";

        /// <summary>
        /// The constant for Tez site configs.
        /// </summary>
        public const string TezSite = "tez-site";

        /// <summary>
        /// The constant for HDFS site configs.
        /// </summary>
        public const string HdfsSite = "hdfs-site";

        /// <summary>
        /// The constant for Gateway configs.
        /// </summary>
        public const string Gateway = "gateway";

        /// <summary>
        /// The constant for cluster identity configs.
        /// </summary>
        public const string ClusterIdentity = "clusterIdentity";
    }
}
