// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.HDInsight.Models;

namespace Microsoft.Azure.Management.HDInsight.Models
{
    /// <summary>
    /// The Get Capabilities operation response.
    /// </summary>
    public partial class CapabilitiesResponse : HDInsightOperationResponse
    {
        private IList<string> _features;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public IList<string> Features
        {
            get { return this._features; }
            set { this._features = value; }
        }
        
        private QuotaCapability _quotaCapability;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public QuotaCapability QuotaCapability
        {
            get { return this._quotaCapability; }
            set { this._quotaCapability = value; }
        }
        
        private IDictionary<string, RegionsCapability> _regions;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public IDictionary<string, RegionsCapability> Regions
        {
            get { return this._regions; }
            set { this._regions = value; }
        }
        
        private IDictionary<string, VersionsCapability> _versions;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public IDictionary<string, VersionsCapability> Versions
        {
            get { return this._versions; }
            set { this._versions = value; }
        }
        
        private IList<VmSizeCompatibilityFilter> _vmSizeCompatibilityFilters;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public IList<VmSizeCompatibilityFilter> VmSizeCompatibilityFilters
        {
            get { return this._vmSizeCompatibilityFilters; }
            set { this._vmSizeCompatibilityFilters = value; }
        }
        
        private IDictionary<string, VmSizesCapability> _vmSizes;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public IDictionary<string, VmSizesCapability> VmSizes
        {
            get { return this._vmSizes; }
            set { this._vmSizes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CapabilitiesResponse class.
        /// </summary>
        public CapabilitiesResponse()
        {
            this.Features = new LazyList<string>();
            this.Regions = new LazyDictionary<string, RegionsCapability>();
            this.Versions = new LazyDictionary<string, VersionsCapability>();
            this.VmSizeCompatibilityFilters = new LazyList<VmSizeCompatibilityFilter>();
            this.VmSizes = new LazyDictionary<string, VmSizesCapability>();
        }
    }
}
