// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.HDInsight.Models;

namespace Microsoft.Azure.Management.HDInsight.Models
{
    /// <summary>
    /// Describes the properties of a cluster.
    /// </summary>
    public partial class ClusterGetProperties
    {
        private ClusterDefinition _clusterDefinition;
        
        /// <summary>
        /// Required. Gets or sets the cluster definition.
        /// </summary>
        public ClusterDefinition ClusterDefinition
        {
            get { return this._clusterDefinition; }
            set { this._clusterDefinition = value; }
        }
        
        private string _clusterState;
        
        /// <summary>
        /// Optional. Gets or sets the state of the cluster.
        /// </summary>
        public string ClusterState
        {
            get { return this._clusterState; }
            set { this._clusterState = value; }
        }
        
        private Tier _clusterTier;
        
        /// <summary>
        /// Optional. Gets or sets the cluster tier.
        /// </summary>
        public Tier ClusterTier
        {
            get { return this._clusterTier; }
            set { this._clusterTier = value; }
        }
        
        private string _clusterVersion;
        
        /// <summary>
        /// Optional. Gets or sets the version of the cluster.
        /// </summary>
        public string ClusterVersion
        {
            get { return this._clusterVersion; }
            set { this._clusterVersion = value; }
        }
        
        private ComputeProfile _computeProfile;
        
        /// <summary>
        /// Optional. Gets or sets the compute profile.
        /// </summary>
        public ComputeProfile ComputeProfile
        {
            get { return this._computeProfile; }
            set { this._computeProfile = value; }
        }
        
        private IList<ConnectivityEndpoint> _connectivityEndpoints;
        
        /// <summary>
        /// Optional. Gets or sets the list of connectivity endpoints.
        /// </summary>
        public IList<ConnectivityEndpoint> ConnectivityEndpoints
        {
            get { return this._connectivityEndpoints; }
            set { this._connectivityEndpoints = value; }
        }
        
        private DateTime _createdDate;
        
        /// <summary>
        /// Optional. Gets or sets the date on which the cluster was created.
        /// </summary>
        public DateTime CreatedDate
        {
            get { return this._createdDate; }
            set { this._createdDate = value; }
        }
        
        private IList<ErrorInfo> _errorInfos;
        
        /// <summary>
        /// Optional. Gets or sets the list of errors.
        /// </summary>
        public IList<ErrorInfo> ErrorInfos
        {
            get { return this._errorInfos; }
            set { this._errorInfos = value; }
        }
        
        private OSType _operatingSystemType;
        
        /// <summary>
        /// Optional. Gets or sets the type of operating system.
        /// </summary>
        public OSType OperatingSystemType
        {
            get { return this._operatingSystemType; }
            set { this._operatingSystemType = value; }
        }
        
        private HDInsightClusterProvisioningState _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets the provisioning state, which only appears
        /// in the response.
        /// </summary>
        public HDInsightClusterProvisioningState ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private QuotaInfo _quotaInfo;
        
        /// <summary>
        /// Optional. Gets or sets the quota information.
        /// </summary>
        public QuotaInfo QuotaInfo
        {
            get { return this._quotaInfo; }
            set { this._quotaInfo = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ClusterGetProperties class.
        /// </summary>
        public ClusterGetProperties()
        {
            this.ConnectivityEndpoints = new LazyList<ConnectivityEndpoint>();
            this.ErrorInfos = new LazyList<ErrorInfo>();
        }
        
        /// <summary>
        /// Initializes a new instance of the ClusterGetProperties class with
        /// required arguments.
        /// </summary>
        public ClusterGetProperties(ClusterDefinition clusterDefinition)
            : this()
        {
            if (clusterDefinition == null)
            {
                throw new ArgumentNullException("clusterDefinition");
            }
            this.ClusterDefinition = clusterDefinition;
        }
    }
}
