// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.HDInsight.Models;

namespace Microsoft.Azure.Management.HDInsight.Models
{
    /// <summary>
    /// Describes the script actions on a running cluster.
    /// </summary>
    public partial class ExecuteScriptActionParameters
    {
        private bool _persistOnSuccess;
        
        /// <summary>
        /// Required. Gets or sets if the scripts needs to be persisted.
        /// </summary>
        public bool PersistOnSuccess
        {
            get { return this._persistOnSuccess; }
            set { this._persistOnSuccess = value; }
        }
        
        private IList<RuntimeScriptAction> _scriptActions;
        
        /// <summary>
        /// Optional. Gets or sets the list of run time script actions.
        /// </summary>
        public IList<RuntimeScriptAction> ScriptActions
        {
            get { return this._scriptActions; }
            set { this._scriptActions = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ExecuteScriptActionParameters
        /// class.
        /// </summary>
        public ExecuteScriptActionParameters()
        {
            this.ScriptActions = new LazyList<RuntimeScriptAction>();
        }
        
        /// <summary>
        /// Initializes a new instance of the ExecuteScriptActionParameters
        /// class with required arguments.
        /// </summary>
        public ExecuteScriptActionParameters(bool persistOnSuccess)
            : this()
        {
            this.PersistOnSuccess = persistOnSuccess;
        }
    }
}
