// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.HDInsight.Models
{
    /// <summary>
    /// The payload for a Configure HTTP settings request.
    /// </summary>
    public partial class HttpSettingsParameters
    {
        private string _httpPassword;
        
        /// <summary>
        /// Optional. Gets or sets the http user password.
        /// </summary>
        public string HttpPassword
        {
            get { return this._httpPassword; }
            set { this._httpPassword = value; }
        }
        
        private bool _httpUserEnabled;
        
        /// <summary>
        /// Required. Gets or sets the whether or not HTTP is enabled.
        /// </summary>
        public bool HttpUserEnabled
        {
            get { return this._httpUserEnabled; }
            set { this._httpUserEnabled = value; }
        }
        
        private string _httpUsername;
        
        /// <summary>
        /// Optional. Gets or sets the http username.
        /// </summary>
        public string HttpUsername
        {
            get { return this._httpUsername; }
            set { this._httpUsername = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HttpSettingsParameters class.
        /// </summary>
        public HttpSettingsParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the HttpSettingsParameters class with
        /// required arguments.
        /// </summary>
        public HttpSettingsParameters(bool httpUserEnabled)
            : this()
        {
            this.HttpUserEnabled = httpUserEnabled;
        }
    }
}
