// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.HDInsight.Models
{
    /// <summary>
    /// Describes a script action on a running cluster.
    /// </summary>
    public partial class RuntimeScriptAction
    {
        private string _applicationName;
        
        /// <summary>
        /// Optional. Gets the application name of the script action, if any.
        /// </summary>
        public string ApplicationName
        {
            get { return this._applicationName; }
            set { this._applicationName = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the name of the script action.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _parameters;
        
        /// <summary>
        /// Optional. Gets or sets the parameters for the script
        /// </summary>
        public string Parameters
        {
            get { return this._parameters; }
            set { this._parameters = value; }
        }
        
        private IList<string> _roles;
        
        /// <summary>
        /// Required. Gets or sets the list of roles where script will be
        /// executed.
        /// </summary>
        public IList<string> Roles
        {
            get { return this._roles; }
            set { this._roles = value; }
        }
        
        private Uri _uri;
        
        /// <summary>
        /// Required. Gets or sets the URI to the script.
        /// </summary>
        public Uri Uri
        {
            get { return this._uri; }
            set { this._uri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RuntimeScriptAction class.
        /// </summary>
        public RuntimeScriptAction()
        {
            this.Roles = new LazyList<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the RuntimeScriptAction class with
        /// required arguments.
        /// </summary>
        public RuntimeScriptAction(string name, Uri uri, IList<string> roles)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (uri == null)
            {
                throw new ArgumentNullException("uri");
            }
            if (roles == null)
            {
                throw new ArgumentNullException("roles");
            }
            this.Name = name;
            this.Uri = uri;
            this.Roles = roles;
        }
    }
}
