// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.HDInsight.Models
{
    /// <summary>
    /// Describes a script action on role on the cluster.
    /// </summary>
    public partial class ScriptAction
    {
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the name of the script action.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _parameters;
        
        /// <summary>
        /// Required. Gets or sets the parameters for the script provided.
        /// </summary>
        public string Parameters
        {
            get { return this._parameters; }
            set { this._parameters = value; }
        }
        
        private Uri _uri;
        
        /// <summary>
        /// Required. Gets or sets the URI to the script.
        /// </summary>
        public Uri Uri
        {
            get { return this._uri; }
            set { this._uri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ScriptAction class.
        /// </summary>
        public ScriptAction()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ScriptAction class with required
        /// arguments.
        /// </summary>
        public ScriptAction(string name, Uri uri, string parameters)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (uri == null)
            {
                throw new ArgumentNullException("uri");
            }
            if (parameters == null)
            {
                throw new ArgumentNullException("parameters");
            }
            this.Name = name;
            this.Uri = uri;
            this.Parameters = parameters;
        }
    }
}
