// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Globalization;
using System.Collections.Generic;

namespace Microsoft.Azure.Management.HDInsight.Job.Models
{
    /// <summary>
    /// State of the application.
    /// </summary>
    internal enum ApplicationState
    {
        Unknown,
        New,
        New_saving,
        Submitted,
        Accepted,
        Running,
        Finished,
        Failed,
        Killed
    };

    /// <summary>
    /// Gets or sets the State of the application.
    /// </summary>
    internal partial class AppState : AzureOperationResponse
    {
        /// <summary>
        /// Gets the state of the Application.
        /// </summary>
        /// <returns>
        /// Return enum ApplicationState.
        /// </returns>
        internal ApplicationState GetState()
        {
            if (String.IsNullOrEmpty(this._state))
            {
                return ApplicationState.Unknown;
            }

            ApplicationState appState;
            if (Enum.TryParse(this._state, true, out appState))
            {
                return appState;
            }

            return ApplicationState.Unknown;
        }
    }
}
