// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.HDInsight.Job;

namespace Microsoft.Azure.Management.HDInsight.Job
{
    /// <summary>
    /// The HDInsight job client manages jobs against HDInsight clusters.
    /// </summary>
    public partial interface IHDInsightJobManagementClient : IDisposable
    {
        /// <summary>
        /// The cluster dns name against which the job management is to be
        /// performed.
        /// </summary>
        string ClusterDnsName
        {
            get; set; 
        }
        
        /// <summary>
        /// Basic authentication credentials for job submission.
        /// </summary>
        BasicAuthenticationCloudCredentials Credentials
        {
            get; set; 
        }
        
        /// <summary>
        /// Gets or sets the SDK UserAgent text to be added to the user agent
        /// header. This is used to further differentiate various SDK versions.
        /// </summary>
        string SdkUserAgent
        {
            get; 
        }
        
        /// <summary>
        /// Gets or sets the additional UserAgent text to be added to the user
        /// agent header. This is used to further differentiate using
        /// applications.
        /// </summary>
        string UserAgentSuffix
        {
            get; set; 
        }
        
        /// <summary>
        /// The user name from Username of BasicAuthenticationCloudCredentials
        /// in lower case used for running job.
        /// </summary>
        string UserName
        {
            get; 
        }
        
        /// <summary>
        /// Operations for managing jobs against HDInsight clusters.
        /// </summary>
        IJobOperations JobManagement
        {
            get; 
        }
    }
}
