// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.HDInsight.Job.Models;

namespace Microsoft.Azure.Management.HDInsight.Job.Models
{
    /// <summary>
    /// Gets or sets the object containing the job details.
    /// </summary>
    public partial class JobDetailRootJsonObject
    {
        private object _callback;
        
        /// <summary>
        /// Optional. Gets or sets the callback URL, if any.
        /// </summary>
        public object Callback
        {
            get { return this._callback; }
            set { this._callback = value; }
        }
        
        private string _completed;
        
        /// <summary>
        /// Optional. Gets or sets the string representing completed status,
        /// for example 'done'.
        /// </summary>
        public string Completed
        {
            get { return this._completed; }
            set { this._completed = value; }
        }
        
        private int _exitValue;
        
        /// <summary>
        /// Optional. Gets or sets the job's exit value.
        /// </summary>
        public int ExitValue
        {
            get { return this._exitValue; }
            set { this._exitValue = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Optional. Gets or sets the job ID.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private object _msg;
        
        /// <summary>
        /// Optional. Gets or sets the message returned.
        /// </summary>
        public object Msg
        {
            get { return this._msg; }
            set { this._msg = value; }
        }
        
        private string _parentId;
        
        /// <summary>
        /// Optional. Gets or sets the parent job ID.
        /// </summary>
        public string ParentId
        {
            get { return this._parentId; }
            set { this._parentId = value; }
        }
        
        private string _percentComplete;
        
        /// <summary>
        /// Optional. Gets or sets the job completion percentage, for example
        /// '75% complete'.
        /// </summary>
        public string PercentComplete
        {
            get { return this._percentComplete; }
            set { this._percentComplete = value; }
        }
        
        private Profile _profile;
        
        /// <summary>
        /// Optional. Gets or sets the object containing the job profile
        /// information.
        /// </summary>
        public Profile Profile
        {
            get { return this._profile; }
            set { this._profile = value; }
        }
        
        private Status _status;
        
        /// <summary>
        /// Optional. Gets or sets the object containing the job status
        /// information.
        /// </summary>
        public Status Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private string _user;
        
        /// <summary>
        /// Optional. Gets or sets the user name of the job creator.
        /// </summary>
        public string User
        {
            get { return this._user; }
            set { this._user = value; }
        }
        
        private Userargs _userargs;
        
        /// <summary>
        /// Optional. Gets or sets the arguments passed in by the user.
        /// </summary>
        public Userargs Userargs
        {
            get { return this._userargs; }
            set { this._userargs = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobDetailRootJsonObject class.
        /// </summary>
        public JobDetailRootJsonObject()
        {
        }
    }
}
