// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.HDInsight.Job.Models;

namespace Microsoft.Azure.Management.HDInsight.Job.Models
{
    /// <summary>
    /// Gets or sets the object containing the job profile information.
    /// </summary>
    public partial class Profile
    {
        private string _jobFile;
        
        /// <summary>
        /// Optional. Gets or sets the job configuration file.
        /// </summary>
        public string JobFile
        {
            get { return this._jobFile; }
            set { this._jobFile = value; }
        }
        
        private string _jobId;
        
        /// <summary>
        /// Optional. Gets or sets the full ID of the job.
        /// </summary>
        public string JobId
        {
            get { return this._jobId; }
            set { this._jobId = value; }
        }
        
        private JobID _jobID;
        
        /// <summary>
        /// Optional. Gets or sets the ID of the job.
        /// </summary>
        public JobID JobID
        {
            get { return this._jobID; }
            set { this._jobID = value; }
        }
        
        private string _jobName;
        
        /// <summary>
        /// Optional. Gets or sets the user-specified job name.
        /// </summary>
        public string JobName
        {
            get { return this._jobName; }
            set { this._jobName = value; }
        }
        
        private string _queueName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the queue to which the job is
        /// submitted.
        /// </summary>
        public string QueueName
        {
            get { return this._queueName; }
            set { this._queueName = value; }
        }
        
        private string _url;
        
        /// <summary>
        /// Optional. Gets or sets the link to the web-ui for details of the
        /// job.
        /// </summary>
        public string Url
        {
            get { return this._url; }
            set { this._url = value; }
        }
        
        private string _user;
        
        /// <summary>
        /// Optional. Gets or sets the userid of the person who submitted the
        /// job.
        /// </summary>
        public string User
        {
            get { return this._user; }
            set { this._user = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Profile class.
        /// </summary>
        public Profile()
        {
        }
    }
}
