// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.HDInsight.Job.Models;

namespace Microsoft.Azure.Management.HDInsight.Job.Models
{
    /// <summary>
    /// Gets or sets the object containing the job status information.
    /// </summary>
    public partial class Status
    {
        private double _cleanupProgress;
        
        /// <summary>
        /// Optional. Gets or sets the progress made on the cleanup.
        /// </summary>
        public double CleanupProgress
        {
            get { return this._cleanupProgress; }
            set { this._cleanupProgress = value; }
        }
        
        private string _failureInfo;
        
        /// <summary>
        /// Optional. Gets or sets the information about any failures that have
        /// occurred.
        /// </summary>
        public string FailureInfo
        {
            get { return this._failureInfo; }
            set { this._failureInfo = value; }
        }
        
        private string _finishTime;
        
        /// <summary>
        /// Optional. Gets or sets the time at which the job completed.
        /// </summary>
        public string FinishTime
        {
            get { return this._finishTime; }
            set { this._finishTime = value; }
        }
        
        private string _historyFile;
        
        /// <summary>
        /// Optional. Gets or sets the history file of the job.
        /// </summary>
        public string HistoryFile
        {
            get { return this._historyFile; }
            set { this._historyFile = value; }
        }
        
        private JobACLs _jobACLs;
        
        /// <summary>
        /// Optional. Gets or sets the ACLs of the job.
        /// </summary>
        public JobACLs JobACLs
        {
            get { return this._jobACLs; }
            set { this._jobACLs = value; }
        }
        
        private bool _jobComplete;
        
        /// <summary>
        /// Optional. Whether or not the job has completed.
        /// </summary>
        public bool JobComplete
        {
            get { return this._jobComplete; }
            set { this._jobComplete = value; }
        }
        
        private string _jobFile;
        
        /// <summary>
        /// Optional. Gets or sets the job configuration file.
        /// </summary>
        public string JobFile
        {
            get { return this._jobFile; }
            set { this._jobFile = value; }
        }
        
        private string _jobId;
        
        /// <summary>
        /// Optional. Gets or sets the full ID of the job.
        /// </summary>
        public string JobId
        {
            get { return this._jobId; }
            set { this._jobId = value; }
        }
        
        private JobID _jobID;
        
        /// <summary>
        /// Optional. Gets or sets the ID of the job.
        /// </summary>
        public JobID JobID
        {
            get { return this._jobID; }
            set { this._jobID = value; }
        }
        
        private string _jobName;
        
        /// <summary>
        /// Optional. Gets or sets the user-specified job name.
        /// </summary>
        public string JobName
        {
            get { return this._jobName; }
            set { this._jobName = value; }
        }
        
        private string _jobPriority;
        
        /// <summary>
        /// Optional. Gets or sets the priority of the job.
        /// </summary>
        public string JobPriority
        {
            get { return this._jobPriority; }
            set { this._jobPriority = value; }
        }
        
        private double _mapProgress;
        
        /// <summary>
        /// Optional. Gets or sets the progress made on the maps.
        /// </summary>
        public double MapProgress
        {
            get { return this._mapProgress; }
            set { this._mapProgress = value; }
        }
        
        private string _neededMem;
        
        /// <summary>
        /// Optional. Gets or sets the amount of memory needed for the job.
        /// </summary>
        public string NeededMem
        {
            get { return this._neededMem; }
            set { this._neededMem = value; }
        }
        
        private string _numReservedSlots;
        
        /// <summary>
        /// Optional. Gets or sets the number of slots reserved.
        /// </summary>
        public string NumReservedSlots
        {
            get { return this._numReservedSlots; }
            set { this._numReservedSlots = value; }
        }
        
        private string _numUsedSlots;
        
        /// <summary>
        /// Optional. Gets or sets the number of slots used for the job.
        /// </summary>
        public string NumUsedSlots
        {
            get { return this._numUsedSlots; }
            set { this._numUsedSlots = value; }
        }
        
        private string _priority;
        
        /// <summary>
        /// Optional. Gets or sets the priority of the job.
        /// </summary>
        public string Priority
        {
            get { return this._priority; }
            set { this._priority = value; }
        }
        
        private string _queue;
        
        /// <summary>
        /// Optional. Gets or sets the job queue name.
        /// </summary>
        public string Queue
        {
            get { return this._queue; }
            set { this._queue = value; }
        }
        
        private double _reduceProgress;
        
        /// <summary>
        /// Optional. Gets or sets the progress made on the reduces.
        /// </summary>
        public double ReduceProgress
        {
            get { return this._reduceProgress; }
            set { this._reduceProgress = value; }
        }
        
        private string _reservedMem;
        
        /// <summary>
        /// Optional. Gets or sets the amount of memory reserved for the job.
        /// </summary>
        public string ReservedMem
        {
            get { return this._reservedMem; }
            set { this._reservedMem = value; }
        }
        
        private bool _retired;
        
        /// <summary>
        /// Optional. Whether or not the job has been retired.
        /// </summary>
        public bool Retired
        {
            get { return this._retired; }
            set { this._retired = value; }
        }
        
        private int _runState;
        
        /// <summary>
        /// Optional. Gets or sets the current state of the job.
        /// </summary>
        public int RunState
        {
            get { return this._runState; }
            set { this._runState = value; }
        }
        
        private string _schedulingInfo;
        
        /// <summary>
        /// Optional. Gets or sets the information about the scheduling of the
        /// job.
        /// </summary>
        public string SchedulingInfo
        {
            get { return this._schedulingInfo; }
            set { this._schedulingInfo = value; }
        }
        
        private double _setupProgress;
        
        /// <summary>
        /// Optional. Gets or sets the progress made on the setup.
        /// </summary>
        public double SetupProgress
        {
            get { return this._setupProgress; }
            set { this._setupProgress = value; }
        }
        
        private long _startTime;
        
        /// <summary>
        /// Optional. Gets or sets the time at which the job started.
        /// </summary>
        public long StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. Gets or sets the state of the job.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _trackingUrl;
        
        /// <summary>
        /// Optional. Gets or sets the link to the web-ui for details of the
        /// job.
        /// </summary>
        public string TrackingUrl
        {
            get { return this._trackingUrl; }
            set { this._trackingUrl = value; }
        }
        
        private bool _uber;
        
        /// <summary>
        /// Optional. Whether job running in uber mode.
        /// </summary>
        public bool Uber
        {
            get { return this._uber; }
            set { this._uber = value; }
        }
        
        private string _usedMem;
        
        /// <summary>
        /// Optional. Gets or sets the amount of memory used by the job.
        /// </summary>
        public string UsedMem
        {
            get { return this._usedMem; }
            set { this._usedMem = value; }
        }
        
        private string _username;
        
        /// <summary>
        /// Optional. Gets or sets the userid of the person who submitted the
        /// job.
        /// </summary>
        public string Username
        {
            get { return this._username; }
            set { this._username = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Status class.
        /// </summary>
        public Status()
        {
        }
    }
}
