// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.HDInsight.Job.Models
{
    /// <summary>
    /// Gets or sets the object containing the user arguments.
    /// </summary>
    public partial class Userargs
    {
        private IList<string> _arg;
        
        /// <summary>
        /// Optional. Gets or sets the list of args defined by the user.
        /// </summary>
        public IList<string> Arg
        {
            get { return this._arg; }
            set { this._arg = value; }
        }
        
        private object _callback;
        
        /// <summary>
        /// Optional. Gets or sets the callback URL, if any.
        /// </summary>
        public object Callback
        {
            get { return this._callback; }
            set { this._callback = value; }
        }
        
        private IList<string> _define;
        
        /// <summary>
        /// Optional. Gets or sets the define properties defined by the user.
        /// </summary>
        public IList<string> Define
        {
            get { return this._define; }
            set { this._define = value; }
        }
        
        private string _enablelog;
        
        /// <summary>
        /// Optional. Whether or not the user enabled logs.
        /// </summary>
        public string Enablelog
        {
            get { return this._enablelog; }
            set { this._enablelog = value; }
        }
        
        private string _execute;
        
        /// <summary>
        /// Optional. Gets or sets the query defined by the user.
        /// </summary>
        public string Execute
        {
            get { return this._execute; }
            set { this._execute = value; }
        }
        
        private string _file;
        
        /// <summary>
        /// Optional. Gets or sets the query file provided by the user.
        /// </summary>
        public string File
        {
            get { return this._file; }
            set { this._file = value; }
        }
        
        private object _files;
        
        /// <summary>
        /// Optional. Gets or sets the files defined by the user.
        /// </summary>
        public object Files
        {
            get { return this._files; }
            set { this._files = value; }
        }
        
        private string _jar;
        
        /// <summary>
        /// Optional. Gets or sets the JAR file provided by the user.
        /// </summary>
        public string Jar
        {
            get { return this._jar; }
            set { this._jar = value; }
        }
        
        private object _statusdir;
        
        /// <summary>
        /// Optional. Gets or sets the status directory defined by the user.
        /// </summary>
        public object Statusdir
        {
            get { return this._statusdir; }
            set { this._statusdir = value; }
        }
        
        private string _username;
        
        /// <summary>
        /// Optional. Gets or sets the username.
        /// </summary>
        public string Username
        {
            get { return this._username; }
            set { this._username = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Userargs class.
        /// </summary>
        public Userargs()
        {
            this.Arg = new LazyList<string>();
            this.Define = new LazyList<string>();
        }
    }
}
