﻿// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;

namespace Microsoft.Azure.Management.HDInsight.Job.Models
{
    internal static class ModelHelper
    {
        internal static string GetStatusDirectory(string status)
        {
            var statusDir = status;
            if (string.IsNullOrWhiteSpace(statusDir))
            {
                // Format of status directory: 2009-06-15T13-45-30-<guid>
                statusDir = DateTime.UtcNow.ToString("s", System.Globalization.CultureInfo.InvariantCulture);

                // Can't create a directory with char ":" in azure storage
                statusDir = statusDir.Replace(':', '-');
                statusDir = string.Format("{0}-{1}", statusDir, Guid.NewGuid().ToString());
            }

            return statusDir;
        }

        internal static string ConvertItemsToString(IEnumerable<KeyValuePair<string, string>> args)
        {
            var strings = (from kvp in args
                           select kvp.Key.EscapeDataString() + "=" + kvp.Value.EscapeDataString()).ToList();
            return string.Join("&", strings);
        }

        internal static string EscapeDataString(this string inputValue)
        {
            if (string.IsNullOrEmpty(inputValue))
            {
                return string.Empty;
            }

            return Uri.EscapeDataString(inputValue);
        }

        internal static IEnumerable<KeyValuePair<string, string>> BuildNameValueList(string paramName, IEnumerable<KeyValuePair<string, string>> nameValuePairs)
        {
            List<KeyValuePair<string, string>> retval = new List<KeyValuePair<string, string>>();

            foreach (var kvp in nameValuePairs)
            {
                retval.Add(new KeyValuePair<string, string>(paramName, kvp.Key + "=" + kvp.Value));
            }
            return retval;
        }

        internal static IEnumerable<KeyValuePair<string, string>> BuildList(string type, IEnumerable<string> args)
        {
            List<KeyValuePair<string, string>> retval = new List<KeyValuePair<string, string>>();

            foreach (var arg in args)
            {
                retval.Add(new KeyValuePair<string, string>(type, arg));
            }
            return retval;
        }

        internal static string BuildListToCommaSeparatedString(IEnumerable<string> input)
        {
            return string.Join(",", input.ToArray());
        }
    }
}
