// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Insights;
using Microsoft.Azure.Insights.Models;

namespace Microsoft.Azure.Insights
{
    public static partial class LogOperationsExtensions
    {
        /// <summary>
        /// The List Log operation lists the logs for the resource.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Insights.ILogOperations.
        /// </param>
        /// <param name='resourceUri'>
        /// Optional.
        /// </param>
        /// <param name='filterString'>
        /// Optional.
        /// </param>
        /// <param name='definitions'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The List Log values operation response.
        /// </returns>
        public static LogListResponse GetLogs(this ILogOperations operations, string resourceUri, string filterString, IEnumerable<LogDefinition> definitions)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((ILogOperations)s).GetLogsAsync(resourceUri, filterString, definitions);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The List Log operation lists the logs for the resource.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the Microsoft.Azure.Insights.ILogOperations.
        /// </param>
        /// <param name='resourceUri'>
        /// Optional.
        /// </param>
        /// <param name='filterString'>
        /// Optional.
        /// </param>
        /// <param name='definitions'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The List Log values operation response.
        /// </returns>
        public static Task<LogListResponse> GetLogsAsync(this ILogOperations operations, string resourceUri, string filterString, IEnumerable<LogDefinition> definitions)
        {
            return operations.GetLogsAsync(resourceUri, filterString, definitions, CancellationToken.None);
        }
    }
}
