// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// Autoscale notification.
    /// </summary>
    public partial class AutoscaleNotification
    {
        private EmailNotification _email;
        
        /// <summary>
        /// Optional. Gets or sets the email notification.
        /// </summary>
        public EmailNotification Email
        {
            get { return this._email; }
            set { this._email = value; }
        }
        
        private string _operation;
        
        /// <summary>
        /// Optional. Gets or sets the operation associated with the
        /// notification.
        /// </summary>
        public string Operation
        {
            get { return this._operation; }
            set { this._operation = value; }
        }
        
        private IList<WebhookNotification> _webhooks;
        
        /// <summary>
        /// Optional. Gets or sets the collection of webhook notifications.
        /// </summary>
        public IList<WebhookNotification> Webhooks
        {
            get { return this._webhooks; }
            set { this._webhooks = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AutoscaleNotification class.
        /// </summary>
        public AutoscaleNotification()
        {
            this.Webhooks = new LazyList<WebhookNotification>();
        }
    }
}
