// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// Enable collection of crash dumps.
    /// </summary>
    public partial class CrashDumps
    {
        private string _containerName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the blob container in your Azure
        /// Storage account that will be used to store crash dumps.
        /// </summary>
        public string ContainerName
        {
            get { return this._containerName; }
            set { this._containerName = value; }
        }
        
        private int? _directoryQuotaPercentage;
        
        /// <summary>
        /// Optional. Gets or sets the configures the percentage of
        /// overallQuotaInMB that will be reserved for crash dumps.
        /// </summary>
        public int? DirectoryQuotaPercentage
        {
            get { return this._directoryQuotaPercentage; }
            set { this._directoryQuotaPercentage = value; }
        }
        
        private Microsoft.Azure.Management.Insights.Models.CrashDumpType? _dumpType;
        
        /// <summary>
        /// Optional. Gets or sets the crash dump type. Configures collection
        /// of Mini or Full cash dumps.
        /// </summary>
        public Microsoft.Azure.Management.Insights.Models.CrashDumpType? DumpType
        {
            get { return this._dumpType; }
            set { this._dumpType = value; }
        }
        
        private IList<string> _processes;
        
        /// <summary>
        /// Optional. Gets or sets the names of the process you want to collect
        /// a crash dump for.
        /// </summary>
        public IList<string> Processes
        {
            get { return this._processes; }
            set { this._processes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CrashDumps class.
        /// </summary>
        public CrashDumps()
        {
            this.Processes = new LazyList<string>();
        }
    }
}
