// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// A rule condition based on a certain number of locations failing.
    /// </summary>
    public partial class LocationThresholdRuleCondition : RuleCondition
    {
        private RuleDataSource _dataSource;
        
        /// <summary>
        /// Optional. Gets or sets the resource from which the rule collects
        /// its data.
        /// </summary>
        public RuleDataSource DataSource
        {
            get { return this._dataSource; }
            set { this._dataSource = value; }
        }
        
        private int _failedLocationCount;
        
        /// <summary>
        /// Optional. Gets or sets the number of locations that must fail to
        /// activate the alert.
        /// </summary>
        public int FailedLocationCount
        {
            get { return this._failedLocationCount; }
            set { this._failedLocationCount = value; }
        }
        
        private TimeSpan _windowSize;
        
        /// <summary>
        /// Optional. Gets or sets the period of time that is used to monitor
        /// alert activity based on the threshold. Must be between 5 minutes
        /// and 1 day.
        /// </summary>
        public TimeSpan WindowSize
        {
            get { return this._windowSize; }
            set { this._windowSize = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the LocationThresholdRuleCondition
        /// class.
        /// </summary>
        public LocationThresholdRuleCondition()
        {
        }
    }
}
