// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// The log profile.
    /// </summary>
    public partial class LogProfile
    {
        private IList<string> _categories;
        
        /// <summary>
        /// Optional.  Gets or sets the categories.
        /// </summary>
        public IList<string> Categories
        {
            get { return this._categories; }
            set { this._categories = value; }
        }
        
        private IList<string> _locations;
        
        /// <summary>
        /// Optional. Gets or sets the locations.
        /// </summary>
        public IList<string> Locations
        {
            get { return this._locations; }
            set { this._locations = value; }
        }
        
        private RetentionPolicy _retentionPolicy;
        
        /// <summary>
        /// Optional. Gets or sets the retention policy for this log.
        /// </summary>
        public RetentionPolicy RetentionPolicy
        {
            get { return this._retentionPolicy; }
            set { this._retentionPolicy = value; }
        }
        
        private string _serviceBusRuleId;
        
        /// <summary>
        /// Optional. Gets or sets the resource id of the service bus rule.
        /// </summary>
        public string ServiceBusRuleId
        {
            get { return this._serviceBusRuleId; }
            set { this._serviceBusRuleId = value; }
        }
        
        private string _storageAccountId;
        
        /// <summary>
        /// Optional. Gets or sets the resource id of the storage account.
        /// </summary>
        public string StorageAccountId
        {
            get { return this._storageAccountId; }
            set { this._storageAccountId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the LogProfile class.
        /// </summary>
        public LogProfile()
        {
            this.Categories = new LazyList<string>();
            this.Locations = new LazyList<string>();
        }
    }
}
