// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// Represents the public monitoring configuration.
    /// </summary>
    public partial class PublicMonitoringConfiguration : PublicConfiguration
    {
        private DiagnosticMonitorConfiguration _diagnosticMonitorConfiguration;
        
        /// <summary>
        /// Optional. Gets or sets the configuration settings for the telemetry
        /// data to be collected.
        /// </summary>
        public DiagnosticMonitorConfiguration DiagnosticMonitorConfiguration
        {
            get { return this._diagnosticMonitorConfiguration; }
            set { this._diagnosticMonitorConfiguration = value; }
        }
        
        private DirectoryAbsolute _localResourceDirectory;
        
        /// <summary>
        /// Optional. Gets or sets the directory on the virtual machine to be
        /// used by the Monitoring Agent to store event data. If not set the
        /// default directory will be used.
        /// </summary>
        public DirectoryAbsolute LocalResourceDirectory
        {
            get { return this._localResourceDirectory; }
            set { this._localResourceDirectory = value; }
        }
        
        private string _storageAccount;
        
        /// <summary>
        /// Optional. Gets or sets the name of the Azure Storage account to
        /// store the data in.
        /// </summary>
        public string StorageAccount
        {
            get { return this._storageAccount; }
            set { this._storageAccount = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the PublicMonitoringConfiguration
        /// class.
        /// </summary>
        public PublicMonitoringConfiguration()
        {
        }
    }
}
