// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// Specifies the action to post to service when the rule condition is
    /// evaluated.
    /// </summary>
    public partial class RuleWebhookAction : RuleAction
    {
        private IDictionary<string, string> _properties;
        
        /// <summary>
        /// Optional. Gets or sets the dictionary of custom properties to
        /// include with the post operation.
        /// </summary>
        public IDictionary<string, string> Properties
        {
            get { return this._properties; }
            set { this._properties = value; }
        }
        
        private string _serviceUri;
        
        /// <summary>
        /// Optional. Gets or sets the service uri to Post the notitication.
        /// </summary>
        public string ServiceUri
        {
            get { return this._serviceUri; }
            set { this._serviceUri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RuleWebhookAction class.
        /// </summary>
        public RuleWebhookAction()
        {
            this.Properties = new LazyDictionary<string, string>();
        }
    }
}
