// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// The number of instances that can be used during this profile.
    /// </summary>
    public partial class ScaleCapacity
    {
        private string _default;
        
        /// <summary>
        /// Optional. Gets or sets the number of instances that will be set if
        /// metrics are not available for evaluation. The default is only used
        /// if the current instance count is lower than the default.
        /// </summary>
        public string Default
        {
            get { return this._default; }
            set { this._default = value; }
        }
        
        private string _maximum;
        
        /// <summary>
        /// Optional. Gets or sets the maximum number of instances for the
        /// resource. The actual maximum number may be limited by the cores
        /// that are available.
        /// </summary>
        public string Maximum
        {
            get { return this._maximum; }
            set { this._maximum = value; }
        }
        
        private string _minimum;
        
        /// <summary>
        /// Optional. Gets or sets the minimum number of instances for the
        /// resource.
        /// </summary>
        public string Minimum
        {
            get { return this._minimum; }
            set { this._minimum = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ScaleCapacity class.
        /// </summary>
        public ScaleCapacity()
        {
        }
    }
}
