// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// Represents a sku.
    /// </summary>
    public partial class Sku
    {
        private string _family;
        
        /// <summary>
        /// Optional. Gets or sets the family of the sku e.g. 'A'.
        /// </summary>
        public string Family
        {
            get { return this._family; }
            set { this._family = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the unique name of the sku e.g. 'Free_A0'.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _size;
        
        /// <summary>
        /// Optional. Gets or sets the size of the sku e.g. 'A0'.
        /// </summary>
        public string Size
        {
            get { return this._size; }
            set { this._size = value; }
        }
        
        private string _tier;
        
        /// <summary>
        /// Optional. Gets or sets the tier of the sku e.g. 'free'.
        /// </summary>
        public string Tier
        {
            get { return this._tier; }
            set { this._tier = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Sku class.
        /// </summary>
        public Sku()
        {
        }
    }
}
