// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// The public diagnostics settings for Storage account services.
    /// </summary>
    public partial class StorageConfiguration
    {
        private StorageLoggingConfiguration _loggingConfiguration;
        
        /// <summary>
        /// Optional. Gets or sets the storage logging configuration. Settings
        /// for logging successful and failed requests to a storage service.
        /// This information can be used to monitor individual requests and to
        /// diagnose issues with a storage service. Requests are logged on a
        /// best-effort basis.
        /// </summary>
        public StorageLoggingConfiguration LoggingConfiguration
        {
            get { return this._loggingConfiguration; }
            set { this._loggingConfiguration = value; }
        }
        
        private StorageMetricConfiguration _metricConfiguration;
        
        /// <summary>
        /// Optional. Gets or sets the settings for metrics that include
        /// aggregated transaction statistics and capacity data about requests
        /// to a storage service.
        /// </summary>
        public StorageMetricConfiguration MetricConfiguration
        {
            get { return this._metricConfiguration; }
            set { this._metricConfiguration = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the StorageConfiguration class.
        /// </summary>
        public StorageConfiguration()
        {
        }
    }
}
