// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.Azure.Management.Network;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network
{
    /// <summary>
    /// The Windows Azure Network management API provides a RESTful set of web
    /// services that interact with Windows Azure Networks service to manage
    /// your network resrources. The API has entities that capture the
    /// relationship between an end user and the Windows Azure Networks
    /// service.
    /// </summary>
    public static partial class ApplicationGatewayOperationsExtensions
    {
        /// <summary>
        /// The Put ApplicationGateway operation creates/updates a
        /// ApplicationGateway
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the ApplicationGateway.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the create/delete
        /// ApplicationGateway operation
        /// </param>
        /// <returns>
        /// Response of Put ApplicationGateway operation
        /// </returns>
        public static ApplicationGatewayPutResponse BeginCreateOrUpdating(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName, ApplicationGateway parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).BeginCreateOrUpdatingAsync(resourceGroupName, applicationGatewayName, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Put ApplicationGateway operation creates/updates a
        /// ApplicationGateway
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the ApplicationGateway.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the create/delete
        /// ApplicationGateway operation
        /// </param>
        /// <returns>
        /// Response of Put ApplicationGateway operation
        /// </returns>
        public static Task<ApplicationGatewayPutResponse> BeginCreateOrUpdatingAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName, ApplicationGateway parameters)
        {
            return operations.BeginCreateOrUpdatingAsync(resourceGroupName, applicationGatewayName, parameters, CancellationToken.None);
        }
        
        /// <summary>
        /// The delete applicationgateway operation deletes the specified
        /// applicationgateway.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the applicationgateway.
        /// </param>
        /// <returns>
        /// If the resource provide needs to return an error to any operation,
        /// it should return the appropriate HTTP error code and a message
        /// body as can be seen below.The message should be localized per the
        /// Accept-Language header specified in the original request such
        /// thatit could be directly be exposed to users
        /// </returns>
        public static UpdateOperationResponse BeginDeleting(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).BeginDeletingAsync(resourceGroupName, applicationGatewayName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The delete applicationgateway operation deletes the specified
        /// applicationgateway.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the applicationgateway.
        /// </param>
        /// <returns>
        /// If the resource provide needs to return an error to any operation,
        /// it should return the appropriate HTTP error code and a message
        /// body as can be seen below.The message should be localized per the
        /// Accept-Language header specified in the original request such
        /// thatit could be directly be exposed to users
        /// </returns>
        public static Task<UpdateOperationResponse> BeginDeletingAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return operations.BeginDeletingAsync(resourceGroupName, applicationGatewayName, CancellationToken.None);
        }
        
        /// <summary>
        /// The Start ApplicationGateway operation starts application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// Response for PutVirtualNetworkGateway Api servive call
        /// </returns>
        public static VirtualNetworkGatewayPutResponse BeginStart(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).BeginStartAsync(resourceGroupName, applicationGatewayName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Start ApplicationGateway operation starts application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// Response for PutVirtualNetworkGateway Api servive call
        /// </returns>
        public static Task<VirtualNetworkGatewayPutResponse> BeginStartAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return operations.BeginStartAsync(resourceGroupName, applicationGatewayName, CancellationToken.None);
        }
        
        /// <summary>
        /// The STOP ApplicationGateway operation stops application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// Response for PutVirtualNetworkGateway Api servive call
        /// </returns>
        public static VirtualNetworkGatewayPutResponse BeginStop(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).BeginStopAsync(resourceGroupName, applicationGatewayName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The STOP ApplicationGateway operation stops application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// Response for PutVirtualNetworkGateway Api servive call
        /// </returns>
        public static Task<VirtualNetworkGatewayPutResponse> BeginStopAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return operations.BeginStopAsync(resourceGroupName, applicationGatewayName, CancellationToken.None);
        }
        
        /// <summary>
        /// The Put ApplicationGateway operation creates/updates a
        /// ApplicationGateway
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the ApplicationGateway.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the create/update
        /// ApplicationGateway operation
        /// </param>
        /// <returns>
        /// The response body contains the status of the specified asynchronous
        /// operation, indicating whether it has succeeded, is inprogress, or
        /// has failed. Note that this status is distinct from the HTTP status
        /// code returned for the Get Operation Status operation itself. If
        /// the asynchronous operation succeeded, the response body includes
        /// the HTTP status code for the successful request. If the
        /// asynchronous operation failed, the response body includes the HTTP
        /// status code for the failed request and error information regarding
        /// the failure.
        /// </returns>
        public static AzureAsyncOperationResponse CreateOrUpdate(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName, ApplicationGateway parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).CreateOrUpdateAsync(resourceGroupName, applicationGatewayName, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Put ApplicationGateway operation creates/updates a
        /// ApplicationGateway
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the ApplicationGateway.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the create/update
        /// ApplicationGateway operation
        /// </param>
        /// <returns>
        /// The response body contains the status of the specified asynchronous
        /// operation, indicating whether it has succeeded, is inprogress, or
        /// has failed. Note that this status is distinct from the HTTP status
        /// code returned for the Get Operation Status operation itself. If
        /// the asynchronous operation succeeded, the response body includes
        /// the HTTP status code for the successful request. If the
        /// asynchronous operation failed, the response body includes the HTTP
        /// status code for the failed request and error information regarding
        /// the failure.
        /// </returns>
        public static Task<AzureAsyncOperationResponse> CreateOrUpdateAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName, ApplicationGateway parameters)
        {
            return operations.CreateOrUpdateAsync(resourceGroupName, applicationGatewayName, parameters, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the applicationgateway.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse Delete(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).DeleteAsync(resourceGroupName, applicationGatewayName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the applicationgateway.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> DeleteAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return operations.DeleteAsync(resourceGroupName, applicationGatewayName, CancellationToken.None);
        }
        
        /// <summary>
        /// The Get applicationgateway operation retreives information about
        /// the specified applicationgateway.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the applicationgateway.
        /// </param>
        /// <returns>
        /// Response of a GET ApplicationGateway operation
        /// </returns>
        public static ApplicationGatewayGetResponse Get(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).GetAsync(resourceGroupName, applicationGatewayName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Get applicationgateway operation retreives information about
        /// the specified applicationgateway.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the applicationgateway.
        /// </param>
        /// <returns>
        /// Response of a GET ApplicationGateway operation
        /// </returns>
        public static Task<ApplicationGatewayGetResponse> GetAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return operations.GetAsync(resourceGroupName, applicationGatewayName, CancellationToken.None);
        }
        
        /// <summary>
        /// The List ApplicationGateway opertion retrieves all the
        /// applicationgateways in a resource group.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <returns>
        /// Response for ListLoadBalancers Api service call
        /// </returns>
        public static ApplicationGatewayListResponse List(this IApplicationGatewayOperations operations, string resourceGroupName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).ListAsync(resourceGroupName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The List ApplicationGateway opertion retrieves all the
        /// applicationgateways in a resource group.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <returns>
        /// Response for ListLoadBalancers Api service call
        /// </returns>
        public static Task<ApplicationGatewayListResponse> ListAsync(this IApplicationGatewayOperations operations, string resourceGroupName)
        {
            return operations.ListAsync(resourceGroupName, CancellationToken.None);
        }
        
        /// <summary>
        /// The List applicationgateway opertion retrieves all the
        /// applicationgateways in a subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <returns>
        /// Response for ListLoadBalancers Api service call
        /// </returns>
        public static ApplicationGatewayListResponse ListAll(this IApplicationGatewayOperations operations)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).ListAllAsync();
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The List applicationgateway opertion retrieves all the
        /// applicationgateways in a subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <returns>
        /// Response for ListLoadBalancers Api service call
        /// </returns>
        public static Task<ApplicationGatewayListResponse> ListAllAsync(this IApplicationGatewayOperations operations)
        {
            return operations.ListAllAsync(CancellationToken.None);
        }
        
        /// <summary>
        /// The Start ApplicationGateway operation starts application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// The response body contains the status of the specified asynchronous
        /// operation, indicating whether it has succeeded, is inprogress, or
        /// has failed. Note that this status is distinct from the HTTP status
        /// code returned for the Get Operation Status operation itself. If
        /// the asynchronous operation succeeded, the response body includes
        /// the HTTP status code for the successful request. If the
        /// asynchronous operation failed, the response body includes the HTTP
        /// status code for the failed request and error information regarding
        /// the failure.
        /// </returns>
        public static AzureAsyncOperationResponse Start(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).StartAsync(resourceGroupName, applicationGatewayName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Start ApplicationGateway operation starts application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// The response body contains the status of the specified asynchronous
        /// operation, indicating whether it has succeeded, is inprogress, or
        /// has failed. Note that this status is distinct from the HTTP status
        /// code returned for the Get Operation Status operation itself. If
        /// the asynchronous operation succeeded, the response body includes
        /// the HTTP status code for the successful request. If the
        /// asynchronous operation failed, the response body includes the HTTP
        /// status code for the failed request and error information regarding
        /// the failure.
        /// </returns>
        public static Task<AzureAsyncOperationResponse> StartAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return operations.StartAsync(resourceGroupName, applicationGatewayName, CancellationToken.None);
        }
        
        /// <summary>
        /// The STOP ApplicationGateway operation stops application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// The response body contains the status of the specified asynchronous
        /// operation, indicating whether it has succeeded, is inprogress, or
        /// has failed. Note that this status is distinct from the HTTP status
        /// code returned for the Get Operation Status operation itself. If
        /// the asynchronous operation succeeded, the response body includes
        /// the HTTP status code for the successful request. If the
        /// asynchronous operation failed, the response body includes the HTTP
        /// status code for the failed request and error information regarding
        /// the failure.
        /// </returns>
        public static AzureAsyncOperationResponse Stop(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IApplicationGatewayOperations)s).StopAsync(resourceGroupName, applicationGatewayName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The STOP ApplicationGateway operation stops application gatewayin
        /// the specified resource group through Network resource provider.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Network.IApplicationGatewayOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The name of the resource group.
        /// </param>
        /// <param name='applicationGatewayName'>
        /// Required. The name of the application gateway.
        /// </param>
        /// <returns>
        /// The response body contains the status of the specified asynchronous
        /// operation, indicating whether it has succeeded, is inprogress, or
        /// has failed. Note that this status is distinct from the HTTP status
        /// code returned for the Get Operation Status operation itself. If
        /// the asynchronous operation succeeded, the response body includes
        /// the HTTP status code for the successful request. If the
        /// asynchronous operation failed, the response body includes the HTTP
        /// status code for the failed request and error information regarding
        /// the failure.
        /// </returns>
        public static Task<AzureAsyncOperationResponse> StopAsync(this IApplicationGatewayOperations operations, string resourceGroupName, string applicationGatewayName)
        {
            return operations.StopAsync(resourceGroupName, applicationGatewayName, CancellationToken.None);
        }
    }
}
