// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// Request routing rule of application gateway
    /// </summary>
    public partial class ApplicationGatewayRequestRoutingRule : ChildResource
    {
        private ResourceId _backendAddressPool;
        
        /// <summary>
        /// Optional. Gets or sets backend address pool resource of application
        /// gateway
        /// </summary>
        public ResourceId BackendAddressPool
        {
            get { return this._backendAddressPool; }
            set { this._backendAddressPool = value; }
        }
        
        private ResourceId _backendHttpSettings;
        
        /// <summary>
        /// Optional. Gets or sets frontend port resource of application
        /// gateway
        /// </summary>
        public ResourceId BackendHttpSettings
        {
            get { return this._backendHttpSettings; }
            set { this._backendHttpSettings = value; }
        }
        
        private ResourceId _httpListener;
        
        /// <summary>
        /// Optional. Gets or sets http listener resource of application
        /// gateway
        /// </summary>
        public ResourceId HttpListener
        {
            get { return this._httpListener; }
            set { this._httpListener = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the request routing
        /// rule resource Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private string _ruleType;
        
        /// <summary>
        /// Optional. Gets or sets the rule type
        /// </summary>
        public string RuleType
        {
            get { return this._ruleType; }
            set { this._ruleType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationGatewayRequestRoutingRule class.
        /// </summary>
        public ApplicationGatewayRequestRoutingRule()
        {
        }
    }
}
