// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// ExpressRouteCircuit resource
    /// </summary>
    public partial class ExpressRouteCircuit : TopLevelResource
    {
        private IList<ExpressRouteCircuitAuthorization> _authorizations;
        
        /// <summary>
        /// Optional. Gets or sets list of authorizations
        /// </summary>
        public IList<ExpressRouteCircuitAuthorization> Authorizations
        {
            get { return this._authorizations; }
            set { this._authorizations = value; }
        }
        
        private string _billingType;
        
        /// <summary>
        /// Required. BillingType to be used for the new dedicated circuit.
        /// </summary>
        public string BillingType
        {
            get { return this._billingType; }
            set { this._billingType = value; }
        }
        
        private string _circuitProvisioningState;
        
        /// <summary>
        /// Optional. Gets or sets CircuitProvisioningState state of the
        /// resource
        /// </summary>
        public string CircuitProvisioningState
        {
            get { return this._circuitProvisioningState; }
            set { this._circuitProvisioningState = value; }
        }
        
        private IList<ExpressRouteCircuitPeering> _peerings;
        
        /// <summary>
        /// Optional. Gets or sets list of peerings
        /// </summary>
        public IList<ExpressRouteCircuitPeering> Peerings
        {
            get { return this._peerings; }
            set { this._peerings = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private string _serviceKey;
        
        /// <summary>
        /// Optional. Gets or sets ServiceKey
        /// </summary>
        public string ServiceKey
        {
            get { return this._serviceKey; }
            set { this._serviceKey = value; }
        }
        
        private string _serviceProviderNotes;
        
        /// <summary>
        /// Optional. Gets or sets ServiceProviderNotes
        /// </summary>
        public string ServiceProviderNotes
        {
            get { return this._serviceProviderNotes; }
            set { this._serviceProviderNotes = value; }
        }
        
        private ExpressRouteCircuitServiceProviderProperties _serviceProviderProperties;
        
        /// <summary>
        /// Optional. Gets or sets ServiceProviderProperties
        /// </summary>
        public ExpressRouteCircuitServiceProviderProperties ServiceProviderProperties
        {
            get { return this._serviceProviderProperties; }
            set { this._serviceProviderProperties = value; }
        }
        
        private string _serviceProviderProvisioningState;
        
        /// <summary>
        /// Optional. Gets or sets ServiceProviderProvisioningState state of
        /// the resource
        /// </summary>
        public string ServiceProviderProvisioningState
        {
            get { return this._serviceProviderProvisioningState; }
            set { this._serviceProviderProvisioningState = value; }
        }
        
        private ExpressRouteCircuitSku _sku;
        
        /// <summary>
        /// Optional. Gets or sets sku
        /// </summary>
        public ExpressRouteCircuitSku Sku
        {
            get { return this._sku; }
            set { this._sku = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ExpressRouteCircuit class.
        /// </summary>
        public ExpressRouteCircuit()
        {
            this.Authorizations = new LazyList<ExpressRouteCircuitAuthorization>();
            this.Peerings = new LazyList<ExpressRouteCircuitPeering>();
        }
        
        /// <summary>
        /// Initializes a new instance of the ExpressRouteCircuit class with
        /// required arguments.
        /// </summary>
        public ExpressRouteCircuit(string billingType, string location)
            : this()
        {
            if (billingType == null)
            {
                throw new ArgumentNullException("billingType");
            }
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.BillingType = billingType;
            this.Location = location;
        }
    }
}
