// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// Specfies the peering config
    /// </summary>
    public partial class ExpressRouteCircuitPeeringConfig
    {
        private IList<string> _advertisedPublicPrefixes;
        
        /// <summary>
        /// Optional. Gets or sets the reference of AdvertisedPublicPrefixes
        /// </summary>
        public IList<string> AdvertisedPublicPrefixes
        {
            get { return this._advertisedPublicPrefixes; }
            set { this._advertisedPublicPrefixes = value; }
        }
        
        private string _advertisedPublicPrefixesState;
        
        /// <summary>
        /// Optional. Gets or sets AdvertisedPublicPrefixState of the Peering
        /// resource
        /// </summary>
        public string AdvertisedPublicPrefixesState
        {
            get { return this._advertisedPublicPrefixesState; }
            set { this._advertisedPublicPrefixesState = value; }
        }
        
        private int _customerASN;
        
        /// <summary>
        /// Optional. Gets or Sets CustomerAsn of the peering.
        /// </summary>
        public int CustomerASN
        {
            get { return this._customerASN; }
            set { this._customerASN = value; }
        }
        
        private string _routingRegistryName;
        
        /// <summary>
        /// Optional. Gets or Sets RoutingRegistryName of the config.
        /// </summary>
        public string RoutingRegistryName
        {
            get { return this._routingRegistryName; }
            set { this._routingRegistryName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ExpressRouteCircuitPeeringConfig
        /// class.
        /// </summary>
        public ExpressRouteCircuitPeeringConfig()
        {
            this.AdvertisedPublicPrefixes = new LazyList<string>();
        }
    }
}
