// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// ExpressRouteResourceProvider object
    /// </summary>
    public partial class ExpressRouteServiceProvider
    {
        private IList<ExpressRouteServiceProviderBandwidthsOffered> _bandwidthsOffered;
        
        /// <summary>
        /// Optional. Gets or bandwidths offered
        /// </summary>
        public IList<ExpressRouteServiceProviderBandwidthsOffered> BandwidthsOffered
        {
            get { return this._bandwidthsOffered; }
            set { this._bandwidthsOffered = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Optional. Gets or sets the ID of the resource.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the resource.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private IList<string> _peeringLocations;
        
        /// <summary>
        /// Optional. Gets or list of peering locations
        /// </summary>
        public IList<string> PeeringLocations
        {
            get { return this._peeringLocations; }
            set { this._peeringLocations = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the resource
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. Gets or sets the type of the resource.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ExpressRouteServiceProvider class.
        /// </summary>
        public ExpressRouteServiceProvider()
        {
            this.BandwidthsOffered = new LazyList<ExpressRouteServiceProviderBandwidthsOffered>();
            this.PeeringLocations = new LazyList<string>();
        }
    }
}
