// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// Inbound NAT pool of the loadbalancer
    /// </summary>
    public partial class InboundNatPool : ChildResource
    {
        private int _backendPort;
        
        /// <summary>
        /// Required. Gets or sets a port used for internal connections on the
        /// endpoint. The localPort attribute maps the eternal port of the
        /// endpoint to an internal port on a role. This is useful in
        /// scenarios where a role must communicate to an internal compotnent
        /// on a port that is different from the one that is exposed
        /// externally. If not specified, the value of localPort is the same
        /// as the port attribute. Set the value of localPort to '*' to
        /// automatically assign an unallocated port that is discoverable
        /// using the runtime API
        /// </summary>
        public int BackendPort
        {
            get { return this._backendPort; }
            set { this._backendPort = value; }
        }
        
        private ResourceId _frontendIPConfiguration;
        
        /// <summary>
        /// Optional. Gets or sets a reference to frontend IP Addresses
        /// </summary>
        public ResourceId FrontendIPConfiguration
        {
            get { return this._frontendIPConfiguration; }
            set { this._frontendIPConfiguration = value; }
        }
        
        private int _frontendPortRangeEnd;
        
        /// <summary>
        /// Required. Gets or sets the ending port range for the NAT pool. You
        /// can spcify any port number you choose, but the port numbers
        /// specified for each role in the service must be unique. Possible
        /// values range between 1 and 65535, inclusive
        /// </summary>
        public int FrontendPortRangeEnd
        {
            get { return this._frontendPortRangeEnd; }
            set { this._frontendPortRangeEnd = value; }
        }
        
        private int _frontendPortRangeStart;
        
        /// <summary>
        /// Required. Gets or sets the starting port range for the NAT pool.
        /// You can spcify any port number you choose, but the port numbers
        /// specified for each role in the service must be unique. Possible
        /// values range between 1 and 65535, inclusive
        /// </summary>
        public int FrontendPortRangeStart
        {
            get { return this._frontendPortRangeStart; }
            set { this._frontendPortRangeStart = value; }
        }
        
        private string _protocol;
        
        /// <summary>
        /// Required. Gets or sets the transport potocol for the external
        /// endpoint. Possible values are Udp or Tcp
        /// </summary>
        public string Protocol
        {
            get { return this._protocol; }
            set { this._protocol = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the InboundNatPool class.
        /// </summary>
        public InboundNatPool()
        {
        }
    }
}
