// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// A common class for general resource information
    /// </summary>
    public partial class LocalNetworkGateway : TopLevelResource
    {
        private string _gatewayIpAddress;
        
        /// <summary>
        /// Optional. IP address of local network gateway.
        /// </summary>
        public string GatewayIpAddress
        {
            get { return this._gatewayIpAddress; }
            set { this._gatewayIpAddress = value; }
        }
        
        private AddressSpace _localNetworkAddressSpace;
        
        /// <summary>
        /// Optional. Local network site Address space
        /// </summary>
        public AddressSpace LocalNetworkAddressSpace
        {
            get { return this._localNetworkAddressSpace; }
            set { this._localNetworkAddressSpace = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the
        /// LocalNetworkGateway resource Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private string _resourceGuid;
        
        /// <summary>
        /// Optional. Gets or sets resource guid property of the
        /// LocalNetworkGateway resource
        /// </summary>
        public string ResourceGuid
        {
            get { return this._resourceGuid; }
            set { this._resourceGuid = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the LocalNetworkGateway class.
        /// </summary>
        public LocalNetworkGateway()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the LocalNetworkGateway class with
        /// required arguments.
        /// </summary>
        public LocalNetworkGateway(string location)
            : this()
        {
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Location = location;
        }
    }
}
