// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// Route resource
    /// </summary>
    public partial class Route : ChildResource
    {
        private string _addressPrefix;
        
        /// <summary>
        /// Optional. Gets or sets the destination CIDR to which the route
        /// applies.
        /// </summary>
        public string AddressPrefix
        {
            get { return this._addressPrefix; }
            set { this._addressPrefix = value; }
        }
        
        private string _nextHopIpAddress;
        
        /// <summary>
        /// Optional. Gets or sets the IP address packets should be forwarded
        /// to. Next hop values are only allowed in routes where the next hop
        /// type is VirtualAppliance.
        /// </summary>
        public string NextHopIpAddress
        {
            get { return this._nextHopIpAddress; }
            set { this._nextHopIpAddress = value; }
        }
        
        private string _nextHopType;
        
        /// <summary>
        /// Required. Gets or sets the type of Azure hop the packet should be
        /// sent to.
        /// </summary>
        public string NextHopType
        {
            get { return this._nextHopType; }
            set { this._nextHopType = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the resource
        /// Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Route class.
        /// </summary>
        public Route()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the Route class with required
        /// arguments.
        /// </summary>
        public Route(string nextHopType)
            : this()
        {
            if (nextHopType == null)
            {
                throw new ArgumentNullException("nextHopType");
            }
            this.NextHopType = nextHopType;
        }
    }
}
