// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// Subnet in a VirtualNework resource
    /// </summary>
    public partial class Subnet : ChildResource
    {
        private string _addressPrefix;
        
        /// <summary>
        /// Required. Gets or sets Address prefix for the subnet.
        /// </summary>
        public string AddressPrefix
        {
            get { return this._addressPrefix; }
            set { this._addressPrefix = value; }
        }
        
        private IList<ResourceId> _ipConfigurations;
        
        /// <summary>
        /// Optional. Gets array of references to the network interface IP
        /// configurations using subnet
        /// </summary>
        public IList<ResourceId> IpConfigurations
        {
            get { return this._ipConfigurations; }
            set { this._ipConfigurations = value; }
        }
        
        private ResourceId _networkSecurityGroup;
        
        /// <summary>
        /// Optional. Gets or sets the reference of the NetworkSecurityGroup
        /// resource
        /// </summary>
        public ResourceId NetworkSecurityGroup
        {
            get { return this._networkSecurityGroup; }
            set { this._networkSecurityGroup = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private ResourceId _routeTable;
        
        /// <summary>
        /// Optional. Gets or sets the reference of the RouteTable resource
        /// </summary>
        public ResourceId RouteTable
        {
            get { return this._routeTable; }
            set { this._routeTable = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Subnet class.
        /// </summary>
        public Subnet()
        {
            this.IpConfigurations = new LazyList<ResourceId>();
        }
        
        /// <summary>
        /// Initializes a new instance of the Subnet class with required
        /// arguments.
        /// </summary>
        public Subnet(string addressPrefix)
            : this()
        {
            if (addressPrefix == null)
            {
                throw new ArgumentNullException("addressPrefix");
            }
            this.AddressPrefix = addressPrefix;
        }
    }
}
