// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// A common class for general resource information
    /// </summary>
    public partial class TopLevelResource : ResourceBaseExtended
    {
        private string _etag;
        
        /// <summary>
        /// Optional. Gets a unique read-only string that changes whenever the
        /// resource is updated
        /// </summary>
        public string Etag
        {
            get { return this._etag; }
            set { this._etag = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the TopLevelResource class.
        /// </summary>
        public TopLevelResource()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the TopLevelResource class with
        /// required arguments.
        /// </summary>
        public TopLevelResource(string location)
            : this()
        {
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Location = location;
        }
    }
}
