// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// Virtual Network resource
    /// </summary>
    public partial class VirtualNetwork : TopLevelResource
    {
        private AddressSpace _addressSpace;
        
        /// <summary>
        /// Optional. Gets or sets AddressSpace that contains an array of IP
        /// address ranges that can be used by subnets
        /// </summary>
        public AddressSpace AddressSpace
        {
            get { return this._addressSpace; }
            set { this._addressSpace = value; }
        }
        
        private DhcpOptions _dhcpOptions;
        
        /// <summary>
        /// Optional. Gets or sets DHCPOptions that contains an array of DNS
        /// servers available to VMs deployed in the virtual network
        /// </summary>
        public DhcpOptions DhcpOptions
        {
            get { return this._dhcpOptions; }
            set { this._dhcpOptions = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private string _resourceGuid;
        
        /// <summary>
        /// Optional. Gets or sets resource guid property of the VirtualNetwork
        /// resource
        /// </summary>
        public string ResourceGuid
        {
            get { return this._resourceGuid; }
            set { this._resourceGuid = value; }
        }
        
        private IList<Subnet> _subnets;
        
        /// <summary>
        /// Optional. Gets or sets List of subnets in a VirtualNetwork
        /// </summary>
        public IList<Subnet> Subnets
        {
            get { return this._subnets; }
            set { this._subnets = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualNetwork class.
        /// </summary>
        public VirtualNetwork()
        {
            this.Subnets = new LazyList<Subnet>();
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualNetwork class with
        /// required arguments.
        /// </summary>
        public VirtualNetwork(string location)
            : this()
        {
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Location = location;
        }
    }
}
