// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// A common class for general resource information
    /// </summary>
    public partial class VirtualNetworkGateway : TopLevelResource
    {
        private bool _enableBgp;
        
        /// <summary>
        /// Optional. EnableBgp Flag
        /// </summary>
        public bool EnableBgp
        {
            get { return this._enableBgp; }
            set { this._enableBgp = value; }
        }
        
        private ResourceId _gatewayDefaultSite;
        
        /// <summary>
        /// Optional. Gets or sets the reference of the LocalNetworkGateway
        /// resource which represents Local network site having default
        /// routes. Assign Null value in case of removing existing default
        /// site setting.
        /// </summary>
        public ResourceId GatewayDefaultSite
        {
            get { return this._gatewayDefaultSite; }
            set { this._gatewayDefaultSite = value; }
        }
        
        private string _gatewayType;
        
        /// <summary>
        /// Optional. The type of this virtual network gateway.
        /// </summary>
        public string GatewayType
        {
            get { return this._gatewayType; }
            set { this._gatewayType = value; }
        }
        
        private IList<VirtualNetworkGatewayIpConfiguration> _ipConfigurations;
        
        /// <summary>
        /// Optional. IpConfigurations for Virtual network gateway.
        /// </summary>
        public IList<VirtualNetworkGatewayIpConfiguration> IpConfigurations
        {
            get { return this._ipConfigurations; }
            set { this._ipConfigurations = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the
        /// VirtualNetworkGateway resource Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private string _resourceGuid;
        
        /// <summary>
        /// Optional. Gets or sets resource guid property of the
        /// VirtualNetworkGateway resource
        /// </summary>
        public string ResourceGuid
        {
            get { return this._resourceGuid; }
            set { this._resourceGuid = value; }
        }
        
        private string _vpnType;
        
        /// <summary>
        /// Optional. The type of this virtual network gateway.
        /// </summary>
        public string VpnType
        {
            get { return this._vpnType; }
            set { this._vpnType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkGateway class.
        /// </summary>
        public VirtualNetworkGateway()
        {
            this.IpConfigurations = new LazyList<VirtualNetworkGatewayIpConfiguration>();
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkGateway class with
        /// required arguments.
        /// </summary>
        public VirtualNetworkGateway(string location)
            : this()
        {
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Location = location;
        }
    }
}
