// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Network.Models;

namespace Microsoft.Azure.Management.Network.Models
{
    /// <summary>
    /// A common class for general resource information
    /// </summary>
    public partial class VirtualNetworkGatewayConnection : TopLevelResource
    {
        private string _authorizationKey;
        
        /// <summary>
        /// Optional. Gets or sets the authorization key
        /// </summary>
        public string AuthorizationKey
        {
            get { return this._authorizationKey; }
            set { this._authorizationKey = value; }
        }
        
        private string _connectionStatus;
        
        /// <summary>
        /// Optional. Virtual network Gateway connection status
        /// </summary>
        public string ConnectionStatus
        {
            get { return this._connectionStatus; }
            set { this._connectionStatus = value; }
        }
        
        private string _connectionType;
        
        /// <summary>
        /// Optional. Gateway connection type
        /// -Ipsec/Dedicated/VpnClient/Vnet2Vnet
        /// </summary>
        public string ConnectionType
        {
            get { return this._connectionType; }
            set { this._connectionType = value; }
        }
        
        private ulong _egressBytesTransferred;
        
        /// <summary>
        /// Optional. The Egress Bytes Transferred in this connection
        /// </summary>
        public ulong EgressBytesTransferred
        {
            get { return this._egressBytesTransferred; }
            set { this._egressBytesTransferred = value; }
        }
        
        private ulong _ingressBytesTransferred;
        
        /// <summary>
        /// Optional. The Ingress Bytes Transferred in this connection
        /// </summary>
        public ulong IngressBytesTransferred
        {
            get { return this._ingressBytesTransferred; }
            set { this._ingressBytesTransferred = value; }
        }
        
        private LocalNetworkGateway _localNetworkGateway2;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public LocalNetworkGateway LocalNetworkGateway2
        {
            get { return this._localNetworkGateway2; }
            set { this._localNetworkGateway2 = value; }
        }
        
        private ResourceId _peer;
        
        /// <summary>
        /// Optional. The reference to peerings resource.
        /// </summary>
        public ResourceId Peer
        {
            get { return this._peer; }
            set { this._peer = value; }
        }
        
        private string _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets Provisioning state of the
        /// VirtualNetworkGatewayConnection resource Updating/Deleting/Failed
        /// </summary>
        public string ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private string _resourceGuid;
        
        /// <summary>
        /// Optional. Gets or sets resource guid property of the
        /// VirtualNetworkGatewayConnection resource
        /// </summary>
        public string ResourceGuid
        {
            get { return this._resourceGuid; }
            set { this._resourceGuid = value; }
        }
        
        private int _routingWeight;
        
        /// <summary>
        /// Optional. The Routing weight.
        /// </summary>
        public int RoutingWeight
        {
            get { return this._routingWeight; }
            set { this._routingWeight = value; }
        }
        
        private string _sharedKey;
        
        /// <summary>
        /// Optional. The Ipsec share key.
        /// </summary>
        public string SharedKey
        {
            get { return this._sharedKey; }
            set { this._sharedKey = value; }
        }
        
        private VirtualNetworkGateway _virtualNetworkGateway1;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public VirtualNetworkGateway VirtualNetworkGateway1
        {
            get { return this._virtualNetworkGateway1; }
            set { this._virtualNetworkGateway1 = value; }
        }
        
        private VirtualNetworkGateway _virtualNetworkGateway2;
        
        /// <summary>
        /// Optional.
        /// </summary>
        public VirtualNetworkGateway VirtualNetworkGateway2
        {
            get { return this._virtualNetworkGateway2; }
            set { this._virtualNetworkGateway2 = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkGatewayConnection
        /// class.
        /// </summary>
        public VirtualNetworkGatewayConnection()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkGatewayConnection
        /// class with required arguments.
        /// </summary>
        public VirtualNetworkGatewayConnection(string location)
            : this()
        {
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Location = location;
        }
    }
}
