// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.NotificationHubs.Models;

namespace Microsoft.Azure.Management.NotificationHubs.Models
{
    /// <summary>
    /// NotificationHub properties.
    /// </summary>
    public partial class NotificationHubProperties
    {
        private AdmCredential _admCredential;
        
        /// <summary>
        /// Optional. The AdmCredential of the created NotificationHub
        /// </summary>
        public AdmCredential AdmCredential
        {
            get { return this._admCredential; }
            set { this._admCredential = value; }
        }
        
        private ApnsCredential _apnsCredential;
        
        /// <summary>
        /// Optional. The ApnsCredential of the created NotificationHub
        /// </summary>
        public ApnsCredential ApnsCredential
        {
            get { return this._apnsCredential; }
            set { this._apnsCredential = value; }
        }
        
        private IList<SharedAccessAuthorizationRuleProperties> _authorizationRules;
        
        /// <summary>
        /// Optional. The AuthorizationRules of the created NotificationHub
        /// </summary>
        public IList<SharedAccessAuthorizationRuleProperties> AuthorizationRules
        {
            get { return this._authorizationRules; }
            set { this._authorizationRules = value; }
        }
        
        private BaiduCredential _baiduCredential;
        
        /// <summary>
        /// Optional. The BaiduCredential of the created NotificationHub
        /// </summary>
        public BaiduCredential BaiduCredential
        {
            get { return this._baiduCredential; }
            set { this._baiduCredential = value; }
        }
        
        private GcmCredential _gcmCredential;
        
        /// <summary>
        /// Optional. The GcmCredential of the created NotificationHub
        /// </summary>
        public GcmCredential GcmCredential
        {
            get { return this._gcmCredential; }
            set { this._gcmCredential = value; }
        }
        
        private MpnsCredential _mpnsCredential;
        
        /// <summary>
        /// Optional. The MpnsCredential of the created NotificationHub
        /// </summary>
        public MpnsCredential MpnsCredential
        {
            get { return this._mpnsCredential; }
            set { this._mpnsCredential = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. The NotificationHub name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _registrationTtl;
        
        /// <summary>
        /// Optional. The RegistrationTtl of the created NotificationHub
        /// </summary>
        public string RegistrationTtl
        {
            get { return this._registrationTtl; }
            set { this._registrationTtl = value; }
        }
        
        private WnsCredential _wnsCredential;
        
        /// <summary>
        /// Optional. The WnsCredential of the created NotificationHub
        /// </summary>
        public WnsCredential WnsCredential
        {
            get { return this._wnsCredential; }
            set { this._wnsCredential = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NotificationHubProperties class.
        /// </summary>
        public NotificationHubProperties()
        {
            this.AuthorizationRules = new LazyList<SharedAccessAuthorizationRuleProperties>();
        }
    }
}
