// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.NotificationHubs.Models;

namespace Microsoft.Azure.Management.NotificationHubs.Models
{
    /// <summary>
    /// Parameters supplied to the CreateOrUpdate Namespace AuthorizationRules.
    /// </summary>
    public partial class SharedAccessAuthorizationRuleCreateOrUpdateParameters
    {
        private string _location;
        
        /// <summary>
        /// Optional. Gets or sets Namespace data center location.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets Name of the Namespace AuthorizationRule.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private SharedAccessAuthorizationRuleProperties _properties;
        
        /// <summary>
        /// Required. Gets or sets properties of the Namespace
        /// AuthorizationRules.
        /// </summary>
        public SharedAccessAuthorizationRuleProperties Properties
        {
            get { return this._properties; }
            set { this._properties = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// SharedAccessAuthorizationRuleCreateOrUpdateParameters class.
        /// </summary>
        public SharedAccessAuthorizationRuleCreateOrUpdateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// SharedAccessAuthorizationRuleCreateOrUpdateParameters class with
        /// required arguments.
        /// </summary>
        public SharedAccessAuthorizationRuleCreateOrUpdateParameters(SharedAccessAuthorizationRuleProperties properties)
            : this()
        {
            if (properties == null)
            {
                throw new ArgumentNullException("properties");
            }
            this.Properties = properties;
        }
    }
}
