// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.NotificationHubs.Models;

namespace Microsoft.Azure.Management.NotificationHubs.Models
{
    /// <summary>
    /// The response of the List Namespace operation.
    /// </summary>
    public partial class SharedAccessAuthorizationRuleListResponse : AzureOperationResponse
    {
        private string _nextLink;
        
        /// <summary>
        /// Optional. Gets or sets link to the next set of results. Not empty
        /// if Value contains incomplete list of AuthorizationRules
        /// </summary>
        public string NextLink
        {
            get { return this._nextLink; }
            set { this._nextLink = value; }
        }
        
        private IList<SharedAccessAuthorizationRuleResource> _value;
        
        /// <summary>
        /// Optional. Gets or sets result of the List AuthorizationRules
        /// operation.
        /// </summary>
        public IList<SharedAccessAuthorizationRuleResource> Value
        {
            get { return this._value; }
            set { this._value = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// SharedAccessAuthorizationRuleListResponse class.
        /// </summary>
        public SharedAccessAuthorizationRuleListResponse()
        {
            this.Value = new LazyList<SharedAccessAuthorizationRuleResource>();
        }
    }
}
