// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.NotificationHubs.Models
{
    /// <summary>
    /// Description of a NotificationHub WnsCredential.
    /// </summary>
    public partial class WnsCredentialProperties
    {
        private string _packageSid;
        
        /// <summary>
        /// Optional. Gets or sets the package ID for this credential.
        /// </summary>
        public string PackageSid
        {
            get { return this._packageSid; }
            set { this._packageSid = value; }
        }
        
        private string _secretKey;
        
        /// <summary>
        /// Optional. Gets or sets the secret key.
        /// </summary>
        public string SecretKey
        {
            get { return this._secretKey; }
            set { this._secretKey = value; }
        }
        
        private string _windowsLiveEndpoint;
        
        /// <summary>
        /// Optional. Gets or sets the Windows Live endpoint.
        /// </summary>
        public string WindowsLiveEndpoint
        {
            get { return this._windowsLiveEndpoint; }
            set { this._windowsLiveEndpoint = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WnsCredentialProperties class.
        /// </summary>
        public WnsCredentialProperties()
        {
        }
    }
}
