// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// Linked service properties.
    /// </summary>
    public partial class LinkedServiceProperties
    {
        private string _resourceId;
        
        /// <summary>
        /// Required. Gets or sets the resource id of the resource that will be
        /// linked to the workspace.
        /// </summary>
        public string ResourceId
        {
            get { return this._resourceId; }
            set { this._resourceId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the LinkedServiceProperties class.
        /// </summary>
        public LinkedServiceProperties()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the LinkedServiceProperties class
        /// with required arguments.
        /// </summary>
        public LinkedServiceProperties(string resourceId)
            : this()
        {
            if (resourceId == null)
            {
                throw new ArgumentNullException("resourceId");
            }
            this.ResourceId = resourceId;
        }
    }
}
