// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.OperationalInsights.Models;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// Parameters specifying the search query and range.
    /// </summary>
    public partial class SearchGetSearchResultsParameters
    {
        private System.DateTime? _end;
        
        /// <summary>
        /// Optional. Gets or sets the end date filter, so the only query
        /// results returned are before this date.
        /// </summary>
        public System.DateTime? End
        {
            get { return this._end; }
            set { this._end = value; }
        }
        
        private Highlight _highlight;
        
        /// <summary>
        /// Optional. Gets or sets the highlight that looks for all occurences
        /// of a string.
        /// </summary>
        public Highlight Highlight
        {
            get { return this._highlight; }
            set { this._highlight = value; }
        }
        
        private string _query;
        
        /// <summary>
        /// Optional. Gets or sets the query to search.
        /// </summary>
        public string Query
        {
            get { return this._query; }
            set { this._query = value; }
        }
        
        private System.DateTime? _start;
        
        /// <summary>
        /// Optional. Gets or sets the start date filter, so the only query
        /// results returned are after this date.
        /// </summary>
        public System.DateTime? Start
        {
            get { return this._start; }
            set { this._start = value; }
        }
        
        private long _top;
        
        /// <summary>
        /// Optional. Gets or sets the number to get from the top.
        /// </summary>
        public long Top
        {
            get { return this._top; }
            set { this._top = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SearchGetSearchResultsParameters
        /// class.
        /// </summary>
        public SearchGetSearchResultsParameters()
        {
        }
    }
}
