// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.OperationalInsights.Models;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// Metadata for search results.
    /// </summary>
    public partial class SearchMetadata
    {
        private string _aggregatedGroupingFields;
        
        /// <summary>
        /// Optional. Gets or sets the aggregated grouping fields.
        /// </summary>
        public string AggregatedGroupingFields
        {
            get { return this._aggregatedGroupingFields; }
            set { this._aggregatedGroupingFields = value; }
        }
        
        private string _aggregatedValueField;
        
        /// <summary>
        /// Optional. Gets or sets the aggregated value field.
        /// </summary>
        public string AggregatedValueField
        {
            get { return this._aggregatedValueField; }
            set { this._aggregatedValueField = value; }
        }
        
        private IList<CoreSummary> _coreSummaries;
        
        /// <summary>
        /// Optional. Gets or sets the core summaries.
        /// </summary>
        public IList<CoreSummary> CoreSummaries
        {
            get { return this._coreSummaries; }
            set { this._coreSummaries = value; }
        }
        
        private string _eTag;
        
        /// <summary>
        /// Optional. Gets or sets the ETag of the search results.
        /// </summary>
        public string ETag
        {
            get { return this._eTag; }
            set { this._eTag = value; }
        }
        
        private System.Guid? _id;
        
        /// <summary>
        /// Optional. Gets or sets the id of the search results request.
        /// </summary>
        public System.Guid? Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private System.DateTime? _lastUpdated;
        
        /// <summary>
        /// Optional. Gets or sets the time of last update.
        /// </summary>
        public System.DateTime? LastUpdated
        {
            get { return this._lastUpdated; }
            set { this._lastUpdated = value; }
        }
        
        private long? _max;
        
        /// <summary>
        /// Optional. Gets or sets the max.
        /// </summary>
        public long? Max
        {
            get { return this._max; }
            set { this._max = value; }
        }
        
        private long? _requestTime;
        
        /// <summary>
        /// Optional. Gets or sets the request time.
        /// </summary>
        public long? RequestTime
        {
            get { return this._requestTime; }
            set { this._requestTime = value; }
        }
        
        private string _resultType;
        
        /// <summary>
        /// Optional. Gets or sets the search result type.
        /// </summary>
        public string ResultType
        {
            get { return this._resultType; }
            set { this._resultType = value; }
        }
        
        private MetadataSchema _schema;
        
        /// <summary>
        /// Optional. Gets or sets the schema.
        /// </summary>
        public MetadataSchema Schema
        {
            get { return this._schema; }
            set { this._schema = value; }
        }
        
        private string _searchId;
        
        /// <summary>
        /// Optional. Gets or sets the request id of the search.
        /// </summary>
        public string SearchId
        {
            get { return this._searchId; }
            set { this._searchId = value; }
        }
        
        private IList<SearchSort> _sort;
        
        /// <summary>
        /// Optional. Gets or sets sort.
        /// </summary>
        public IList<SearchSort> Sort
        {
            get { return this._sort; }
            set { this._sort = value; }
        }
        
        private System.DateTime? _startTime;
        
        /// <summary>
        /// Optional. Gets or sets the start time for the search.
        /// </summary>
        public System.DateTime? StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Gets or sets the status of the search results.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private long? _sum;
        
        /// <summary>
        /// Optional. Gets or sets the sum.
        /// </summary>
        public long? Sum
        {
            get { return this._sum; }
            set { this._sum = value; }
        }
        
        private long? _top;
        
        /// <summary>
        /// Optional. Gets or sets the number of top search results.
        /// </summary>
        public long? Top
        {
            get { return this._top; }
            set { this._top = value; }
        }
        
        private long? _total;
        
        /// <summary>
        /// Optional. Gets or sets the total search results.
        /// </summary>
        public long? Total
        {
            get { return this._total; }
            set { this._total = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SearchMetadata class.
        /// </summary>
        public SearchMetadata()
        {
            this.CoreSummaries = new LazyList<CoreSummary>();
            this.Sort = new LazyList<SearchSort>();
        }
    }
}
