// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.OperationalInsights.Models;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// The list workspaces operation response.
    /// </summary>
    public partial class WorkspaceListResponse : AzureOperationResponse
    {
        private string _nextLink;
        
        /// <summary>
        /// Optional. Gets or sets the link (url) to the next page of results.
        /// </summary>
        public string NextLink
        {
            get { return this._nextLink; }
            set { this._nextLink = value; }
        }
        
        private IList<Workspace> _workspaces;
        
        /// <summary>
        /// Optional. Gets or sets a list of workspace instances.
        /// </summary>
        public IList<Workspace> Workspaces
        {
            get { return this._workspaces; }
            set { this._workspaces = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WorkspaceListResponse class.
        /// </summary>
        public WorkspaceListResponse()
        {
            this.Workspaces = new LazyList<Workspace>();
        }
    }
}
