// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Azure IaaS VM workload-specifc job object.
    /// </summary>
    public partial class AzureIaaSVMJob : Job
    {
        private IList<JobSupportedAction> _actionsInfo;
        
        /// <summary>
        /// Optional. List of supported actions on this job.
        /// </summary>
        public IList<JobSupportedAction> ActionsInfo
        {
            get { return this._actionsInfo; }
            set { this._actionsInfo = value; }
        }
        
        private TimeSpan _duration;
        
        /// <summary>
        /// Optional. Time elapsed during the execution of this job.
        /// </summary>
        public TimeSpan Duration
        {
            get { return this._duration; }
            set { this._duration = value; }
        }
        
        private IList<AzureIaaSVMErrorInfo> _errorDetails;
        
        /// <summary>
        /// Optional. Details about errors that occured during the execution of
        /// this job.
        /// </summary>
        public IList<AzureIaaSVMErrorInfo> ErrorDetails
        {
            get { return this._errorDetails; }
            set { this._errorDetails = value; }
        }
        
        private AzureIaaSVMJobExtendedInfo _extendedInfo;
        
        /// <summary>
        /// Optional. Extended info for this job.
        /// </summary>
        public AzureIaaSVMJobExtendedInfo ExtendedInfo
        {
            get { return this._extendedInfo; }
            set { this._extendedInfo = value; }
        }
        
        private string _virtualMachineVersion;
        
        /// <summary>
        /// Optional. Specifies whether the item in the job's context is a
        /// Classic or a Compute VM.
        /// </summary>
        public string VirtualMachineVersion
        {
            get { return this._virtualMachineVersion; }
            set { this._virtualMachineVersion = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AzureIaaSVMJob class.
        /// </summary>
        public AzureIaaSVMJob()
        {
            this.ActionsInfo = new LazyList<JobSupportedAction>();
            this.ErrorDetails = new LazyList<AzureIaaSVMErrorInfo>();
        }
    }
}
