// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// IaaS VM workload-specific protected item.
    /// </summary>
    public partial class AzureIaaSVMProtectedItem : ProtectedItem
    {
        private AzureIaaSVMProtectedItemExtendedInfo _extendedInfo;
        
        /// <summary>
        /// Optional. Extended info for this protected item.
        /// </summary>
        public AzureIaaSVMProtectedItemExtendedInfo ExtendedInfo
        {
            get { return this._extendedInfo; }
            set { this._extendedInfo = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the VM represented by this protected
        /// item.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _lastBackupStatus;
        
        /// <summary>
        /// Optional. Health status of the last backup operation on this
        /// protected item. Possible values: Healthy, Unhealthy.
        /// </summary>
        public string LastBackupStatus
        {
            get { return this._lastBackupStatus; }
            set { this._lastBackupStatus = value; }
        }
        
        private System.DateTime? _lastBackupTime;
        
        /// <summary>
        /// Optional. Timestamp of the last backup operation on this protected
        /// item.
        /// </summary>
        public System.DateTime? LastBackupTime
        {
            get { return this._lastBackupTime; }
            set { this._lastBackupTime = value; }
        }
        
        private string _protectionState;
        
        /// <summary>
        /// Optional. State of protection of this protected item.
        /// </summary>
        public string ProtectionState
        {
            get { return this._protectionState; }
            set { this._protectionState = value; }
        }
        
        private string _protectionStatus;
        
        /// <summary>
        /// Optional. Status of protection of this protected item.
        /// </summary>
        public string ProtectionStatus
        {
            get { return this._protectionStatus; }
            set { this._protectionStatus = value; }
        }
        
        private string _virtualMachineId;
        
        /// <summary>
        /// Optional. Fully qualified ARM ID of the virtual machine represented
        /// by this item.
        /// </summary>
        public string VirtualMachineId
        {
            get { return this._virtualMachineId; }
            set { this._virtualMachineId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AzureIaaSVMProtectedItem class.
        /// </summary>
        public AzureIaaSVMProtectedItem()
        {
        }
    }
}
