// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Azure SQL workload-specific protected item.
    /// </summary>
    public partial class AzureSqlProtectedItem : ProtectedItem
    {
        private AzureSqlProtectedItemExtendedInfo _extendedInfo;
        
        /// <summary>
        /// Optional. Extended info for this protected item.
        /// </summary>
        public AzureSqlProtectedItemExtendedInfo ExtendedInfo
        {
            get { return this._extendedInfo; }
            set { this._extendedInfo = value; }
        }
        
        private string _protectedItemDataId;
        
        /// <summary>
        /// Optional. Data ID of this protected item.
        /// </summary>
        public string ProtectedItemDataId
        {
            get { return this._protectedItemDataId; }
            set { this._protectedItemDataId = value; }
        }
        
        private string _protectionState;
        
        /// <summary>
        /// Optional. State of protection of this protected item.
        /// </summary>
        public string ProtectionState
        {
            get { return this._protectionState; }
            set { this._protectionState = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AzureSqlProtectedItem class.
        /// </summary>
        public AzureSqlProtectedItem()
        {
        }
    }
}
