// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// HTTP request headers for azure recovery services operations.
    /// </summary>
    public partial class CustomRequestHeaders
    {
        private string _clientRequestId;
        
        /// <summary>
        /// Optional. Unique identifier for identifying every request sent to
        /// Azure recovery services. In case of service internal errors,
        /// please communicate this ID to the engineering teams for further
        /// debugging.
        /// </summary>
        public string ClientRequestId
        {
            get { return this._clientRequestId; }
            set { this._clientRequestId = value; }
        }
        
        private string _culture;
        
        /// <summary>
        /// Optional. Culture in which service has to return the output content.
        /// </summary>
        public string Culture
        {
            get { return this._culture; }
            set { this._culture = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CustomRequestHeaders class.
        /// </summary>
        public CustomRequestHeaders()
        {
        }
    }
}
