// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Response object for the export jobs operation.
    /// </summary>
    public partial class ExportJobsOperationResultInfo : OperationResultInfoBase
    {
        private string _blobSasKey;
        
        /// <summary>
        /// Optional. SAS key to access the blob. It expires in 15 mins.
        /// </summary>
        public string BlobSasKey
        {
            get { return this._blobSasKey; }
            set { this._blobSasKey = value; }
        }
        
        private string _blobUrl;
        
        /// <summary>
        /// Optional. URL of the blob into which the serialized string of list
        /// of jobs is exported.
        /// </summary>
        public string BlobUrl
        {
            get { return this._blobUrl; }
            set { this._blobUrl = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ExportJobsOperationResultInfo
        /// class.
        /// </summary>
        public ExportJobsOperationResultInfo()
        {
        }
    }
}
