// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Defines some workload agnostic properties for a job.
    /// </summary>
    public partial class Job : JobBase
    {
        private string _activityId;
        
        /// <summary>
        /// Optional. Activity ID of the job.
        /// </summary>
        public string ActivityId
        {
            get { return this._activityId; }
            set { this._activityId = value; }
        }
        
        private string _backupManagementType;
        
        /// <summary>
        /// Optional. Type of backup management for the item in whose context
        /// the job is executing.
        /// </summary>
        public string BackupManagementType
        {
            get { return this._backupManagementType; }
            set { this._backupManagementType = value; }
        }
        
        private System.DateTime? _endTime;
        
        /// <summary>
        /// Optional. Timestamp when this job ended its execution (if this job
        /// already completed its execution).
        /// </summary>
        public System.DateTime? EndTime
        {
            get { return this._endTime; }
            set { this._endTime = value; }
        }
        
        private string _entityFriendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the entity on which the current job is
        /// being executed.
        /// </summary>
        public string EntityFriendlyName
        {
            get { return this._entityFriendlyName; }
            set { this._entityFriendlyName = value; }
        }
        
        private string _operation;
        
        /// <summary>
        /// Optional. Name of the operation created by this job.
        /// </summary>
        public string Operation
        {
            get { return this._operation; }
            set { this._operation = value; }
        }
        
        private DateTime _startTime;
        
        /// <summary>
        /// Optional. Timestamp when this job started its execution.
        /// </summary>
        public DateTime StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Status of this job.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Job class.
        /// </summary>
        public Job()
        {
        }
    }
}
