// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    public enum JobStatus
    {
        /// <summary>
        /// Invalid status of Job.
        /// </summary>
        Invalid = 0,
        
        /// <summary>
        /// Status of job when it is running normally.
        /// </summary>
        InProgress = 1,
        
        /// <summary>
        /// Status of job when it has completed running successfully.
        /// </summary>
        Completed = 2,
        
        /// <summary>
        /// Status of job when it failed to run successfully.
        /// </summary>
        Failed = 3,
        
        /// <summary>
        /// Status of job when it completes execution but with few warnings.
        /// </summary>
        CompletedWithWarnings = 4,
        
        /// <summary>
        /// Status of a job which has been cancelled.
        /// </summary>
        Cancelled = 5,
        
        /// <summary>
        /// Status of a job which is getting cancelled.
        /// </summary>
        Cancelling = 6,
    }
}
