// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// MAB workload-specific protected item.
    /// </summary>
    public partial class MabFileFolderProtectedItem : ProtectedItem
    {
        private string _computerName;
        
        /// <summary>
        /// Optional. Name of the computer represented by this protected item.
        /// </summary>
        public string ComputerName
        {
            get { return this._computerName; }
            set { this._computerName = value; }
        }
        
        private MabFileFolderProtectedItemExtendedInfo _extendedInfo;
        
        /// <summary>
        /// Optional. Extended info for this protected item.
        /// </summary>
        public MabFileFolderProtectedItemExtendedInfo ExtendedInfo
        {
            get { return this._extendedInfo; }
            set { this._extendedInfo = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of this protected item.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MabFileFolderProtectedItem class.
        /// </summary>
        public MabFileFolderProtectedItem()
        {
        }
    }
}
