// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Operation status extended info for list of jobs.
    /// </summary>
    public partial class OperationStatusJobsExtendedInfo : OperationStatusExtendedInfo
    {
        private IDictionary<string, string> _failedJobsError;
        
        /// <summary>
        /// Optional. Stores all the failed jobs along with the corresponding
        /// error codes.
        /// </summary>
        public IDictionary<string, string> FailedJobsError
        {
            get { return this._failedJobsError; }
            set { this._failedJobsError = value; }
        }
        
        private IList<string> _jobIds;
        
        /// <summary>
        /// Optional. IDs of the jobs created for the protected item.
        /// </summary>
        public IList<string> JobIds
        {
            get { return this._jobIds; }
            set { this._jobIds = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OperationStatusJobsExtendedInfo
        /// class.
        /// </summary>
        public OperationStatusJobsExtendedInfo()
        {
            this.FailedJobsError = new LazyDictionary<string, string>();
            this.JobIds = new LazyList<string>();
        }
    }
}
