// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Base class for protectable item. Workload-specific protectable items
    /// are derived from this class.
    /// </summary>
    public partial class ProtectableItem : ProtectableObjectBase
    {
        private string _backupManagementType;
        
        /// <summary>
        /// Optional. Type of backup managmenent for the protectable item.
        /// </summary>
        public string BackupManagementType
        {
            get { return this._backupManagementType; }
            set { this._backupManagementType = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the protectable item.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _protectableItemType;
        
        /// <summary>
        /// Optional. Type of the protectable item.
        /// </summary>
        public string ProtectableItemType
        {
            get { return this._protectableItemType; }
            set { this._protectableItemType = value; }
        }
        
        private string _protectionState;
        
        /// <summary>
        /// Optional. Protection state of the protectable item.
        /// </summary>
        public string ProtectionState
        {
            get { return this._protectionState; }
            set { this._protectionState = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectableItem class.
        /// </summary>
        public ProtectableItem()
        {
        }
    }
}
