// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Base class for protected item. Workload-specific protected items are
    /// derived from this class.
    /// </summary>
    public partial class ProtectedItem : ProtectedItemBase
    {
        private string _backupManagementType;
        
        /// <summary>
        /// Optional. Type of backup managmenent for the protected item.
        /// </summary>
        public string BackupManagementType
        {
            get { return this._backupManagementType; }
            set { this._backupManagementType = value; }
        }
        
        private System.DateTime? _lastRecoveryPoint;
        
        /// <summary>
        /// Optional. Timestamp when the last (latest) recovery point was
        /// created for this protected item.
        /// </summary>
        public System.DateTime? LastRecoveryPoint
        {
            get { return this._lastRecoveryPoint; }
            set { this._lastRecoveryPoint = value; }
        }
        
        private string _policyId;
        
        /// <summary>
        /// Optional. ID of the protection policy with which this protected
        /// item is protected.
        /// </summary>
        public string PolicyId
        {
            get { return this._policyId; }
            set { this._policyId = value; }
        }
        
        private string _sourceResourceId;
        
        /// <summary>
        /// Optional. ARM ID of the resource to be protected.
        /// </summary>
        public string SourceResourceId
        {
            get { return this._sourceResourceId; }
            set { this._sourceResourceId = value; }
        }
        
        private string _workloadType;
        
        /// <summary>
        /// Optional. Type of workload this item represents. Possible values:
        /// VM, FileFolder.
        /// </summary>
        public string WorkloadType
        {
            get { return this._workloadType; }
            set { this._workloadType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectedItem class.
        /// </summary>
        public ProtectedItem()
        {
        }
    }
}
