// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Base class for protection container. Workload-specific protection
    /// containers are derived from this class.
    /// </summary>
    public partial class ProtectionContainer : ProtectionContainerBase
    {
        private string _backupManagementType;
        
        /// <summary>
        /// Optional. Type of backup managmenent for the protection container.
        /// </summary>
        public string BackupManagementType
        {
            get { return this._backupManagementType; }
            set { this._backupManagementType = value; }
        }
        
        private string _containerType;
        
        /// <summary>
        /// Optional. Type of the protection container. Possible values are:
        /// IaasVMContainer, Windows.
        /// </summary>
        public string ContainerType
        {
            get { return this._containerType; }
            set { this._containerType = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the protection container.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _healthStatus;
        
        /// <summary>
        /// Optional. Status of health of the protection container.
        /// </summary>
        public string HealthStatus
        {
            get { return this._healthStatus; }
            set { this._healthStatus = value; }
        }
        
        private string _protectableObjectType;
        
        /// <summary>
        /// Optional. Type of the protectable object associated with this
        /// protection container. Possible values: IaasVMContainer,
        /// MABWindowsContainer, AzureSqlContainer.
        /// </summary>
        public string ProtectableObjectType
        {
            get { return this._protectableObjectType; }
            set { this._protectableObjectType = value; }
        }
        
        private string _registrationStatus;
        
        /// <summary>
        /// Optional. Status of registration of the protection container with
        /// the Recovery Services Vault.
        /// </summary>
        public string RegistrationStatus
        {
            get { return this._registrationStatus; }
            set { this._registrationStatus = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectionContainer class.
        /// </summary>
        public ProtectionContainer()
        {
        }
    }
}
