// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Base class for recovery points. Workload-specific recovery points are
    /// derived from this class.
    /// </summary>
    public partial class RecoveryPoint : RecoveryPointBase
    {
        private bool _isInstantILRSessionActive;
        
        /// <summary>
        /// Optional. Identifies whether the instant ILR session associated
        /// with this recovery point is still active.
        /// </summary>
        public bool IsInstantILRSessionActive
        {
            get { return this._isInstantILRSessionActive; }
            set { this._isInstantILRSessionActive = value; }
        }
        
        private bool? _isSourceVMEncrypted;
        
        /// <summary>
        /// Optional. Identifies whether this recovery point represents an
        /// encrypted VM at the time of backup.
        /// </summary>
        public bool? IsSourceVMEncrypted
        {
            get { return this._isSourceVMEncrypted; }
            set { this._isSourceVMEncrypted = value; }
        }
        
        private KeyAndSecretDetails _keyAndSecret;
        
        /// <summary>
        /// Optional. Required details for recovering an encrypted VM.
        /// Applicable only when IsSourceVMEncrypted is true.
        /// </summary>
        public KeyAndSecretDetails KeyAndSecret
        {
            get { return this._keyAndSecret; }
            set { this._keyAndSecret = value; }
        }
        
        private string _recoveryPointAdditionalInfo;
        
        /// <summary>
        /// Optional. Additional information associated with this recovery
        /// point.
        /// </summary>
        public string RecoveryPointAdditionalInfo
        {
            get { return this._recoveryPointAdditionalInfo; }
            set { this._recoveryPointAdditionalInfo = value; }
        }
        
        private string _recoveryPointTime;
        
        /// <summary>
        /// Optional. Time at which this recovery point was created.
        /// </summary>
        public string RecoveryPointTime
        {
            get { return this._recoveryPointTime; }
            set { this._recoveryPointTime = value; }
        }
        
        private string _recoveryPointType;
        
        /// <summary>
        /// Optional. Type of the recovery point.
        /// </summary>
        public string RecoveryPointType
        {
            get { return this._recoveryPointType; }
            set { this._recoveryPointType = value; }
        }
        
        private string _sourceVMStorageType;
        
        /// <summary>
        /// Optional. Storage type of the source VM associated with this
        /// recovery point.
        /// </summary>
        public string SourceVMStorageType
        {
            get { return this._sourceVMStorageType; }
            set { this._sourceVMStorageType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RecoveryPoint class.
        /// </summary>
        public RecoveryPoint()
        {
        }
    }
}
