// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Retention duration.
    /// </summary>
    public partial class RetentionDuration
    {
        private int _count;
        
        /// <summary>
        /// Optional. Count of duration types. Retention duration is obtained
        /// by the counting the duration type Count times. For example, when
        /// Count = 3 and DurationType = Weeks, retention duration will be
        /// three weeks.
        /// </summary>
        public int Count
        {
            get { return this._count; }
            set { this._count = value; }
        }
        
        private string _durationType;
        
        /// <summary>
        /// Optional. Retention duration type of retention policy. Possible
        /// values: Days, Weeks, Months, Years.
        /// </summary>
        public string DurationType
        {
            get { return this._durationType; }
            set { this._durationType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RetentionDuration class.
        /// </summary>
        public RetentionDuration()
        {
        }
    }
}
