// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Azure.Management.RecoveryServices.Backup.Models;

namespace Microsoft.Azure.Management.RecoveryServices.Backup.Models
{
    /// <summary>
    /// Simple policy schedule.
    /// </summary>
    public partial class SimpleSchedulePolicy : SchedulePolicy
    {
        private IList<string> _scheduleRunDays;
        
        /// <summary>
        /// Optional. List of days of week this schedule has to be run.
        /// </summary>
        public IList<string> ScheduleRunDays
        {
            get { return this._scheduleRunDays; }
            set { this._scheduleRunDays = value; }
        }
        
        private string _scheduleRunFrequency;
        
        /// <summary>
        /// Optional. Frequency of the schedule operation of this policy.
        /// Possible values: Daily, Weekly.
        /// </summary>
        public string ScheduleRunFrequency
        {
            get { return this._scheduleRunFrequency; }
            set { this._scheduleRunFrequency = value; }
        }
        
        private IList<DateTime> _scheduleRunTimes;
        
        /// <summary>
        /// Optional. List of times of day this schedule has to be run.
        /// </summary>
        public IList<DateTime> ScheduleRunTimes
        {
            get { return this._scheduleRunTimes; }
            set { this._scheduleRunTimes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SimpleSchedulePolicy class.
        /// </summary>
        public SimpleSchedulePolicy()
        {
            this.ScheduleRunDays = new List<string>();
            this.ScheduleRunTimes = new List<DateTime>();
        }
    }
}
