// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.RecoveryServices.Models
{
    /// <summary>
    /// The certificate properties
    /// </summary>
    public partial class CertificateProperties
    {
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the certificate.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _globalAcsHostName;
        
        /// <summary>
        /// Optional. Global ACS Host name.
        /// </summary>
        public string GlobalAcsHostName
        {
            get { return this._globalAcsHostName; }
            set { this._globalAcsHostName = value; }
        }
        
        private string _globalAcsNamespace;
        
        /// <summary>
        /// Optional. Global ACS Namespace.
        /// </summary>
        public string GlobalAcsNamespace
        {
            get { return this._globalAcsNamespace; }
            set { this._globalAcsNamespace = value; }
        }
        
        private string _globalAcsRPRealm;
        
        /// <summary>
        /// Optional. Global ACS RP realm.
        /// </summary>
        public string GlobalAcsRPRealm
        {
            get { return this._globalAcsRPRealm; }
            set { this._globalAcsRPRealm = value; }
        }
        
        private long _resourceId;
        
        /// <summary>
        /// Optional. ASR vault id: resource id
        /// </summary>
        public long ResourceId
        {
            get { return this._resourceId; }
            set { this._resourceId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CertificateProperties class.
        /// </summary>
        public CertificateProperties()
        {
        }
    }
}
