// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.RecoveryServices.Models
{
    /// <summary>
    /// The definition of jobs summary object.
    /// </summary>
    public partial class JobsSummary
    {
        private int _failedJobs;
        
        /// <summary>
        /// Required. Count of failed jobs.
        /// </summary>
        public int FailedJobs
        {
            get { return this._failedJobs; }
            set { this._failedJobs = value; }
        }
        
        private int _inProgressJobs;
        
        /// <summary>
        /// Required. Count of in progress jobs.
        /// </summary>
        public int InProgressJobs
        {
            get { return this._inProgressJobs; }
            set { this._inProgressJobs = value; }
        }
        
        private int _suspendedJobs;
        
        /// <summary>
        /// Required. Count of suspended jobs.
        /// </summary>
        public int SuspendedJobs
        {
            get { return this._suspendedJobs; }
            set { this._suspendedJobs = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobsSummary class.
        /// </summary>
        public JobsSummary()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the JobsSummary class with required
        /// arguments.
        /// </summary>
        public JobsSummary(int failedJobs, int suspendedJobs, int inProgressJobs)
            : this()
        {
            this.FailedJobs = failedJobs;
            this.SuspendedJobs = suspendedJobs;
            this.InProgressJobs = inProgressJobs;
        }
    }
}
