// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.RecoveryServices.Models
{
    /// <summary>
    /// The definition of Monitoring summary object.
    /// </summary>
    public partial class MonitoringSummary
    {
        private int _eventsCount;
        
        /// <summary>
        /// Required. Count of all critical warning events.
        /// </summary>
        public int EventsCount
        {
            get { return this._eventsCount; }
            set { this._eventsCount = value; }
        }
        
        private int _unHealthyProviderCount;
        
        /// <summary>
        /// Required. Count of unhealthy replication providers.
        /// </summary>
        public int UnHealthyProviderCount
        {
            get { return this._unHealthyProviderCount; }
            set { this._unHealthyProviderCount = value; }
        }
        
        private int _unHealthyVmCount;
        
        /// <summary>
        /// Required. Count of unhealthy VMs.
        /// </summary>
        public int UnHealthyVmCount
        {
            get { return this._unHealthyVmCount; }
            set { this._unHealthyVmCount = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MonitoringSummary class.
        /// </summary>
        public MonitoringSummary()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the MonitoringSummary class with
        /// required arguments.
        /// </summary>
        public MonitoringSummary(int unHealthyVmCount, int unHealthyProviderCount, int eventsCount)
            : this()
        {
            this.UnHealthyVmCount = unHealthyVmCount;
            this.UnHealthyProviderCount = unHealthyProviderCount;
            this.EventsCount = eventsCount;
        }
    }
}
