// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of automation runbook task details object.
    /// </summary>
    public partial class AutomationRunbookTaskDetails : TaskTypeDetails
    {
        private string _accountName;
        
        /// <summary>
        /// Required. Automation account name of the runbook.
        /// </summary>
        public string AccountName
        {
            get { return this._accountName; }
            set { this._accountName = value; }
        }
        
        private string _cloudServiceName;
        
        /// <summary>
        /// Required. Cloud service name of automation runbook account.
        /// </summary>
        public string CloudServiceName
        {
            get { return this._cloudServiceName; }
            set { this._cloudServiceName = value; }
        }
        
        private bool _isPrimarySideScript;
        
        /// <summary>
        /// Required. Indicates whether it is a primary side script or not.
        /// </summary>
        public bool IsPrimarySideScript
        {
            get { return this._isPrimarySideScript; }
            set { this._isPrimarySideScript = value; }
        }
        
        private string _jobId;
        
        /// <summary>
        /// Required. Job Id of the runbook execution.
        /// </summary>
        public string JobId
        {
            get { return this._jobId; }
            set { this._jobId = value; }
        }
        
        private string _jobOutput;
        
        /// <summary>
        /// Required. Job execution output of the runbook.
        /// </summary>
        public string JobOutput
        {
            get { return this._jobOutput; }
            set { this._jobOutput = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Name of the task.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _runbookId;
        
        /// <summary>
        /// Required. Runbook Id.
        /// </summary>
        public string RunbookId
        {
            get { return this._runbookId; }
            set { this._runbookId = value; }
        }
        
        private string _runbookName;
        
        /// <summary>
        /// Required. Runbook name.
        /// </summary>
        public string RunbookName
        {
            get { return this._runbookName; }
            set { this._runbookName = value; }
        }
        
        private string _subscriptionId;
        
        /// <summary>
        /// Required. Subscription Id of the automation runbook account.
        /// </summary>
        public string SubscriptionId
        {
            get { return this._subscriptionId; }
            set { this._subscriptionId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AutomationRunbookTaskDetails
        /// class.
        /// </summary>
        public AutomationRunbookTaskDetails()
        {
        }
    }
}
