// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Store the extended details of the Azure fabric.
    /// </summary>
    public partial class AzureFabricSpecificDetails : FabricSpecificDetails
    {
        private IList<string> _containerIds;
        
        /// <summary>
        /// Optional. List of ARM Ids for the containers.
        /// </summary>
        public IList<string> ContainerIds
        {
            get { return this._containerIds; }
            set { this._containerIds = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Optional. The list of Process Servers associated with the fabric.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AzureFabricSpecificDetails class.
        /// </summary>
        public AzureFabricSpecificDetails()
        {
            this.ContainerIds = new LazyList<string>();
        }
    }
}
