// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of consistency check task details object.
    /// </summary>
    public partial class ConsistencyCheckTaskDetails : TaskTypeDetails
    {
        private IList<InconsistentVmDetails> _vmDetails;
        
        /// <summary>
        /// Required. List of inconsistent VM details.
        /// </summary>
        public IList<InconsistentVmDetails> VmDetails
        {
            get { return this._vmDetails; }
            set { this._vmDetails = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ConsistencyCheckTaskDetails class.
        /// </summary>
        public ConsistencyCheckTaskDetails()
        {
            this.VmDetails = new LazyList<InconsistentVmDetails>();
        }
        
        /// <summary>
        /// Initializes a new instance of the ConsistencyCheckTaskDetails class
        /// with required arguments.
        /// </summary>
        public ConsistencyCheckTaskDetails(List<InconsistentVmDetails> vmDetails, string type)
            : this()
        {
            if (vmDetails == null)
            {
                throw new ArgumentNullException("vmDetails");
            }
            if (type == null)
            {
                throw new ArgumentNullException("type");
            }
            this.VmDetails = vmDetails;
            this.Type = type;
        }
    }
}
