// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Hyper V Replica Provider specific entity details.
    /// </summary>
    public partial class HyperVVirtualMachineDetails : ProtectableItemTypeSettings
    {
        private IList<DiskDetails> _diskDetailsList;
        
        /// <summary>
        /// Optional. Gets or sets the DiskDetails.
        /// </summary>
        public IList<DiskDetails> DiskDetailsList
        {
            get { return this._diskDetailsList; }
            set { this._diskDetailsList = value; }
        }
        
        private string _generation;
        
        /// <summary>
        /// Optional. Gets or sets the Generation.
        /// </summary>
        public string Generation
        {
            get { return this._generation; }
            set { this._generation = value; }
        }
        
        private OSDetails _oSDetails;
        
        /// <summary>
        /// Optional. Gets or sets the OSDetails.
        /// </summary>
        public OSDetails OSDetails
        {
            get { return this._oSDetails; }
            set { this._oSDetails = value; }
        }
        
        private string _sourceItemId;
        
        /// <summary>
        /// Optional. Gets or sets the source id of the object.
        /// </summary>
        public string SourceItemId
        {
            get { return this._sourceItemId; }
            set { this._sourceItemId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HyperVVirtualMachineDetails class.
        /// </summary>
        public HyperVVirtualMachineDetails()
        {
            this.DiskDetailsList = new LazyList<DiskDetails>();
        }
    }
}
