// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of inline workflow task details object.
    /// </summary>
    public partial class InlineWorkflowTaskDetails : GroupTaskDetails
    {
        private IList<string> _workflowIds;
        
        /// <summary>
        /// Required. List of child workflow Ids.
        /// </summary>
        public IList<string> WorkflowIds
        {
            get { return this._workflowIds; }
            set { this._workflowIds = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the InlineWorkflowTaskDetails class.
        /// </summary>
        public InlineWorkflowTaskDetails()
        {
            this.WorkflowIds = new LazyList<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the InlineWorkflowTaskDetails class
        /// with required arguments.
        /// </summary>
        public InlineWorkflowTaskDetails(List<string> workflowIds, string type, List<AsrTaskBase> childTasks)
            : this()
        {
            if (workflowIds == null)
            {
                throw new ArgumentNullException("workflowIds");
            }
            if (type == null)
            {
                throw new ArgumentNullException("type");
            }
            if (childTasks == null)
            {
                throw new ArgumentNullException("childTasks");
            }
            this.WorkflowIds = workflowIds;
            this.Type = type;
            this.ChildTasks = childTasks;
        }
    }
}
