// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The details of an update of the mobility service.
    /// </summary>
    public partial class MobilityServiceUpdate
    {
        private string _osType;
        
        /// <summary>
        /// Optional. The OS type.
        /// </summary>
        public string OsType
        {
            get { return this._osType; }
            set { this._osType = value; }
        }
        
        private string _rebootStatus;
        
        /// <summary>
        /// Optional. The reboot status of the update - whether it is required
        /// or not. Values can be 'Required' or 'NotRequired'
        /// </summary>
        public string RebootStatus
        {
            get { return this._rebootStatus; }
            set { this._rebootStatus = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. The version of the latest update.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MobilityServiceUpdate class.
        /// </summary>
        public MobilityServiceUpdate()
        {
        }
    }
}
