// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a Fabric properties.
    /// </summary>
    public partial class ProtectableItemProperties
    {
        private ProtectableItemTypeSettings _customDetails;
        
        /// <summary>
        /// Optional. Gets or sets the Replication provider custom settings.
        /// </summary>
        public ProtectableItemTypeSettings CustomDetails
        {
            get { return this._customDetails; }
            set { this._customDetails = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Gets or sets the name.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private IList<string> _protectionReadinessErrors;
        
        /// <summary>
        /// Optional. Gets or sets the ProtectionReadinessErrors.
        /// </summary>
        public IList<string> ProtectionReadinessErrors
        {
            get { return this._protectionReadinessErrors; }
            set { this._protectionReadinessErrors = value; }
        }
        
        private string _protectionStatus;
        
        /// <summary>
        /// Optional. Gets or sets the protection status.
        /// </summary>
        public string ProtectionStatus
        {
            get { return this._protectionStatus; }
            set { this._protectionStatus = value; }
        }
        
        private string _recoveryServicesProviderId;
        
        /// <summary>
        /// Optional. Gets or sets the recovery services provider name.
        /// </summary>
        public string RecoveryServicesProviderId
        {
            get { return this._recoveryServicesProviderId; }
            set { this._recoveryServicesProviderId = value; }
        }
        
        private string _replicationProtectedItemId;
        
        /// <summary>
        /// Optional. Gets or sets the ARM resource Id of protected items.
        /// </summary>
        public string ReplicationProtectedItemId
        {
            get { return this._replicationProtectedItemId; }
            set { this._replicationProtectedItemId = value; }
        }
        
        private IList<string> _supportedReplicationProviders;
        
        /// <summary>
        /// Optional. Gets or sets the Supported Replication Providers for the
        /// protectable item.
        /// </summary>
        public IList<string> SupportedReplicationProviders
        {
            get { return this._supportedReplicationProviders; }
            set { this._supportedReplicationProviders = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectableItemProperties class.
        /// </summary>
        public ProtectableItemProperties()
        {
            this.ProtectionReadinessErrors = new LazyList<string>();
            this.SupportedReplicationProviders = new LazyList<string>();
        }
    }
}
