// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Recovery plan protected item.
    /// </summary>
    public partial class RecoveryPlanProtectedItem
    {
        private string _id;
        
        /// <summary>
        /// Required. ARM Id of the protected item.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _virtualMachineId;
        
        /// <summary>
        /// Optional. Virtual machine Id.
        /// </summary>
        public string VirtualMachineId
        {
            get { return this._virtualMachineId; }
            set { this._virtualMachineId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanProtectedItem class.
        /// </summary>
        public RecoveryPlanProtectedItem()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanProtectedItem class
        /// with required arguments.
        /// </summary>
        public RecoveryPlanProtectedItem(string id)
            : this()
        {
            if (id == null)
            {
                throw new ArgumentNullException("id");
            }
            this.Id = id;
        }
    }
}
