// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Recovery plan script action object.
    /// </summary>
    public partial class RecoveryPlanScriptActionDetails : RecoveryPlanActionDetails
    {
        private string _fabricLocation;
        
        /// <summary>
        /// Required. Fabric location.
        /// </summary>
        public string FabricLocation
        {
            get { return this._fabricLocation; }
            set { this._fabricLocation = value; }
        }
        
        private string _path;
        
        /// <summary>
        /// Required. Script path.
        /// </summary>
        public string Path
        {
            get { return this._path; }
            set { this._path = value; }
        }
        
        private System.TimeSpan? _timeout;
        
        /// <summary>
        /// Optional. Script timeout.
        /// </summary>
        public System.TimeSpan? Timeout
        {
            get { return this._timeout; }
            set { this._timeout = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanScriptActionDetails
        /// class.
        /// </summary>
        public RecoveryPlanScriptActionDetails()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanScriptActionDetails
        /// class with required arguments.
        /// </summary>
        public RecoveryPlanScriptActionDetails(string path, string fabricLocation)
            : this()
        {
            if (path == null)
            {
                throw new ArgumentNullException("path");
            }
            if (fabricLocation == null)
            {
                throw new ArgumentNullException("fabricLocation");
            }
            this.Path = path;
            this.FabricLocation = fabricLocation;
        }
    }
}
