// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Hyper V VM network details.
    /// </summary>
    public partial class VMNicDetails
    {
        private string _ipAddressType;
        
        /// <summary>
        /// Optional. Gets or sets ipv4 address type.
        /// </summary>
        public string IpAddressType
        {
            get { return this._ipAddressType; }
            set { this._ipAddressType = value; }
        }
        
        private string _nicId;
        
        /// <summary>
        /// Optional. Gets or sets the nic Id.
        /// </summary>
        public string NicId
        {
            get { return this._nicId; }
            set { this._nicId = value; }
        }
        
        private string _recoveryVMNetworkId;
        
        /// <summary>
        /// Optional. Gets or sets recovery VM network Id.
        /// </summary>
        public string RecoveryVMNetworkId
        {
            get { return this._recoveryVMNetworkId; }
            set { this._recoveryVMNetworkId = value; }
        }
        
        private string _recoveryVMSubnetName;
        
        /// <summary>
        /// Optional. Gets or sets recovery VM subnet name.
        /// </summary>
        public string RecoveryVMSubnetName
        {
            get { return this._recoveryVMSubnetName; }
            set { this._recoveryVMSubnetName = value; }
        }
        
        private string _replicaNicStaticIPAddress;
        
        /// <summary>
        /// Optional. Gets or sets replica nic static IP address.
        /// </summary>
        public string ReplicaNicStaticIPAddress
        {
            get { return this._replicaNicStaticIPAddress; }
            set { this._replicaNicStaticIPAddress = value; }
        }
        
        private string _selectionType;
        
        /// <summary>
        /// Optional. Gets or sets selection type for failover.
        /// </summary>
        public string SelectionType
        {
            get { return this._selectionType; }
            set { this._selectionType = value; }
        }
        
        private string _vMNetworkName;
        
        /// <summary>
        /// Optional. Gets or sets VM network name.
        /// </summary>
        public string VMNetworkName
        {
            get { return this._vMNetworkName; }
            set { this._vMNetworkName = value; }
        }
        
        private string _vMSubnetName;
        
        /// <summary>
        /// Optional. Gets or sets VM subnet name.
        /// </summary>
        public string VMSubnetName
        {
            get { return this._vMSubnetName; }
            set { this._vMSubnetName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VMNicDetails class.
        /// </summary>
        public VMNicDetails()
        {
        }
    }
}
