// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// A2A policy creation input.
    /// </summary>
    public partial class A2APolicyCreationInput : PolicyProviderSpecificInput
    {
        private int _appConsistentFrequencyInMinutes;
        
        /// <summary>
        /// Optional. App consistent frequency in minutes.
        /// </summary>
        public int AppConsistentFrequencyInMinutes
        {
            get { return this._appConsistentFrequencyInMinutes; }
            set { this._appConsistentFrequencyInMinutes = value; }
        }
        
        private int _crashConsistentFrequencyInMinutes;
        
        /// <summary>
        /// Optional. Crash consistent frequency in minutes.
        /// </summary>
        public int CrashConsistentFrequencyInMinutes
        {
            get { return this._crashConsistentFrequencyInMinutes; }
            set { this._crashConsistentFrequencyInMinutes = value; }
        }
        
        private string _multiVmSyncStatus;
        
        /// <summary>
        /// Optional. The multi-VM sync status of the policy. Should be either
        /// 'Enabled' or 'Disabled'
        /// </summary>
        public string MultiVmSyncStatus
        {
            get { return this._multiVmSyncStatus; }
            set { this._multiVmSyncStatus = value; }
        }
        
        private int _recoveryPointHistory;
        
        /// <summary>
        /// Optional. Recovery point history.
        /// </summary>
        public int RecoveryPointHistory
        {
            get { return this._recoveryPointHistory; }
            set { this._recoveryPointHistory = value; }
        }
        
        private int _recoveryPointThresholdInMinutes;
        
        /// <summary>
        /// Optional. Recovery point threshold in minutes.
        /// </summary>
        public int RecoveryPointThresholdInMinutes
        {
            get { return this._recoveryPointThresholdInMinutes; }
            set { this._recoveryPointThresholdInMinutes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the A2APolicyCreationInput class.
        /// </summary>
        public A2APolicyCreationInput()
        {
        }
    }
}
