// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// A2A Provider specific entity details.
    /// </summary>
    public partial class A2AReplicationDetails : ReplicationProviderSpecificSettings
    {
        private string _fabricObjectId;
        
        /// <summary>
        /// Optional. Fabric object ARM Id.
        /// </summary>
        public string FabricObjectId
        {
            get { return this._fabricObjectId; }
            set { this._fabricObjectId = value; }
        }
        
        private string _multiVmGroupId;
        
        /// <summary>
        /// Optional. Multi vm group Id.
        /// </summary>
        public string MultiVmGroupId
        {
            get { return this._multiVmGroupId; }
            set { this._multiVmGroupId = value; }
        }
        
        private string _multiVmGroupName;
        
        /// <summary>
        /// Optional. Multi vm group name.
        /// </summary>
        public string MultiVmGroupName
        {
            get { return this._multiVmGroupName; }
            set { this._multiVmGroupName = value; }
        }
        
        private IList<A2AProtectedDiskDetails> _protectedDisks;
        
        /// <summary>
        /// Optional. List of disk specific details.
        /// </summary>
        public IList<A2AProtectedDiskDetails> ProtectedDisks
        {
            get { return this._protectedDisks; }
            set { this._protectedDisks = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the A2AReplicationDetails class.
        /// </summary>
        public A2AReplicationDetails()
        {
            this.ProtectedDisks = new LazyList<A2AProtectedDiskDetails>();
        }
    }
}
