// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of base Task object.
    /// </summary>
    public partial class AsrTaskBase
    {
        private IList<string> _actions;
        
        /// <summary>
        /// Required. Actions applicable on this task.
        /// </summary>
        public IList<string> Actions
        {
            get { return this._actions; }
            set { this._actions = value; }
        }
        
        private TaskTypeDetails _customDetails;
        
        /// <summary>
        /// Required. The custom task details based on the task type.
        /// </summary>
        public TaskTypeDetails CustomDetails
        {
            get { return this._customDetails; }
            set { this._customDetails = value; }
        }
        
        private DateTime _endTime;
        
        /// <summary>
        /// Required. End time of the task.
        /// </summary>
        public DateTime EndTime
        {
            get { return this._endTime; }
            set { this._endTime = value; }
        }
        
        private IList<JobErrorDetails> _errors;
        
        /// <summary>
        /// Required. List of errors.
        /// </summary>
        public IList<JobErrorDetails> Errors
        {
            get { return this._errors; }
            set { this._errors = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Required. Id of the task.
        /// </summary>
        public string ID
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Task name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private DateTime _startTime;
        
        /// <summary>
        /// Required. Start time of the task.
        /// </summary>
        public DateTime StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Required. State of the task.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _stateDescription;
        
        /// <summary>
        /// Required. Description of the task state. It has detailed state for
        /// the task.
        /// </summary>
        public string StateDescription
        {
            get { return this._stateDescription; }
            set { this._stateDescription = value; }
        }
        
        private string _taskFriendlyName;
        
        /// <summary>
        /// Required. Name of the task.
        /// </summary>
        public string TaskFriendlyName
        {
            get { return this._taskFriendlyName; }
            set { this._taskFriendlyName = value; }
        }
        
        private string _taskType;
        
        /// <summary>
        /// Required. The type of task. Details in CustomDetails property of
        /// task depend on this type.
        /// </summary>
        public string TaskType
        {
            get { return this._taskType; }
            set { this._taskType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AsrTaskBase class.
        /// </summary>
        public AsrTaskBase()
        {
            this.Actions = new LazyList<string>();
            this.Errors = new LazyList<JobErrorDetails>();
        }
    }
}
