// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Create recovery plan input properties object.
    /// </summary>
    public partial class CreateRecoveryPlanInputProperties
    {
        private string _failoverDeploymentModel;
        
        /// <summary>
        /// Optional. Failover deployment model.
        /// </summary>
        public string FailoverDeploymentModel
        {
            get { return this._failoverDeploymentModel; }
            set { this._failoverDeploymentModel = value; }
        }
        
        private IList<RecoveryPlanGroup> _groups;
        
        /// <summary>
        /// Required. Recovery plan groups list.
        /// </summary>
        public IList<RecoveryPlanGroup> Groups
        {
            get { return this._groups; }
            set { this._groups = value; }
        }
        
        private string _primaryFabricId;
        
        /// <summary>
        /// Required. Primary fabric Id.
        /// </summary>
        public string PrimaryFabricId
        {
            get { return this._primaryFabricId; }
            set { this._primaryFabricId = value; }
        }
        
        private string _recoveryFabricId;
        
        /// <summary>
        /// Required. Recovery fabric Id.
        /// </summary>
        public string RecoveryFabricId
        {
            get { return this._recoveryFabricId; }
            set { this._recoveryFabricId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CreateRecoveryPlanInputProperties
        /// class.
        /// </summary>
        public CreateRecoveryPlanInputProperties()
        {
            this.Groups = new LazyList<RecoveryPlanGroup>();
        }
        
        /// <summary>
        /// Initializes a new instance of the CreateRecoveryPlanInputProperties
        /// class with required arguments.
        /// </summary>
        public CreateRecoveryPlanInputProperties(string primaryFabricId, string recoveryFabricId, List<RecoveryPlanGroup> groups)
            : this()
        {
            if (primaryFabricId == null)
            {
                throw new ArgumentNullException("primaryFabricId");
            }
            if (recoveryFabricId == null)
            {
                throw new ArgumentNullException("recoveryFabricId");
            }
            if (groups == null)
            {
                throw new ArgumentNullException("groups");
            }
            this.PrimaryFabricId = primaryFabricId;
            this.RecoveryFabricId = recoveryFabricId;
            this.Groups = groups;
        }
    }
}
