// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Encryption details for the fabric.
    /// </summary>
    public partial class EncryptionDetails
    {
        private System.DateTime? _kekCertExpiryDate;
        
        /// <summary>
        /// Optional. Gets or sets the key encryption key certificate expiry
        /// date.
        /// </summary>
        public System.DateTime? KekCertExpiryDate
        {
            get { return this._kekCertExpiryDate; }
            set { this._kekCertExpiryDate = value; }
        }
        
        private string _kekCertThumbprint;
        
        /// <summary>
        /// Optional. Gets or sets the key encryption key certificate
        /// thumbprint.
        /// </summary>
        public string KekCertThumbprint
        {
            get { return this._kekCertThumbprint; }
            set { this._kekCertThumbprint = value; }
        }
        
        private string _kekState;
        
        /// <summary>
        /// Optional. Gets or sets the key encryption key state for the fabric.
        /// </summary>
        public string KekState
        {
            get { return this._kekState; }
            set { this._kekState = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the EncryptionDetails class.
        /// </summary>
        public EncryptionDetails()
        {
        }
    }
}
