// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Implements the event query parameter.
    /// </summary>
    public partial class EventQueryParameter
    {
        private string _affectedObjectFriendlyName;
        
        /// <summary>
        /// Optional. The affected object name of the events to be queried.
        /// </summary>
        public string AffectedObjectFriendlyName
        {
            get { return this._affectedObjectFriendlyName; }
            set { this._affectedObjectFriendlyName = value; }
        }
        
        private string _endTime;
        
        /// <summary>
        /// Optional. The end time of the time range within which the events
        /// are to be queried.
        /// </summary>
        public string EndTime
        {
            get { return this._endTime; }
            set { this._endTime = value; }
        }
        
        private string _eventCode;
        
        /// <summary>
        /// Optional. The source id of the events to be queried.
        /// </summary>
        public string EventCode
        {
            get { return this._eventCode; }
            set { this._eventCode = value; }
        }
        
        private string _eventType;
        
        /// <summary>
        /// Optional. The type of the events to be queried.
        /// </summary>
        public string EventType
        {
            get { return this._eventType; }
            set { this._eventType = value; }
        }
        
        private string _fabricName;
        
        /// <summary>
        /// Optional. The affected object server id of the events to be queried.
        /// </summary>
        public string FabricName
        {
            get { return this._fabricName; }
            set { this._fabricName = value; }
        }
        
        private string _severity;
        
        /// <summary>
        /// Optional. The severity of the events to be queried.
        /// </summary>
        public string Severity
        {
            get { return this._severity; }
            set { this._severity = value; }
        }
        
        private string _startTime;
        
        /// <summary>
        /// Optional. The start time of the time range within which the events
        /// are to be queried.
        /// </summary>
        public string StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the EventQueryParameter class.
        /// </summary>
        public EventQueryParameter()
        {
        }
    }
}
