// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The InMageAzureV2 enable protection input.
    /// </summary>
    public partial class InMageAzureV2EnableProtectionInput : EnableProtectionProviderSpecificInput
    {
        private IList<string> _disksToInclude;
        
        /// <summary>
        /// Optional. The disk inclusion list.
        /// </summary>
        public IList<string> DisksToInclude
        {
            get { return this._disksToInclude; }
            set { this._disksToInclude = value; }
        }
        
        private string _enableRDPOnTargetOption;
        
        /// <summary>
        /// Optional. Gets or sets the option to enable RDP on target vm after
        /// failover.Value can be Never, OnlyOnTestFailover or Always.
        /// </summary>
        public string EnableRDPOnTargetOption
        {
            get { return this._enableRDPOnTargetOption; }
            set { this._enableRDPOnTargetOption = value; }
        }
        
        private string _logStorageAccountId;
        
        /// <summary>
        /// Optional. Gets or sets the storage account to be used for logging
        /// during replication.
        /// </summary>
        public string LogStorageAccountId
        {
            get { return this._logStorageAccountId; }
            set { this._logStorageAccountId = value; }
        }
        
        private string _masterTargetId;
        
        /// <summary>
        /// Optional. Master Target Id.
        /// </summary>
        public string MasterTargetId
        {
            get { return this._masterTargetId; }
            set { this._masterTargetId = value; }
        }
        
        private string _multiVmGroupId;
        
        /// <summary>
        /// Optional. Multi VM group ID.
        /// </summary>
        public string MultiVmGroupId
        {
            get { return this._multiVmGroupId; }
            set { this._multiVmGroupId = value; }
        }
        
        private string _multiVmGroupName;
        
        /// <summary>
        /// Optional. Multi VM group name.
        /// </summary>
        public string MultiVmGroupName
        {
            get { return this._multiVmGroupName; }
            set { this._multiVmGroupName = value; }
        }
        
        private string _processServerId;
        
        /// <summary>
        /// Optional. Process Server ID.
        /// </summary>
        public string ProcessServerId
        {
            get { return this._processServerId; }
            set { this._processServerId = value; }
        }
        
        private string _runAsAccountId;
        
        /// <summary>
        /// Optional. Account Id which has priviliges to install the mobility
        /// service.
        /// </summary>
        public string RunAsAccountId
        {
            get { return this._runAsAccountId; }
            set { this._runAsAccountId = value; }
        }
        
        private string _storageAccountId;
        
        /// <summary>
        /// Optional. Storage account ID.
        /// </summary>
        public string StorageAccountId
        {
            get { return this._storageAccountId; }
            set { this._storageAccountId = value; }
        }
        
        private string _storageSubscriptionId;
        
        /// <summary>
        /// Optional. Storage subscription ID.
        /// </summary>
        public string StorageSubscriptionId
        {
            get { return this._storageSubscriptionId; }
            set { this._storageSubscriptionId = value; }
        }
        
        private string _targetAzureNetworkId;
        
        /// <summary>
        /// Optional. The target Azure network ID.
        /// </summary>
        public string TargetAzureNetworkId
        {
            get { return this._targetAzureNetworkId; }
            set { this._targetAzureNetworkId = value; }
        }
        
        private string _targetAzureSubnetId;
        
        /// <summary>
        /// Optional. The target Azure subnet ID.
        /// </summary>
        public string TargetAzureSubnetId
        {
            get { return this._targetAzureSubnetId; }
            set { this._targetAzureSubnetId = value; }
        }
        
        private string _targetAzureVmName;
        
        /// <summary>
        /// Optional. The target Azure VM Name.
        /// </summary>
        public string TargetAzureVmName
        {
            get { return this._targetAzureVmName; }
            set { this._targetAzureVmName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// InMageAzureV2EnableProtectionInput class.
        /// </summary>
        public InMageAzureV2EnableProtectionInput()
        {
            this.DisksToInclude = new LazyList<string>();
        }
    }
}
