// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// DiskExclusionInput when doing enable protection of virtual machine in
    /// InMage provider.
    /// </summary>
    public partial class InMageDiskExclusionInput
    {
        private IList<InMageDiskSignatureExclusionOptions> _diskSignatureOptions;
        
        /// <summary>
        /// Optional. The guest disk signature based option for disk exclusion.
        /// </summary>
        public IList<InMageDiskSignatureExclusionOptions> DiskSignatureOptions
        {
            get { return this._diskSignatureOptions; }
            set { this._diskSignatureOptions = value; }
        }
        
        private IList<InMageVolumeExclusionOptions> _volumeOptions;
        
        /// <summary>
        /// Optional. The volume label based option for disk exclusion.
        /// </summary>
        public IList<InMageVolumeExclusionOptions> VolumeOptions
        {
            get { return this._volumeOptions; }
            set { this._volumeOptions = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the InMageDiskExclusionInput class.
        /// </summary>
        public InMageDiskExclusionInput()
        {
            this.DiskSignatureOptions = new LazyList<InMageDiskSignatureExclusionOptions>();
            this.VolumeOptions = new LazyList<InMageVolumeExclusionOptions>();
        }
    }
}
