// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of inconsistent VM details object.
    /// </summary>
    public partial class InconsistentVmDetails
    {
        private string _cloudName;
        
        /// <summary>
        /// Required. Cloud name.
        /// </summary>
        public string CloudName
        {
            get { return this._cloudName; }
            set { this._cloudName = value; }
        }
        
        private IList<string> _details;
        
        /// <summary>
        /// Required. Details regarding state of the Protected Entity in ASR
        /// and On prem.
        /// </summary>
        public IList<string> Details
        {
            get { return this._details; }
            set { this._details = value; }
        }
        
        private IList<string> _errorIds;
        
        /// <summary>
        /// Required. List of Error IDs.
        /// </summary>
        public IList<string> ErrorIds
        {
            get { return this._errorIds; }
            set { this._errorIds = value; }
        }
        
        private string _vmName;
        
        /// <summary>
        /// Required. Name of the VM.
        /// </summary>
        public string VmName
        {
            get { return this._vmName; }
            set { this._vmName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the InconsistentVmDetails class.
        /// </summary>
        public InconsistentVmDetails()
        {
            this.Details = new LazyList<string>();
            this.ErrorIds = new LazyList<string>();
        }
    }
}
