// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Custom job details based on the job type.
    /// </summary>
    public partial class JobDetails
    {
        private IDictionary<string, string> _affectedObjectDetails;
        
        /// <summary>
        /// Required. Affected object details about the job.
        /// </summary>
        public IDictionary<string, string> AffectedObjectDetails
        {
            get { return this._affectedObjectDetails; }
            set { this._affectedObjectDetails = value; }
        }
        
        private string _instanceType;
        
        /// <summary>
        /// Required. The job type. Overriden in derived classes.
        /// </summary>
        public string InstanceType
        {
            get { return this._instanceType; }
            set { this._instanceType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobDetails class.
        /// </summary>
        public JobDetails()
        {
            this.AffectedObjectDetails = new LazyDictionary<string, string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the JobDetails class with required
        /// arguments.
        /// </summary>
        public JobDetails(string instanceType, IDictionary<string, string> affectedObjectDetails)
            : this()
        {
            if (instanceType == null)
            {
                throw new ArgumentNullException("instanceType");
            }
            if (affectedObjectDetails == null)
            {
                throw new ArgumentNullException("affectedObjectDetails");
            }
            this.InstanceType = instanceType;
            this.AffectedObjectDetails = affectedObjectDetails;
        }
    }
}
