// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a ErrorDetails object.
    /// </summary>
    public partial class JobErrorDetails
    {
        private DateTime _creationTime;
        
        /// <summary>
        /// Optional. Gets or sets the creation time of job error.
        /// </summary>
        public DateTime CreationTime
        {
            get { return this._creationTime; }
            set { this._creationTime = value; }
        }
        
        private string _errorLevel;
        
        /// <summary>
        /// Optional. Gets or sets error level of error.
        /// </summary>
        public string ErrorLevel
        {
            get { return this._errorLevel; }
            set { this._errorLevel = value; }
        }
        
        private ProviderError _providerErrorDetails;
        
        /// <summary>
        /// Required. Provider error details.
        /// </summary>
        public ProviderError ProviderErrorDetails
        {
            get { return this._providerErrorDetails; }
            set { this._providerErrorDetails = value; }
        }
        
        private ServiceError _serviceErrorDetails;
        
        /// <summary>
        /// Required. Service error details.
        /// </summary>
        public ServiceError ServiceErrorDetails
        {
            get { return this._serviceErrorDetails; }
            set { this._serviceErrorDetails = value; }
        }
        
        private string _taskId;
        
        /// <summary>
        /// Required. ID of the task, where error was raised.
        /// </summary>
        public string TaskId
        {
            get { return this._taskId; }
            set { this._taskId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobErrorDetails class.
        /// </summary>
        public JobErrorDetails()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the JobErrorDetails class with
        /// required arguments.
        /// </summary>
        public JobErrorDetails(ServiceError serviceErrorDetails, ProviderError providerErrorDetails, string taskId)
            : this()
        {
            if (serviceErrorDetails == null)
            {
                throw new ArgumentNullException("serviceErrorDetails");
            }
            if (providerErrorDetails == null)
            {
                throw new ArgumentNullException("providerErrorDetails");
            }
            if (taskId == null)
            {
                throw new ArgumentNullException("taskId");
            }
            this.ServiceErrorDetails = serviceErrorDetails;
            this.ProviderErrorDetails = providerErrorDetails;
            this.TaskId = taskId;
        }
    }
}
