// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of Logical Network Properties
    /// </summary>
    public partial class LogicalNetworkProperties
    {
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the logical network.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _logicalNetworkDefinitionsStatus;
        
        /// <summary>
        /// Optional. Value indicating whether logical network definitions are
        /// isolated.
        /// </summary>
        public string LogicalNetworkDefinitionsStatus
        {
            get { return this._logicalNetworkDefinitionsStatus; }
            set { this._logicalNetworkDefinitionsStatus = value; }
        }
        
        private string _logicalNetworkUsage;
        
        /// <summary>
        /// Optional. Value indicating whether logical network is used as
        /// private test network by test failover.
        /// </summary>
        public string LogicalNetworkUsage
        {
            get { return this._logicalNetworkUsage; }
            set { this._logicalNetworkUsage = value; }
        }
        
        private string _networkVirtualizationStatus;
        
        /// <summary>
        /// Optional. Value indicating whether Network Virtualization is
        /// enabled for the logical network.
        /// </summary>
        public string NetworkVirtualizationStatus
        {
            get { return this._networkVirtualizationStatus; }
            set { this._networkVirtualizationStatus = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the LogicalNetworkProperties class.
        /// </summary>
        public LogicalNetworkProperties()
        {
        }
    }
}
