// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// A standard service response for long running operations.
    /// </summary>
    public partial class LongRunningOperationResponse : OperationCommonResponse
    {
        private string _asyncOperation;
        
        /// <summary>
        /// Optional. The async operation url.
        /// </summary>
        public string AsyncOperation
        {
            get { return this._asyncOperation; }
            set { this._asyncOperation = value; }
        }
        
        private string _culture;
        
        /// <summary>
        /// Optional. Culture being used for request.
        /// </summary>
        public string Culture
        {
            get { return this._culture; }
            set { this._culture = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Optional. The location url for the get request.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private int? _retryAfter;
        
        /// <summary>
        /// Optional. The retry after time in seconds.
        /// </summary>
        public int? RetryAfter
        {
            get { return this._retryAfter; }
            set { this._retryAfter = value; }
        }
        
        private OperationStatus _status;
        
        /// <summary>
        /// Optional. Status of the operation.
        /// </summary>
        public OperationStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the LongRunningOperationResponse
        /// class.
        /// </summary>
        public LongRunningOperationResponse()
        {
        }
    }
}
