// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// A standard service response for Get operations.
    /// </summary>
    public partial class OperationCommonResponse : AzureOperationResponse
    {
        private string _clientRequestId;
        
        /// <summary>
        /// Optional. Caller-specified value identifying the request, in the
        /// form of a GUID with no decoration such as curly braces (e.g.
        /// client-request-id: 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0).
        /// </summary>
        public string ClientRequestId
        {
            get { return this._clientRequestId; }
            set { this._clientRequestId = value; }
        }
        
        private string _contentType;
        
        /// <summary>
        /// Optional. Content Type.
        /// </summary>
        public string ContentType
        {
            get { return this._contentType; }
            set { this._contentType = value; }
        }
        
        private string _correlationRequestId;
        
        /// <summary>
        /// Optional. Specifies the tracing correlation Id for the request; the
        /// resource provider *must* log this so that end-to-end requests can
        /// be correlated across Azure.
        /// </summary>
        public string CorrelationRequestId
        {
            get { return this._correlationRequestId; }
            set { this._correlationRequestId = value; }
        }
        
        private string _date;
        
        /// <summary>
        /// Optional. The date that the request was processed, in RFC 1123
        /// format..
        /// </summary>
        public string Date
        {
            get { return this._date; }
            set { this._date = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OperationCommonResponse class.
        /// </summary>
        public OperationCommonResponse()
        {
        }
    }
}
