// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a Protection Container properties object.
    /// </summary>
    public partial class ProtectionContainerProperties
    {
        private ContainerFabricConfigurationSettings _fabricConfigurationSettings;
        
        /// <summary>
        /// Optional. Fabric configuration settings for container.
        /// </summary>
        public ContainerFabricConfigurationSettings FabricConfigurationSettings
        {
            get { return this._fabricConfigurationSettings; }
            set { this._fabricConfigurationSettings = value; }
        }
        
        private string _fabricFriendlyName;
        
        /// <summary>
        /// Optional. Fabric friendly name.
        /// </summary>
        public string FabricFriendlyName
        {
            get { return this._fabricFriendlyName; }
            set { this._fabricFriendlyName = value; }
        }
        
        private string _fabricType;
        
        /// <summary>
        /// Optional. Gets or sets the fabric type.
        /// </summary>
        public string FabricType
        {
            get { return this._fabricType; }
            set { this._fabricType = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Gets or sets the friendly name.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _pairingStatus;
        
        /// <summary>
        /// Optional. Gets or sets the pairing status of this cloud.
        /// </summary>
        public string PairingStatus
        {
            get { return this._pairingStatus; }
            set { this._pairingStatus = value; }
        }
        
        private int _protectedItemCount;
        
        /// <summary>
        /// Optional. Number of protected items.
        /// </summary>
        public int ProtectedItemCount
        {
            get { return this._protectedItemCount; }
            set { this._protectedItemCount = value; }
        }
        
        private string _role;
        
        /// <summary>
        /// Optional. Gets or sets the pairing role of this cloud.
        /// </summary>
        public string Role
        {
            get { return this._role; }
            set { this._role = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectionContainerProperties
        /// class.
        /// </summary>
        public ProtectionContainerProperties()
        {
        }
    }
}
