// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Recovery plan action object.
    /// </summary>
    public partial class RecoveryPlanAction
    {
        private string _actionName;
        
        /// <summary>
        /// Required. Action name.
        /// </summary>
        public string ActionName
        {
            get { return this._actionName; }
            set { this._actionName = value; }
        }
        
        private RecoveryPlanActionDetails _customDetails;
        
        /// <summary>
        /// Required. Recovery plan action custom details.
        /// </summary>
        public RecoveryPlanActionDetails CustomDetails
        {
            get { return this._customDetails; }
            set { this._customDetails = value; }
        }
        
        private IList<string> _failoverDirections;
        
        /// <summary>
        /// Required. Allowed failover directions.
        /// </summary>
        public IList<string> FailoverDirections
        {
            get { return this._failoverDirections; }
            set { this._failoverDirections = value; }
        }
        
        private IList<string> _failoverTypes;
        
        /// <summary>
        /// Required. Allowed failover types.
        /// </summary>
        public IList<string> FailoverTypes
        {
            get { return this._failoverTypes; }
            set { this._failoverTypes = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanAction class.
        /// </summary>
        public RecoveryPlanAction()
        {
            this.FailoverDirections = new LazyList<string>();
            this.FailoverTypes = new LazyList<string>();
        }
    }
}
