// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The response model for the list recovery plan operation.
    /// </summary>
    public partial class RecoveryPlanListResponse : OperationCommonResponse
    {
        private string _nextLink;
        
        /// <summary>
        /// Optional. The nextLink value.
        /// </summary>
        public string NextLink
        {
            get { return this._nextLink; }
            set { this._nextLink = value; }
        }
        
        private IList<RecoveryPlan> _recoveryPlans;
        
        /// <summary>
        /// Optional. The list of recovery plans.
        /// </summary>
        public IList<RecoveryPlan> RecoveryPlans
        {
            get { return this._recoveryPlans; }
            set { this._recoveryPlans = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RecoveryPlanListResponse class.
        /// </summary>
        public RecoveryPlanListResponse()
        {
            this.RecoveryPlans = new LazyList<RecoveryPlan>();
        }
    }
}
