// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Recovery plan test failover input properties.
    /// </summary>
    public partial class RecoveryPlanTestFailoverInputProperties
    {
        private string _failoverDirection;
        
        /// <summary>
        /// Required. Failover direction.
        /// </summary>
        public string FailoverDirection
        {
            get { return this._failoverDirection; }
            set { this._failoverDirection = value; }
        }
        
        private string _networkId;
        
        /// <summary>
        /// Optional. Network Id.
        /// </summary>
        public string NetworkId
        {
            get { return this._networkId; }
            set { this._networkId = value; }
        }
        
        private string _networkType;
        
        /// <summary>
        /// Required. Network type.
        /// </summary>
        public string NetworkType
        {
            get { return this._networkType; }
            set { this._networkType = value; }
        }
        
        private IList<RecoveryPlanProviderSpecificFailoverInput> _providerSpecificDetails;
        
        /// <summary>
        /// Optional. Provider specific details.
        /// </summary>
        public IList<RecoveryPlanProviderSpecificFailoverInput> ProviderSpecificDetails
        {
            get { return this._providerSpecificDetails; }
            set { this._providerSpecificDetails = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// RecoveryPlanTestFailoverInputProperties class.
        /// </summary>
        public RecoveryPlanTestFailoverInputProperties()
        {
            this.ProviderSpecificDetails = new LazyList<RecoveryPlanProviderSpecificFailoverInput>();
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// RecoveryPlanTestFailoverInputProperties class with required
        /// arguments.
        /// </summary>
        public RecoveryPlanTestFailoverInputProperties(string failoverDirection, string networkType)
            : this()
        {
            if (failoverDirection == null)
            {
                throw new ArgumentNullException("failoverDirection");
            }
            if (networkType == null)
            {
                throw new ArgumentNullException("networkType");
            }
            this.FailoverDirection = failoverDirection;
            this.NetworkType = networkType;
        }
    }
}
