// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a recovery services provider properties.
    /// </summary>
    public partial class RecoveryServicesProviderProperties
    {
        private IList<string> _allowedScenarios;
        
        /// <summary>
        /// Optional. Gets or sets the scenarions allowed on this provider.
        /// </summary>
        public IList<string> AllowedScenarios
        {
            get { return this._allowedScenarios; }
            set { this._allowedScenarios = value; }
        }
        
        private string _connectionStatus;
        
        /// <summary>
        /// Optional. Denotes whether provider is responsive..
        /// </summary>
        public string ConnectionStatus
        {
            get { return this._connectionStatus; }
            set { this._connectionStatus = value; }
        }
        
        private string _fabricFriendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the Fabric.
        /// </summary>
        public string FabricFriendlyName
        {
            get { return this._fabricFriendlyName; }
            set { this._fabricFriendlyName = value; }
        }
        
        private string _fabricType;
        
        /// <summary>
        /// Optional. Type of the Fabric.
        /// </summary>
        public string FabricType
        {
            get { return this._fabricType; }
            set { this._fabricType = value; }
        }
        
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the DRA.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private System.DateTime? _lastHeartbeat;
        
        /// <summary>
        /// Optional. Time when last heartbeat was sent by the DRA.
        /// </summary>
        public System.DateTime? LastHeartbeat
        {
            get { return this._lastHeartbeat; }
            set { this._lastHeartbeat = value; }
        }
        
        private int _protectedItemCount;
        
        /// <summary>
        /// Optional. Number of protected entities currently managed by the
        /// provider.
        /// </summary>
        public int ProtectedItemCount
        {
            get { return this._protectedItemCount; }
            set { this._protectedItemCount = value; }
        }
        
        private string _providerVersion;
        
        /// <summary>
        /// Optional. Version details of the DRA.
        /// </summary>
        public string ProviderVersion
        {
            get { return this._providerVersion; }
            set { this._providerVersion = value; }
        }
        
        private System.DateTime? _providerVersionExpiryDate;
        
        /// <summary>
        /// Optional. Provider expiry date if the version is deprecated.
        /// </summary>
        public System.DateTime? ProviderVersionExpiryDate
        {
            get { return this._providerVersionExpiryDate; }
            set { this._providerVersionExpiryDate = value; }
        }
        
        private string _providerVersionState;
        
        /// <summary>
        /// Optional. Version Sate of the DRA.
        /// </summary>
        public string ProviderVersionState
        {
            get { return this._providerVersionState; }
            set { this._providerVersionState = value; }
        }
        
        private string _serverVersion;
        
        /// <summary>
        /// Optional. Version details of the Server
        /// </summary>
        public string ServerVersion
        {
            get { return this._serverVersion; }
            set { this._serverVersion = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// RecoveryServicesProviderProperties class.
        /// </summary>
        public RecoveryServicesProviderProperties()
        {
            this.AllowedScenarios = new LazyList<string>();
        }
    }
}
