// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Vault exteneded information.
    /// </summary>
    public partial class ResourceExtendedInformationArgs
    {
        private string _contractVersion;
        
        /// <summary>
        /// Required. Contract version for the entity.
        /// </summary>
        public string ContractVersion
        {
            get { return this._contractVersion; }
            set { this._contractVersion = value; }
        }
        
        private string _extendedInfo;
        
        /// <summary>
        /// Required. Serialized blob for the extended info
        /// </summary>
        public string ExtendedInfo
        {
            get { return this._extendedInfo; }
            set { this._extendedInfo = value; }
        }
        
        private string _extendedInfoETag;
        
        /// <summary>
        /// Required. ETag for the request
        /// </summary>
        public string ExtendedInfoETag
        {
            get { return this._extendedInfoETag; }
            set { this._extendedInfoETag = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ResourceExtendedInformationArgs
        /// class.
        /// </summary>
        public ResourceExtendedInformationArgs()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ResourceExtendedInformationArgs
        /// class with required arguments.
        /// </summary>
        public ResourceExtendedInformationArgs(string contractVersion, string extendedInfo, string extendedInfoETag)
            : this()
        {
            if (contractVersion == null)
            {
                throw new ArgumentNullException("contractVersion");
            }
            if (extendedInfo == null)
            {
                throw new ArgumentNullException("extendedInfo");
            }
            if (extendedInfoETag == null)
            {
                throw new ArgumentNullException("extendedInfoETag");
            }
            this.ContractVersion = contractVersion;
            this.ExtendedInfo = extendedInfo;
            this.ExtendedInfoETag = extendedInfoETag;
        }
    }
}
