// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a ServiceError object.
    /// </summary>
    public partial class ServiceError
    {
        private string _activityId;
        
        /// <summary>
        /// Required. Activity id of the request where service error was
        /// recorded.
        /// </summary>
        public string ActivityId
        {
            get { return this._activityId; }
            set { this._activityId = value; }
        }
        
        private string _code;
        
        /// <summary>
        /// Required. Service error code.
        /// </summary>
        public string Code
        {
            get { return this._code; }
            set { this._code = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Required. Service error message.
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private string _possibleCauses;
        
        /// <summary>
        /// Required. Possible causes which can lead to this error.
        /// </summary>
        public string PossibleCauses
        {
            get { return this._possibleCauses; }
            set { this._possibleCauses = value; }
        }
        
        private string _recommendedAction;
        
        /// <summary>
        /// Required. Recommended action to resolve error.
        /// </summary>
        public string RecommendedAction
        {
            get { return this._recommendedAction; }
            set { this._recommendedAction = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServiceError class.
        /// </summary>
        public ServiceError()
        {
        }
    }
}
