// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Custom details for test failover job.
    /// </summary>
    public partial class TestFailoverJobDetails : JobDetails
    {
        private string _comments;
        
        /// <summary>
        /// Optional. Test failover comments.
        /// </summary>
        public string Comments
        {
            get { return this._comments; }
            set { this._comments = value; }
        }
        
        private string _networkFriendlyName;
        
        /// <summary>
        /// Optional. Test failover network friendly name.
        /// </summary>
        public string NetworkFriendlyName
        {
            get { return this._networkFriendlyName; }
            set { this._networkFriendlyName = value; }
        }
        
        private string _networkName;
        
        /// <summary>
        /// Optional. Test failover network name.
        /// </summary>
        public string NetworkName
        {
            get { return this._networkName; }
            set { this._networkName = value; }
        }
        
        private string _networkType;
        
        /// <summary>
        /// Optional. Test failover network type.
        /// </summary>
        public string NetworkType
        {
            get { return this._networkType; }
            set { this._networkType = value; }
        }
        
        private IList<TestFailoverReplicationProtectedItemDetails> _protectedItemDetails;
        
        /// <summary>
        /// Optional. Protected item details for the test failover job.
        /// </summary>
        public IList<TestFailoverReplicationProtectedItemDetails> ProtectedItemDetails
        {
            get { return this._protectedItemDetails; }
            set { this._protectedItemDetails = value; }
        }
        
        private string _testFailoverStatus;
        
        /// <summary>
        /// Required. Test failover status.
        /// </summary>
        public string TestFailoverStatus
        {
            get { return this._testFailoverStatus; }
            set { this._testFailoverStatus = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the TestFailoverJobDetails class.
        /// </summary>
        public TestFailoverJobDetails()
        {
            this.ProtectedItemDetails = new LazyList<TestFailoverReplicationProtectedItemDetails>();
        }
        
        /// <summary>
        /// Initializes a new instance of the TestFailoverJobDetails class with
        /// required arguments.
        /// </summary>
        public TestFailoverJobDetails(string testFailoverStatus, string instanceType, IDictionary<string, string> affectedObjectDetails)
            : this()
        {
            if (testFailoverStatus == null)
            {
                throw new ArgumentNullException("testFailoverStatus");
            }
            if (instanceType == null)
            {
                throw new ArgumentNullException("instanceType");
            }
            if (affectedObjectDetails == null)
            {
                throw new ArgumentNullException("affectedObjectDetails");
            }
            this.TestFailoverStatus = testFailoverStatus;
            this.InstanceType = instanceType;
            this.AffectedObjectDetails = affectedObjectDetails;
        }
    }
}
