// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// Update protected item input properties.
    /// </summary>
    public partial class UpdateReplicationProtectedItemInputProperties
    {
        private string _enableRDPOnTargetOption;
        
        /// <summary>
        /// Optional. Gets or sets the option to enable RDP on target vm after
        /// failover.Value can be Never, OnlyOnTestFailover or Always.
        /// </summary>
        public string EnableRDPOnTargetOption
        {
            get { return this._enableRDPOnTargetOption; }
            set { this._enableRDPOnTargetOption = value; }
        }
        
        private string _licenseType;
        
        /// <summary>
        /// Optional. Gets or sets License Type of the VM to be used for HUB
        /// https://azure.microsoft.com/en-in/pricing/hybrid-use-benefit/.
        /// </summary>
        public string LicenseType
        {
            get { return this._licenseType; }
            set { this._licenseType = value; }
        }
        
        private string _recoveryAvailabilitySetId;
        
        /// <summary>
        /// Optional. Gets or sets the target availability set Id.
        /// </summary>
        public string RecoveryAvailabilitySetId
        {
            get { return this._recoveryAvailabilitySetId; }
            set { this._recoveryAvailabilitySetId = value; }
        }
        
        private string _recoveryAzureVMName;
        
        /// <summary>
        /// Optional. Gets or sets target azure VM name given by the user.
        /// </summary>
        public string RecoveryAzureVMName
        {
            get { return this._recoveryAzureVMName; }
            set { this._recoveryAzureVMName = value; }
        }
        
        private string _recoveryAzureVMSize;
        
        /// <summary>
        /// Optional. Gets or sets Target Azure Vm size.
        /// </summary>
        public string RecoveryAzureVMSize
        {
            get { return this._recoveryAzureVMSize; }
            set { this._recoveryAzureVMSize = value; }
        }
        
        private string _recoveryCloudServiceId;
        
        /// <summary>
        /// Optional. Gets or sets the target cloud service ARM Id (for V1).
        /// </summary>
        public string RecoveryCloudServiceId
        {
            get { return this._recoveryCloudServiceId; }
            set { this._recoveryCloudServiceId = value; }
        }
        
        private string _recoveryResourceGroupId;
        
        /// <summary>
        /// Optional. Gets or sets the target resource group ARM Id (for V2).
        /// </summary>
        public string RecoveryResourceGroupId
        {
            get { return this._recoveryResourceGroupId; }
            set { this._recoveryResourceGroupId = value; }
        }
        
        private string _selectedRecoveryAzureNetworkId;
        
        /// <summary>
        /// Optional. Gets or sets target Azure Network Id.
        /// </summary>
        public string SelectedRecoveryAzureNetworkId
        {
            get { return this._selectedRecoveryAzureNetworkId; }
            set { this._selectedRecoveryAzureNetworkId = value; }
        }
        
        private IList<VMNicInputDetails> _vmNics;
        
        /// <summary>
        /// Required. Gets or sets VM Nic Details
        /// </summary>
        public IList<VMNicInputDetails> VmNics
        {
            get { return this._vmNics; }
            set { this._vmNics = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// UpdateReplicationProtectedItemInputProperties class.
        /// </summary>
        public UpdateReplicationProtectedItemInputProperties()
        {
            this.VmNics = new LazyList<VMNicInputDetails>();
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// UpdateReplicationProtectedItemInputProperties class with required
        /// arguments.
        /// </summary>
        public UpdateReplicationProtectedItemInputProperties(List<VMNicInputDetails> vmNics)
            : this()
        {
            if (vmNics == null)
            {
                throw new ArgumentNullException("vmNics");
            }
            this.VmNics = vmNics;
        }
    }
}
