// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of update vCenter properties object.
    /// </summary>
    public partial class UpdateVCenterProperties
    {
        private string _friendlyName;
        
        /// <summary>
        /// Optional. Friendly name of the vCenter.
        /// </summary>
        public string FriendlyName
        {
            get { return this._friendlyName; }
            set { this._friendlyName = value; }
        }
        
        private string _ipAddress;
        
        /// <summary>
        /// Optional. IP address of the vCenter.
        /// </summary>
        public string IpAddress
        {
            get { return this._ipAddress; }
            set { this._ipAddress = value; }
        }
        
        private string _port;
        
        /// <summary>
        /// Optional. Port of the vCenter.
        /// </summary>
        public string Port
        {
            get { return this._port; }
            set { this._port = value; }
        }
        
        private string _processServerId;
        
        /// <summary>
        /// Optional. Process server Id from where the discovery to be
        /// orchestrated.
        /// </summary>
        public string ProcessServerId
        {
            get { return this._processServerId; }
            set { this._processServerId = value; }
        }
        
        private string _runAsAccountId;
        
        /// <summary>
        /// Optional. Account Id which has priviliges to discover vCenter.
        /// </summary>
        public string RunAsAccountId
        {
            get { return this._runAsAccountId; }
            set { this._runAsAccountId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the UpdateVCenterProperties class.
        /// </summary>
        public UpdateVCenterProperties()
        {
        }
    }
}
