// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.SiteRecovery.Models;

namespace Microsoft.Azure.Management.SiteRecovery.Models
{
    /// <summary>
    /// VMware Provider specific entity details.
    /// </summary>
    public partial class VMwareVirtualMachineDetails : ProtectableItemTypeSettings
    {
        private string _agentGeneratedId;
        
        /// <summary>
        /// Optional. ID generated by the InMage agent after it gets installed
        /// on guest.
        /// </summary>
        public string AgentGeneratedId
        {
            get { return this._agentGeneratedId; }
            set { this._agentGeneratedId = value; }
        }
        
        private string _agentInstalled;
        
        /// <summary>
        /// Optional. Value indicating if InMage scout agent is installed on
        /// guest.
        /// </summary>
        public string AgentInstalled
        {
            get { return this._agentInstalled; }
            set { this._agentInstalled = value; }
        }
        
        private string _agentVersion;
        
        /// <summary>
        /// Optional. Agent version installed on VM.
        /// </summary>
        public string AgentVersion
        {
            get { return this._agentVersion; }
            set { this._agentVersion = value; }
        }
        
        private string _discoveryType;
        
        /// <summary>
        /// Optional. The discovery type of the machine.
        /// </summary>
        public string DiscoveryType
        {
            get { return this._discoveryType; }
            set { this._discoveryType = value; }
        }
        
        private IList<InMageDiskDetails> _diskDetails;
        
        /// <summary>
        /// Optional. Disk Details.
        /// </summary>
        public IList<InMageDiskDetails> DiskDetails
        {
            get { return this._diskDetails; }
            set { this._diskDetails = value; }
        }
        
        private string _ipAddress;
        
        /// <summary>
        /// Optional. VM IP address.
        /// </summary>
        public string IpAddress
        {
            get { return this._ipAddress; }
            set { this._ipAddress = value; }
        }
        
        private string _osType;
        
        /// <summary>
        /// Optional. OsType installed on VM.
        /// </summary>
        public string OsType
        {
            get { return this._osType; }
            set { this._osType = value; }
        }
        
        private string _poweredOn;
        
        /// <summary>
        /// Optional. Value indicating whether VM is powered on.
        /// </summary>
        public string PoweredOn
        {
            get { return this._poweredOn; }
            set { this._poweredOn = value; }
        }
        
        private string _vCenterInfrastructureId;
        
        /// <summary>
        /// Optional. VCenter infrastructure Id.
        /// </summary>
        public string VCenterInfrastructureId
        {
            get { return this._vCenterInfrastructureId; }
            set { this._vCenterInfrastructureId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VMwareVirtualMachineDetails class.
        /// </summary>
        public VMwareVirtualMachineDetails()
        {
            this.DiskDetails = new LazyList<InMageDiskDetails>();
        }
    }
}
