// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the response to a list sql azure database advisors request.
    /// </summary>
    public partial class AdvisorListResponse : AzureOperationResponse, IEnumerable<Advisor>
    {
        private IList<Advisor> _advisors;
        
        /// <summary>
        /// Optional. Gets or sets the list of Advisors for Azure Sql
        /// Server/Database/Elastic Pool.
        /// </summary>
        public IList<Advisor> Advisors
        {
            get { return this._advisors; }
            set { this._advisors = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AdvisorListResponse class.
        /// </summary>
        public AdvisorListResponse()
        {
            this.Advisors = new LazyList<Advisor>();
        }
        
        /// <summary>
        /// Gets the sequence of Advisors.
        /// </summary>
        public IEnumerator<Advisor> GetEnumerator()
        {
            return this.Advisors.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Advisors.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
