// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Update Azure Sql Server/Database/Elastic Pool Advisor properties.
    /// </summary>
    public partial class AdvisorUpdateProperties
    {
        private string _autoExecuteStatus;
        
        /// <summary>
        /// Optional. Updates the auto-execute status for this Advisor. Allowed
        /// values are :Enabled     ->  Enable automated execution of
        /// recommendations on the resource (e.g. Server) and its children
        /// (e.g., Databases).Disabled    ->  Disable automated execution of
        /// recommendations on the resource and its childrenDefault     ->
        /// Reset the status that has been explicitly set before. This will
        /// cause auto-execute status for this resource (e.g., Database)
        /// to be inherited for parent resource (e.g., Server).
        /// </summary>
        public string AutoExecuteStatus
        {
            get { return this._autoExecuteStatus; }
            set { this._autoExecuteStatus = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AdvisorUpdateProperties class.
        /// </summary>
        public AdvisorUpdateProperties()
        {
        }
    }
}
