// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of an Azure SQL blob auditing policy.
    /// </summary>
    public partial class BlobAuditingProperties
    {
        private IList<string> _auditActionsAndGroups;
        
        /// <summary>
        /// Optional. Specifies the audit actions and groups.
        /// </summary>
        public IList<string> AuditActionsAndGroups
        {
            get { return this._auditActionsAndGroups; }
            set { this._auditActionsAndGroups = value; }
        }
        
        private bool _isStorageSecondaryKeyInUse;
        
        /// <summary>
        /// Optional. Indicating whether the storage secondary key is in use.
        /// </summary>
        public bool IsStorageSecondaryKeyInUse
        {
            get { return this._isStorageSecondaryKeyInUse; }
            set { this._isStorageSecondaryKeyInUse = value; }
        }
        
        private int _retentionDays;
        
        /// <summary>
        /// Optional. Specifies the number of days to keep in the audit logs.
        /// </summary>
        public int RetentionDays
        {
            get { return this._retentionDays; }
            set { this._retentionDays = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. Specifies the state of the policy. The acceptable values
        /// are Disabled and Enabled.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _storageAccountAccessKey;
        
        /// <summary>
        /// Optional. Specifies the identifier key of the auditing storage
        /// account.
        /// </summary>
        public string StorageAccountAccessKey
        {
            get { return this._storageAccountAccessKey; }
            set { this._storageAccountAccessKey = value; }
        }
        
        private string _storageAccountSubscriptionId;
        
        /// <summary>
        /// Optional. Gets or sets the storage account subscription Id.
        /// </summary>
        public string StorageAccountSubscriptionId
        {
            get { return this._storageAccountSubscriptionId; }
            set { this._storageAccountSubscriptionId = value; }
        }
        
        private string _storageEndpoint;
        
        /// <summary>
        /// Optional. Specifies the blob storage endpoint (e.g.
        /// https://MyAccount.blob.core.windows.net).
        /// </summary>
        public string StorageEndpoint
        {
            get { return this._storageEndpoint; }
            set { this._storageEndpoint = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BlobAuditingProperties class.
        /// </summary>
        public BlobAuditingProperties()
        {
            this.AuditActionsAndGroups = new LazyList<string>();
        }
    }
}
