// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Create or update Azure Sql Database parameters properties.
    /// </summary>
    public partial class DatabaseCreateOrUpdateProperties
    {
        private string _collation;
        
        /// <summary>
        /// Optional. Gets or sets the collation of the Azure Sql Database
        /// being created.  You cannot change change the collation of an
        /// existing Azure Sql Database.
        /// </summary>
        public string Collation
        {
            get { return this._collation; }
            set { this._collation = value; }
        }
        
        private string _createMode;
        
        /// <summary>
        /// Optional. Gets or sets the create Mode for the Azure Sql Database
        /// database being created.
        /// </summary>
        public string CreateMode
        {
            get { return this._createMode; }
            set { this._createMode = value; }
        }
        
        private string _edition;
        
        /// <summary>
        /// Optional. Gets or sets the edition for the Azure Sql Database being
        /// updated or created.
        /// </summary>
        public string Edition
        {
            get { return this._edition; }
            set { this._edition = value; }
        }
        
        private string _elasticPoolName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the Elastic Pool to put the
        /// Azure Sql Database in.
        /// </summary>
        public string ElasticPoolName
        {
            get { return this._elasticPoolName; }
            set { this._elasticPoolName = value; }
        }
        
        private long? _maxSizeBytes;
        
        /// <summary>
        /// Optional. Gets or sets the maximum size of the Azure Sql Database
        /// being created or updated in bytes.
        /// </summary>
        public long? MaxSizeBytes
        {
            get { return this._maxSizeBytes; }
            set { this._maxSizeBytes = value; }
        }
        
        private string _recoveryServicesRecoveryPointResourceId;
        
        /// <summary>
        /// Optional. Gets or sets the recovery services restore point resource
        /// ID (for LTR)
        /// </summary>
        public string RecoveryServicesRecoveryPointResourceId
        {
            get { return this._recoveryServicesRecoveryPointResourceId; }
            set { this._recoveryServicesRecoveryPointResourceId = value; }
        }
        
        private System.Guid? _requestedServiceObjectiveId;
        
        /// <summary>
        /// Optional. Gets or sets the service objective to be applied to the
        /// Azure Sql Database being created or updated.
        /// </summary>
        public System.Guid? RequestedServiceObjectiveId
        {
            get { return this._requestedServiceObjectiveId; }
            set { this._requestedServiceObjectiveId = value; }
        }
        
        private string _requestedServiceObjectiveName;
        
        /// <summary>
        /// Optional. Gets or sets the service objective to be applied to the
        /// Azure Sql Database being created or updated.
        /// </summary>
        public string RequestedServiceObjectiveName
        {
            get { return this._requestedServiceObjectiveName; }
            set { this._requestedServiceObjectiveName = value; }
        }
        
        private System.DateTime? _restorePointInTime;
        
        /// <summary>
        /// Optional. Gets or sets the point in time for the restore request
        /// </summary>
        public System.DateTime? RestorePointInTime
        {
            get { return this._restorePointInTime; }
            set { this._restorePointInTime = value; }
        }
        
        private string _sourceDatabaseId;
        
        /// <summary>
        /// Optional. Gets or sets the resource id of the database to use as
        /// the source for the copy being created.
        /// </summary>
        public string SourceDatabaseId
        {
            get { return this._sourceDatabaseId; }
            set { this._sourceDatabaseId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DatabaseCreateOrUpdateProperties
        /// class.
        /// </summary>
        public DatabaseCreateOrUpdateProperties()
        {
        }
    }
}
