// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of an Azure SQL Database.
    /// </summary>
    public partial class DatabaseProperties
    {
        private string _collation;
        
        /// <summary>
        /// Optional. Gets the collation of the Azure SQL Database.
        /// </summary>
        public string Collation
        {
            get { return this._collation; }
            set { this._collation = value; }
        }
        
        private string _createMode;
        
        /// <summary>
        /// Optional. Gets the create mode for this database.
        /// </summary>
        public string CreateMode
        {
            get { return this._createMode; }
            set { this._createMode = value; }
        }
        
        private DateTime _creationDate;
        
        /// <summary>
        /// Optional. Gets the creation date of the Azure SQL Database.
        /// </summary>
        public DateTime CreationDate
        {
            get { return this._creationDate; }
            set { this._creationDate = value; }
        }
        
        private string _currentServiceObjectiveId;
        
        /// <summary>
        /// Optional. Gets the current Service Level Objective Id of the Azure
        /// SQL Database. This is the Id of the Service Level Objective that
        /// is currently active.
        /// </summary>
        public string CurrentServiceObjectiveId
        {
            get { return this._currentServiceObjectiveId; }
            set { this._currentServiceObjectiveId = value; }
        }
        
        private string _databaseId;
        
        /// <summary>
        /// Optional. Gets the Id of the Azure SQL Database.
        /// </summary>
        public string DatabaseId
        {
            get { return this._databaseId; }
            set { this._databaseId = value; }
        }
        
        private string _defaultSecondaryLocation;
        
        /// <summary>
        /// Optional. Gets the default secondary region for this database.
        /// </summary>
        public string DefaultSecondaryLocation
        {
            get { return this._defaultSecondaryLocation; }
            set { this._defaultSecondaryLocation = value; }
        }
        
        private DateTime _earliestRestoreDate;
        
        /// <summary>
        /// Optional. Gets the recovery period starte date of the Azure SQL
        /// Database. This records the start date and time when recovery is
        /// available for this Azure SQL Database.
        /// </summary>
        public DateTime EarliestRestoreDate
        {
            get { return this._earliestRestoreDate; }
            set { this._earliestRestoreDate = value; }
        }
        
        private string _edition;
        
        /// <summary>
        /// Optional. Gets the edition of the Azure SQL Database.  The
        /// DatabaseEditions enumeration contains all the valid editions.
        /// </summary>
        public string Edition
        {
            get { return this._edition; }
            set { this._edition = value; }
        }
        
        private string _elasticPoolName;
        
        /// <summary>
        /// Optional. Gets the name of the Azure SQL Database Elastic Pool the
        /// database is in.
        /// </summary>
        public string ElasticPoolName
        {
            get { return this._elasticPoolName; }
            set { this._elasticPoolName = value; }
        }
        
        private long _maxSizeBytes;
        
        /// <summary>
        /// Optional. Gets the max size of the Azure SQL Database expressed in
        /// bytes.
        /// </summary>
        public long MaxSizeBytes
        {
            get { return this._maxSizeBytes; }
            set { this._maxSizeBytes = value; }
        }
        
        private string _requestedServiceObjectiveId;
        
        /// <summary>
        /// Optional. Gets the configured Service Level Objective Id of the
        /// Azure SQL Database. This is the Service Level Objective that is
        /// being applied to the Azure SQL Database.
        /// </summary>
        public string RequestedServiceObjectiveId
        {
            get { return this._requestedServiceObjectiveId; }
            set { this._requestedServiceObjectiveId = value; }
        }
        
        private string _requestedServiceObjectiveName;
        
        /// <summary>
        /// Optional. Gets the name of the configured Service Level Objective
        /// of the Azure SQL Database. This is the Service Level Objective
        /// that is being applied to the Azure SQL Database.
        /// </summary>
        public string RequestedServiceObjectiveName
        {
            get { return this._requestedServiceObjectiveName; }
            set { this._requestedServiceObjectiveName = value; }
        }
        
        private IList<Schema> _schemas;
        
        /// <summary>
        /// Optional. Gets the schemas from this database.
        /// </summary>
        public IList<Schema> Schemas
        {
            get { return this._schemas; }
            set { this._schemas = value; }
        }
        
        private string _serviceObjective;
        
        /// <summary>
        /// Optional. Gets the Service Level Objective of the Azure SQL
        /// Database.
        /// </summary>
        public string ServiceObjective
        {
            get { return this._serviceObjective; }
            set { this._serviceObjective = value; }
        }
        
        private IList<ServiceTierAdvisor> _serviceTierAdvisors;
        
        /// <summary>
        /// Optional. Gets the list of service tier advisors for this database.
        /// Expanded property
        /// </summary>
        public IList<ServiceTierAdvisor> ServiceTierAdvisors
        {
            get { return this._serviceTierAdvisors; }
            set { this._serviceTierAdvisors = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Gets the status of the Azure SQL Database.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private UpgradeHint _upgradeHint;
        
        /// <summary>
        /// Optional. Gets the upgrade hint for this database.
        /// </summary>
        public UpgradeHint UpgradeHint
        {
            get { return this._upgradeHint; }
            set { this._upgradeHint = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DatabaseProperties class.
        /// </summary>
        public DatabaseProperties()
        {
            this.Schemas = new LazyList<Schema>();
            this.ServiceTierAdvisors = new LazyList<ServiceTierAdvisor>();
        }
    }
}
