// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the Azure SQL Server edition capabilities.
    /// </summary>
    public partial class EditionCapability
    {
        private string _name;
        
        /// <summary>
        /// Optional. Gets the edition name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Gets the status of the Azure SQL Server edition.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private IList<ServiceObjectiveCapability> _supportedServiceObjectives;
        
        /// <summary>
        /// Optional. Gets the list of supported Service Objectives for the
        /// edition.
        /// </summary>
        public IList<ServiceObjectiveCapability> SupportedServiceObjectives
        {
            get { return this._supportedServiceObjectives; }
            set { this._supportedServiceObjectives = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the EditionCapability class.
        /// </summary>
        public EditionCapability()
        {
            this.SupportedServiceObjectives = new LazyList<ServiceObjectiveCapability>();
        }
    }
}
