// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of an Azure SQL Database Elastic Pool.
    /// </summary>
    public partial class ElasticPoolProperties
    {
        private System.DateTime? _creationDate;
        
        /// <summary>
        /// Optional. Gets the creation date of the Azure SQL Database Elastic
        /// Pool.
        /// </summary>
        public System.DateTime? CreationDate
        {
            get { return this._creationDate; }
            set { this._creationDate = value; }
        }
        
        private int _databaseDtuMax;
        
        /// <summary>
        /// Optional. Gets the maximum DTU any one Sql Azure Database can
        /// consume.
        /// </summary>
        public int DatabaseDtuMax
        {
            get { return this._databaseDtuMax; }
            set { this._databaseDtuMax = value; }
        }
        
        private int _databaseDtuMin;
        
        /// <summary>
        /// Optional. Gets the minimum DTU all Sql Azure Databases are
        /// guaranteed.
        /// </summary>
        public int DatabaseDtuMin
        {
            get { return this._databaseDtuMin; }
            set { this._databaseDtuMin = value; }
        }
        
        private int _dtu;
        
        /// <summary>
        /// Optional. Gets the total shared DTU for the Sql Azure Database
        /// Elastic Pool.
        /// </summary>
        public int Dtu
        {
            get { return this._dtu; }
            set { this._dtu = value; }
        }
        
        private string _edition;
        
        /// <summary>
        /// Optional. Gets the edition of the Azure SQL Database Elastic Pool.
        /// The DatabaseEditions enumeration contains all the valid editions.
        /// </summary>
        public string Edition
        {
            get { return this._edition; }
            set { this._edition = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. Gets the state of the Azure SQL Database Elastic Pool.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private int _storageMB;
        
        /// <summary>
        /// Optional. Gets storage limit for the Sql Azure Database Elastic
        /// Pool in MB.
        /// </summary>
        public int StorageMB
        {
            get { return this._storageMB; }
            set { this._storageMB = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ElasticPoolProperties class.
        /// </summary>
        public ElasticPoolProperties()
        {
        }
    }
}
