// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Import Azure SQL Database parameters.
    /// </summary>
    public partial class ImportExtensionRequestParameteres
    {
        private string _extensionName;
        
        /// <summary>
        /// Optional. Gets the name of the extenstion.
        /// </summary>
        public string ExtensionName
        {
            get { return this._extensionName; }
            set { this._extensionName = value; }
        }
        
        private string _extensionType;
        
        /// <summary>
        /// Optional. Gets the type of the extenstion.
        /// </summary>
        public string ExtensionType
        {
            get { return this._extensionType; }
            set { this._extensionType = value; }
        }
        
        private ImportExtensionProperties _properties;
        
        /// <summary>
        /// Required. Gets or sets the properties of the request.
        /// </summary>
        public ImportExtensionProperties Properties
        {
            get { return this._properties; }
            set { this._properties = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ImportExtensionRequestParameteres
        /// class.
        /// </summary>
        public ImportExtensionRequestParameteres()
        {
            this.ExtensionName = "Import";
            this.ExtensionType = "Microsoft.Sql/servers/databases/extensions";
        }
        
        /// <summary>
        /// Initializes a new instance of the ImportExtensionRequestParameteres
        /// class with required arguments.
        /// </summary>
        public ImportExtensionRequestParameteres(ImportExtensionProperties properties)
            : this()
        {
            if (properties == null)
            {
                throw new ArgumentNullException("properties");
            }
            this.Properties = properties;
        }
    }
}
