// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Import Azure SQL Database parameters.
    /// </summary>
    public partial class ImportRequestParameters : ExportRequestParameters
    {
        private long _databaseMaxSize;
        
        /// <summary>
        /// Optional. Gets or sets the maximum size for the newly imported
        /// database.
        /// </summary>
        public long DatabaseMaxSize
        {
            get { return this._databaseMaxSize; }
            set { this._databaseMaxSize = value; }
        }
        
        private string _databaseName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the Azure SQL database to import.
        /// </summary>
        public string DatabaseName
        {
            get { return this._databaseName; }
            set { this._databaseName = value; }
        }
        
        private string _edition;
        
        /// <summary>
        /// Optional. Gets or sets the edition for the Azure Sql Database being
        /// created.
        /// </summary>
        public string Edition
        {
            get { return this._edition; }
            set { this._edition = value; }
        }
        
        private string _serviceObjectiveName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the service objective to assign
        /// to the Azure SQL Database.
        /// </summary>
        public string ServiceObjectiveName
        {
            get { return this._serviceObjectiveName; }
            set { this._serviceObjectiveName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ImportRequestParameters class.
        /// </summary>
        public ImportRequestParameters()
        {
        }
    }
}
