// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents impact of applying a Recommended Action, either estimated or
    /// observed
    /// </summary>
    public partial class RecommendedActionImpactInfo
    {
        private double? _absoluteValue;
        
        /// <summary>
        /// Optional. Gets the absolute value of this dimension if applicable.
        /// E.g., Number of Queries affected
        /// </summary>
        public double? AbsoluteValue
        {
            get { return this._absoluteValue; }
            set { this._absoluteValue = value; }
        }
        
        private double? _changeValueAbsolute;
        
        /// <summary>
        /// Optional. Gets the absolute change in the value of this dimension.
        /// E.g., Absolute Disk space change in Megabytes
        /// </summary>
        public double? ChangeValueAbsolute
        {
            get { return this._changeValueAbsolute; }
            set { this._changeValueAbsolute = value; }
        }
        
        private double? _changeValueRelative;
        
        /// <summary>
        /// Optional. Gets the relative change in the value of this dimension.
        /// E.g., Relative Disk space change in Percentage
        /// </summary>
        public double? ChangeValueRelative
        {
            get { return this._changeValueRelative; }
            set { this._changeValueRelative = value; }
        }
        
        private string _dimensionName;
        
        /// <summary>
        /// Optional. Gets the name of the impact dimension. E.g., CPUChange,
        /// DiskSpaceChange, NumberOfQueriesAffected.
        /// </summary>
        public string DimensionName
        {
            get { return this._dimensionName; }
            set { this._dimensionName = value; }
        }
        
        private string _unit;
        
        /// <summary>
        /// Optional. Gets the unit in which impact of this dimension is
        /// measured. E.g., DTU, MegaBytes
        /// </summary>
        public string Unit
        {
            get { return this._unit; }
            set { this._unit = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RecommendedActionImpactInfo class.
        /// </summary>
        public RecommendedActionImpactInfo()
        {
        }
    }
}
