// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents implementation info of a Recommended Action if user wants to
    /// manually apply this Recommended Action
    /// </summary>
    public partial class RecommendedActionImplementationInfo
    {
        private string _method;
        
        /// <summary>
        /// Optional. Gets the method in which this Recommended Action can be
        /// manually implemented. E.g., TSql, AzurePowerShell.
        /// </summary>
        public string Method
        {
            get { return this._method; }
            set { this._method = value; }
        }
        
        private string _script;
        
        /// <summary>
        /// Optional. Gets the implementation script. E.g., T-SQL script that
        /// could be executed on the database.
        /// </summary>
        public string Script
        {
            get { return this._script; }
            set { this._script = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// RecommendedActionImplementationInfo class.
        /// </summary>
        public RecommendedActionImplementationInfo()
        {
        }
    }
}
