// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the response to a list recommended actions request.
    /// </summary>
    public partial class RecommendedActionListResponse : AzureOperationResponse, IEnumerable<RecommendedAction>
    {
        private IList<RecommendedAction> _recommendedActions;
        
        /// <summary>
        /// Optional. Gets or sets the list of Recommended actions of the
        /// advisor
        /// </summary>
        public IList<RecommendedAction> RecommendedActions
        {
            get { return this._recommendedActions; }
            set { this._recommendedActions = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RecommendedActionListResponse
        /// class.
        /// </summary>
        public RecommendedActionListResponse()
        {
            this.RecommendedActions = new LazyList<RecommendedAction>();
        }
        
        /// <summary>
        /// Gets the sequence of RecommendedActions.
        /// </summary>
        public IEnumerator<RecommendedAction> GetEnumerator()
        {
            return this.RecommendedActions.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of RecommendedActions.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
