// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of an Azure SQL Database Replication Link.
    /// </summary>
    public partial class ReplicationLinkProperties
    {
        private string _partnerDatabase;
        
        /// <summary>
        /// Optional. Gets the name of the partner Azure SQL Database.
        /// </summary>
        public string PartnerDatabase
        {
            get { return this._partnerDatabase; }
            set { this._partnerDatabase = value; }
        }
        
        private string _partnerLocation;
        
        /// <summary>
        /// Optional. Gets the Azure Region of the partner Azure SQL Database.
        /// </summary>
        public string PartnerLocation
        {
            get { return this._partnerLocation; }
            set { this._partnerLocation = value; }
        }
        
        private string _partnerRole;
        
        /// <summary>
        /// Optional. Gets the role of the partner Azure SQL Database in the
        /// replication link.
        /// </summary>
        public string PartnerRole
        {
            get { return this._partnerRole; }
            set { this._partnerRole = value; }
        }
        
        private string _partnerServer;
        
        /// <summary>
        /// Optional. Gets the name of the Azure SQL Server hosting the partner
        /// Azure SQL Database.
        /// </summary>
        public string PartnerServer
        {
            get { return this._partnerServer; }
            set { this._partnerServer = value; }
        }
        
        private string _percentComplete;
        
        /// <summary>
        /// Optional. Gets the percentage of seeding complete for the
        /// replication link.
        /// </summary>
        public string PercentComplete
        {
            get { return this._percentComplete; }
            set { this._percentComplete = value; }
        }
        
        private string _replicationState;
        
        /// <summary>
        /// Optional. Gets the replication state for the replication link.
        /// </summary>
        public string ReplicationState
        {
            get { return this._replicationState; }
            set { this._replicationState = value; }
        }
        
        private string _role;
        
        /// <summary>
        /// Optional. Gets the role of the Azure SQL Database in the
        /// replication link.
        /// </summary>
        public string Role
        {
            get { return this._role; }
            set { this._role = value; }
        }
        
        private DateTime _startTime;
        
        /// <summary>
        /// Optional. Gets the start time for the replication link.
        /// </summary>
        public DateTime StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ReplicationLinkProperties class.
        /// </summary>
        public ReplicationLinkProperties()
        {
        }
    }
}
