// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Storage.Models
{
    /// <summary>
    /// The URIs that are used to perform a retrieval of a public blob, queue
    /// or table object.
    /// </summary>
    public partial class Endpoints
    {
        private Uri _blob;
        
        /// <summary>
        /// Optional. Gets the blob endpoint.
        /// </summary>
        public Uri Blob
        {
            get { return this._blob; }
            set { this._blob = value; }
        }
        
        private Uri _file;
        
        /// <summary>
        /// Optional. Gets the file endpoint.
        /// </summary>
        public Uri File
        {
            get { return this._file; }
            set { this._file = value; }
        }
        
        private Uri _queue;
        
        /// <summary>
        /// Optional. Gets the queue endpoint.
        /// </summary>
        public Uri Queue
        {
            get { return this._queue; }
            set { this._queue = value; }
        }
        
        private Uri _table;
        
        /// <summary>
        /// Optional. Gets the table endpoint.
        /// </summary>
        public Uri Table
        {
            get { return this._table; }
            set { this._table = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Endpoints class.
        /// </summary>
        public Endpoints()
        {
        }
    }
}
