// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Storage.Models
{
    /// <summary>
    /// The state of the storage account at the time the operation was called.
    /// </summary>
    public enum ProvisioningState
    {
        /// <summary>
        /// The storage account is being created. When an account is in
        /// “Creating” state, only properties that are specified as input for
        /// Create operation are returned.
        /// </summary>
        Creating = 0,
        
        /// <summary>
        /// The DNS name for the storage account is being propagated.
        /// </summary>
        ResolvingDNS = 1,
        
        /// <summary>
        /// The storage account is active for use.
        /// </summary>
        Succeeded = 2,
    }
}
