// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Storage;
using Microsoft.Azure.Management.Storage.Models;

namespace Microsoft.Azure.Management.Storage
{
    /// <summary>
    /// The Storage Management Client.
    /// </summary>
    public static partial class UsageOperationsExtensions
    {
        /// <summary>
        /// Gets the current usage count and the limit for the resources under
        /// the subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Storage.IUsageOperations.
        /// </param>
        /// <returns>
        /// The List Usages operation response.
        /// </returns>
        public static UsageListResponse List(this IUsageOperations operations)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IUsageOperations)s).ListAsync();
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets the current usage count and the limit for the resources under
        /// the subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Storage.IUsageOperations.
        /// </param>
        /// <returns>
        /// The List Usages operation response.
        /// </returns>
        public static Task<UsageListResponse> ListAsync(this IUsageOperations operations)
        {
            return operations.ListAsync(CancellationToken.None);
        }
    }
}
