// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Azure.Management.StreamAnalytics.Models;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// The properties of the Azure Machine Learning web service function
    /// binding.
    /// </summary>
    public partial class AzureMachineLearningWebServiceFunctionBindingProperties
    {
        private string _apiKey;
        
        /// <summary>
        /// Optional. Gets or sets the API key used to authenticate with
        /// Request-Response endpoint.
        /// </summary>
        public string ApiKey
        {
            get { return this._apiKey; }
            set { this._apiKey = value; }
        }
        
        private int? _batchSize;
        
        /// <summary>
        /// Optional. Gets or sets the maximum number of rows for every Azure
        /// ML web service execute request. Value between 1 and 10000. Default
        /// is 1000.
        /// </summary>
        public int? BatchSize
        {
            get { return this._batchSize; }
            set { this._batchSize = value; }
        }
        
        private string _endpoint;
        
        /// <summary>
        /// Optional. Gets or sets the Request-Response execute endpoint of
        /// Azure Machine Learning web service.
        /// </summary>
        public string Endpoint
        {
            get { return this._endpoint; }
            set { this._endpoint = value; }
        }
        
        private AzureMachineLearningWebServiceInputs _inputs;
        
        /// <summary>
        /// Optional. Gets or sets the inputs for the Azure Machine Learning
        /// web service endpoint.
        /// </summary>
        public AzureMachineLearningWebServiceInputs Inputs
        {
            get { return this._inputs; }
            set { this._inputs = value; }
        }
        
        private IList<AzureMachineLearningWebServiceOutputColumn> _outputs;
        
        /// <summary>
        /// Optional. Gets or sets a list of outputs from the Azure Machine
        /// Learning web service endpoint execution.
        /// </summary>
        public IList<AzureMachineLearningWebServiceOutputColumn> Outputs
        {
            get { return this._outputs; }
            set { this._outputs = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceFunctionBindingProperties class.
        /// </summary>
        public AzureMachineLearningWebServiceFunctionBindingProperties()
        {
        }
    }
}
