// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// The input column for the Azure Machine Learning web service endpoint.
    /// </summary>
    public partial class AzureMachineLearningWebServiceInputColumn
    {
        private string _dataType;
        
        /// <summary>
        /// Optional. Gets or sets the data type of the input column. These are
        /// Azure Machine Learning data types
        /// (https://msdn.microsoft.com/en-us/library/azure/dn905923.aspx).
        /// </summary>
        public string DataType
        {
            get { return this._dataType; }
            set { this._dataType = value; }
        }
        
        private int? _mapTo;
        
        /// <summary>
        /// Optional. Gets or sets the zero based index of the function
        /// parameter this input maps to.
        /// </summary>
        public int? MapTo
        {
            get { return this._mapTo; }
            set { this._mapTo = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the name of the input column.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceInputColumn class.
        /// </summary>
        public AzureMachineLearningWebServiceInputColumn()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureMachineLearningWebServiceInputColumn class with required
        /// arguments.
        /// </summary>
        public AzureMachineLearningWebServiceInputColumn(string name)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            this.Name = name;
        }
    }
}
