// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// The properties of Blob data source as output.
    /// </summary>
    public partial class AzureTableOutputDataSourceProperties
    {
        private string _accountKey;
        
        /// <summary>
        /// Optional. Gets or sets the account key of the storage account
        /// containing the Azure Table.
        /// </summary>
        public string AccountKey
        {
            get { return this._accountKey; }
            set { this._accountKey = value; }
        }
        
        private string _accountName;
        
        /// <summary>
        /// Optional. Gets or sets the account name of the storage account
        /// containing the Azure Table.
        /// </summary>
        public string AccountName
        {
            get { return this._accountName; }
            set { this._accountName = value; }
        }
        
        private int? _batchSize;
        
        /// <summary>
        /// Optional. Gets or sets the number of rows to write to the table at
        /// a time.
        /// </summary>
        public int? BatchSize
        {
            get { return this._batchSize; }
            set { this._batchSize = value; }
        }
        
        private IList<string> _columnsToRemove;
        
        /// <summary>
        /// Optional. Gets or sets a list of one or more columns to remove from
        /// the output event entities.
        /// </summary>
        public IList<string> ColumnsToRemove
        {
            get { return this._columnsToRemove; }
            set { this._columnsToRemove = value; }
        }
        
        private string _partitionKey;
        
        /// <summary>
        /// Optional. Gets or sets the Azure Table's partition key.
        /// </summary>
        public string PartitionKey
        {
            get { return this._partitionKey; }
            set { this._partitionKey = value; }
        }
        
        private string _rowKey;
        
        /// <summary>
        /// Optional. Gets or sets the Azure Table's row key.
        /// </summary>
        public string RowKey
        {
            get { return this._rowKey; }
            set { this._rowKey = value; }
        }
        
        private string _table;
        
        /// <summary>
        /// Optional. Gets or sets the name of the Azure Table.
        /// </summary>
        public string Table
        {
            get { return this._table; }
            set { this._table = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureTableOutputDataSourceProperties class.
        /// </summary>
        public AzureTableOutputDataSourceProperties()
        {
        }
    }
}
