// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Azure.Management.StreamAnalytics.Models;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// The properties of Blob data source as output.
    /// </summary>
    public partial class BlobOutputDataSourceProperties
    {
        private string _container;
        
        /// <summary>
        /// Optional. Gets or sets the container of the blob.
        /// </summary>
        public string Container
        {
            get { return this._container; }
            set { this._container = value; }
        }
        
        private string _dateFormat;
        
        /// <summary>
        /// Optional. Gets or sets the date format. Wherever {date} appears in
        /// pathPattern, the value of this property is used as the date format
        /// instead.
        /// </summary>
        public string DateFormat
        {
            get { return this._dateFormat; }
            set { this._dateFormat = value; }
        }
        
        private string _pathPattern;
        
        /// <summary>
        /// Optional. Gets or sets the blob path pattern. Not a regular
        /// expression. Value is a pattern against which blob names are
        /// matched to determine whether to include data from the associated
        /// blobs in the streaming job output.
        /// </summary>
        public string PathPattern
        {
            get { return this._pathPattern; }
            set { this._pathPattern = value; }
        }
        
        private IList<StorageAccount> _storageAccounts;
        
        /// <summary>
        /// Optional. Gets or sets a list of one or more storage accounts.
        /// </summary>
        public IList<StorageAccount> StorageAccounts
        {
            get { return this._storageAccounts; }
            set { this._storageAccounts = value; }
        }
        
        private string _timeFormat;
        
        /// <summary>
        /// Optional. Gets or sets the time format. Wherever {time} appears in
        /// pathPattern, the value of this property is used as the time format
        /// instead.
        /// </summary>
        public string TimeFormat
        {
            get { return this._timeFormat; }
            set { this._timeFormat = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BlobOutputDataSourceProperties
        /// class.
        /// </summary>
        public BlobOutputDataSourceProperties()
        {
        }
    }
}
