// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// The running state of the job.
    /// </summary>
    public static partial class JobRunningState
    {
        /// <summary>
        /// Created.
        /// </summary>
        public const string Created = "Created";
        
        /// <summary>
        /// Starting.
        /// </summary>
        public const string Starting = "Starting";
        
        /// <summary>
        /// Stopping.
        /// </summary>
        public const string Stopping = "Stopping";
        
        /// <summary>
        /// Stopped.
        /// </summary>
        public const string Stopped = "Stopped";
        
        /// <summary>
        /// Deleting.
        /// </summary>
        public const string Deleting = "Deleting";
        
        /// <summary>
        /// Failed.
        /// </summary>
        public const string Failed = "Failed";
        
        /// <summary>
        /// The job is allocated, processing input, or waiting to process
        /// input. If the job shows a Running state without producing output,
        /// it is likely that the data processing time window is large or the
        /// query logic is complicated. Another reason may be that currently
        /// there isn't any data being sent to the job.
        /// </summary>
        public const string Running = "Running";
        
        /// <summary>
        /// This state indicates that a Stream Analytics job is encountering
        /// one of the following errors: input/output communication errors,
        /// query errors, or retry-able run-time errors. To distinguish what
        /// type of error(s) the job is encountering, view the operation logs.
        /// </summary>
        public const string Degraded = "Degraded";
        
        /// <summary>
        /// Restarting.
        /// </summary>
        public const string Restarting = "Restarting";
    }
}
