// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Azure.Management.StreamAnalytics.Models;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// The configuration of the scalar function.
    /// </summary>
    public partial class ScalarFunctionConfiguration
    {
        private FunctionBinding _binding;
        
        /// <summary>
        /// Optional. Gets or sets the physical binding of the function. In the
        /// Azure Machine Learning web service’s case, this describes the
        /// endpoint.
        /// </summary>
        public FunctionBinding Binding
        {
            get { return this._binding; }
            set { this._binding = value; }
        }
        
        private IList<FunctionInput> _inputs;
        
        /// <summary>
        /// Optional. Gets or sets a list of inputs describing the parameters
        /// of the function.
        /// </summary>
        public IList<FunctionInput> Inputs
        {
            get { return this._inputs; }
            set { this._inputs = value; }
        }
        
        private FunctionOutput _output;
        
        /// <summary>
        /// Optional. Gets or sets the output of the function.
        /// </summary>
        public FunctionOutput Output
        {
            get { return this._output; }
            set { this._output = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ScalarFunctionConfiguration class.
        /// </summary>
        public ScalarFunctionConfiguration()
        {
        }
    }
}
