// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;
using Microsoft.Azure.Management.TrafficManager.Models;

namespace Microsoft.Azure.Management.TrafficManager.Models
{
    /// <summary>
    /// The response to a 'CheckTrafficManagerNameAvailability' operation.
    /// </summary>
    public partial class CheckTrafficManagerRelativeDnsNameAvailabilityResponse : AzureOperationResponse
    {
        private string _message;
        
        /// <summary>
        /// Optional. Gets an error message explaining the Reason value in more
        /// detail.
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the resource.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private bool _nameAvailable;
        
        /// <summary>
        /// Optional. Gets a boolean value that indicates whether the name is
        /// available for you to use. If true, the name is available. If
        /// false, the name has already been taken or invalid and cannot be
        /// used.
        /// </summary>
        public bool NameAvailable
        {
            get { return this._nameAvailable; }
            set { this._nameAvailable = value; }
        }
        
        private Microsoft.Azure.Management.TrafficManager.Models.Reason? _reason;
        
        /// <summary>
        /// Optional. Gets the reason that a storage account name could not be
        /// used. The Reason element is only returned if NameAvailable is
        /// false.
        /// </summary>
        public Microsoft.Azure.Management.TrafficManager.Models.Reason? Reason
        {
            get { return this._reason; }
            set { this._reason = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. Gets or sets the type of the resource.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// CheckTrafficManagerRelativeDnsNameAvailabilityResponse class.
        /// </summary>
        public CheckTrafficManagerRelativeDnsNameAvailabilityResponse()
        {
        }
    }
}
