// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.WebSites.Models;

namespace Microsoft.Azure.Management.WebSites
{
    /// <summary>
    /// User source controls operations
    /// </summary>
    public partial interface ISourceControlOperations
    {
        /// <summary>
        /// Get user source control
        /// </summary>
        /// <param name='name'>
        /// The name of the source control (GitHub, Bitbucket, CodePlex or
        /// Dropbox)
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The get source control operation response.
        /// </returns>
        Task<SourceControlGetResponse> GetAsync(string name, CancellationToken cancellationToken);
        
        /// <summary>
        /// List source controls for user.
        /// </summary>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The list source controls operation response.
        /// </returns>
        Task<SourceControlListResponse> ListAsync(CancellationToken cancellationToken);
        
        /// <summary>
        /// Update source control for user.
        /// </summary>
        /// <param name='name'>
        /// The name of the source control (can be: GitHub, Bitbucket,
        /// CodePlex, Dropbox)
        /// </param>
        /// <param name='parameters'>
        /// Parameters supplied to the Update Source Control operation.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The update source control operation response.
        /// </returns>
        Task<SourceControlUpdateResponse> UpdateAsync(string name, SourceControlUpdateParameters parameters, CancellationToken cancellationToken);
    }
}
