// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.WebSites.Models;

namespace Microsoft.Azure.Management.WebSites.Models
{
    /// <summary>
    /// Cloning information for target site
    /// </summary>
    public partial class CloningInfo
    {
        private bool _cloneCustomHostNames;
        
        /// <summary>
        /// Optional. Clone custom hostnames
        /// </summary>
        public bool CloneCustomHostNames
        {
            get { return this._cloneCustomHostNames; }
            set { this._cloneCustomHostNames = value; }
        }
        
        private Guid _correlationId;
        
        /// <summary>
        /// Optional. Correlation Id. Used for bulk cloning operations
        /// </summary>
        public Guid CorrelationId
        {
            get { return this._correlationId; }
            set { this._correlationId = value; }
        }
        
        private string _hostingEnvironment;
        
        /// <summary>
        /// Optional. Hosting environment
        /// </summary>
        public string HostingEnvironment
        {
            get { return this._hostingEnvironment; }
            set { this._hostingEnvironment = value; }
        }
        
        private bool _overwrite;
        
        /// <summary>
        /// Optional. Overwrite target site
        /// </summary>
        public bool Overwrite
        {
            get { return this._overwrite; }
            set { this._overwrite = value; }
        }
        
        private SourceWebSite _source;
        
        /// <summary>
        /// Optional. Source website to clone
        /// </summary>
        public SourceWebSite Source
        {
            get { return this._source; }
            set { this._source = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CloningInfo class.
        /// </summary>
        public CloningInfo()
        {
        }
    }
}
