// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.WebSites.Models
{
    /// <summary>
    /// Publishing Credentials  for the website.
    /// </summary>
    public partial class PublishingCredentials
    {
        private string _publishingPassword;
        
        /// <summary>
        /// Required. Hash value of the password used for publishing the web
        /// site.
        /// </summary>
        public string PublishingPassword
        {
            get { return this._publishingPassword; }
            set { this._publishingPassword = value; }
        }
        
        private string _publishingUserName;
        
        /// <summary>
        /// Required. The username used for publishing the web site. This is
        /// normally a dollar sign prepended to the web site name (for
        /// example, "$contoso").
        /// </summary>
        public string PublishingUserName
        {
            get { return this._publishingUserName; }
            set { this._publishingUserName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the PublishingCredentials class.
        /// </summary>
        public PublishingCredentials()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the PublishingCredentials class with
        /// required arguments.
        /// </summary>
        public PublishingCredentials(string publishingPassword, string publishingUserName)
            : this()
        {
            if (publishingPassword == null)
            {
                throw new ArgumentNullException("publishingPassword");
            }
            if (publishingUserName == null)
            {
                throw new ArgumentNullException("publishingUserName");
            }
            this.PublishingPassword = publishingPassword;
            this.PublishingUserName = publishingUserName;
        }
    }
}
