// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.WebSites.Models
{
    /// <summary>
    /// Represents the properties of the site's source control.
    /// </summary>
    public partial class SiteSourceControlProperties
    {
        private string _branch;
        
        /// <summary>
        /// Optional. Gets or sets the branch (if required, will be master by
        /// default).
        /// </summary>
        public string Branch
        {
            get { return this._branch; }
            set { this._branch = value; }
        }
        
        private bool _deploymentRollbackEnabled;
        
        /// <summary>
        /// Optional. Gets or sets true to keep a repository for non-repository
        /// source control provider (like Dropbox) or false (by default)
        /// otherwise.
        /// </summary>
        public bool DeploymentRollbackEnabled
        {
            get { return this._deploymentRollbackEnabled; }
            set { this._deploymentRollbackEnabled = value; }
        }
        
        private bool _isManualIntegration;
        
        /// <summary>
        /// Optional. Gets or sets true for repository that requires to be
        /// manually synced or false (by default) otherwise.
        /// </summary>
        public bool IsManualIntegration
        {
            get { return this._isManualIntegration; }
            set { this._isManualIntegration = value; }
        }
        
        private bool _isMercurial;
        
        /// <summary>
        /// Optional. Gets or sets true if repository is Mercurial or false (by
        /// default) otherwise.
        /// </summary>
        public bool IsMercurial
        {
            get { return this._isMercurial; }
            set { this._isMercurial = value; }
        }
        
        private string _repoUrl;
        
        /// <summary>
        /// Required. Gets or sets the repository url.
        /// </summary>
        public string RepoUrl
        {
            get { return this._repoUrl; }
            set { this._repoUrl = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteSourceControlProperties class.
        /// </summary>
        public SiteSourceControlProperties()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteSourceControlProperties class
        /// with required arguments.
        /// </summary>
        public SiteSourceControlProperties(string repoUrl)
            : this()
        {
            if (repoUrl == null)
            {
                throw new ArgumentNullException("repoUrl");
            }
            this.RepoUrl = repoUrl;
        }
    }
}
