// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.WebSites.Models;

namespace Microsoft.Azure.Management.WebSites.Models
{
    /// <summary>
    /// The list source controls operation response.
    /// </summary>
    public partial class SourceControlListResponse : AzureOperationResponse, IEnumerable<SourceControl>
    {
        private IList<SourceControl> _sourceControls;
        
        /// <summary>
        /// Optional. Gets or sets the source controls list.
        /// </summary>
        public IList<SourceControl> SourceControls
        {
            get { return this._sourceControls; }
            set { this._sourceControls = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SourceControlListResponse class.
        /// </summary>
        public SourceControlListResponse()
        {
            this.SourceControls = new LazyList<SourceControl>();
        }
        
        /// <summary>
        /// Gets the sequence of SourceControls.
        /// </summary>
        public IEnumerator<SourceControl> GetEnumerator()
        {
            return this.SourceControls.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of SourceControls.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
