// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.WebSites.Models;

namespace Microsoft.Azure.Management.WebSites.Models
{
    /// <summary>
    /// The Update Web Site connection strings operation parameters.
    /// </summary>
    public partial class WebSiteUpdateConnectionStringsParameters : ResourceBase
    {
        private IList<ConnectionStringInfo> _properties;
        
        /// <summary>
        /// Required. The connection strings for the web site.
        /// </summary>
        public IList<ConnectionStringInfo> Properties
        {
            get { return this._properties; }
            set { this._properties = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// WebSiteUpdateConnectionStringsParameters class.
        /// </summary>
        public WebSiteUpdateConnectionStringsParameters()
        {
            this.Properties = new LazyList<ConnectionStringInfo>();
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// WebSiteUpdateConnectionStringsParameters class with required
        /// arguments.
        /// </summary>
        public WebSiteUpdateConnectionStringsParameters(IList<ConnectionStringInfo> properties, string location)
            : this()
        {
            if (properties == null)
            {
                throw new ArgumentNullException("properties");
            }
            if (location == null)
            {
                throw new ArgumentNullException("location");
            }
            this.Properties = properties;
            this.Location = location;
        }
    }
}
