// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Parameters supplied to the Walk Upgrade Domain operation.
    /// </summary>
    public partial class DeploymentWalkUpgradeDomainParameters
    {
        private int _upgradeDomain;
        
        /// <summary>
        /// Required. An integer value that identifies the update domain to
        /// update. Update domains are identified with a zero-based index: the
        /// first update domain has an ID of 0, the second has an ID of 1, and
        /// so on.
        /// </summary>
        public int UpgradeDomain
        {
            get { return this._upgradeDomain; }
            set { this._upgradeDomain = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// DeploymentWalkUpgradeDomainParameters class.
        /// </summary>
        public DeploymentWalkUpgradeDomainParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// DeploymentWalkUpgradeDomainParameters class with required
        /// arguments.
        /// </summary>
        public DeploymentWalkUpgradeDomainParameters(int upgradeDomain)
            : this()
        {
            this.UpgradeDomain = upgradeDomain;
        }
    }
}
