// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Parameters supplied to Prepare Deployment Migration Operation.
    /// </summary>
    public partial class PrepareDeploymentMigrationParameters
    {
        private string _destinationVirtualNetwork;
        
        /// <summary>
        /// Required. Destination Virtual Network type for migration.Accepted
        /// values are Default, New, Existing.
        /// </summary>
        public string DestinationVirtualNetwork
        {
            get { return this._destinationVirtualNetwork; }
            set { this._destinationVirtualNetwork = value; }
        }
        
        private string _resourceGroupName;
        
        /// <summary>
        /// Required. Name of the resource group for migration.
        /// </summary>
        public string ResourceGroupName
        {
            get { return this._resourceGroupName; }
            set { this._resourceGroupName = value; }
        }
        
        private string _subNetName;
        
        /// <summary>
        /// Required. Subnet name for migration.
        /// </summary>
        public string SubNetName
        {
            get { return this._subNetName; }
            set { this._subNetName = value; }
        }
        
        private string _virtualNetworkName;
        
        /// <summary>
        /// Required. Name of the Virtual Network for migration.
        /// </summary>
        public string VirtualNetworkName
        {
            get { return this._virtualNetworkName; }
            set { this._virtualNetworkName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// PrepareDeploymentMigrationParameters class.
        /// </summary>
        public PrepareDeploymentMigrationParameters()
        {
        }
    }
}
