// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Contains the unattend component.
    /// </summary>
    public partial class UnattendComponent
    {
        private string _componentName;
        
        /// <summary>
        /// Required. Specifies the name of the component to configure with the
        /// added content.
        /// </summary>
        public string ComponentName
        {
            get { return this._componentName; }
            set { this._componentName = value; }
        }
        
        private IList<ComponentSetting> _unattendComponentSettings;
        
        /// <summary>
        /// Optional. Specifies component settings.
        /// </summary>
        public IList<ComponentSetting> UnattendComponentSettings
        {
            get { return this._unattendComponentSettings; }
            set { this._unattendComponentSettings = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the UnattendComponent class.
        /// </summary>
        public UnattendComponent()
        {
            this.UnattendComponentSettings = new LazyList<ComponentSetting>();
        }
        
        /// <summary>
        /// Initializes a new instance of the UnattendComponent class with
        /// required arguments.
        /// </summary>
        public UnattendComponent(string componentName)
            : this()
        {
            if (componentName == null)
            {
                throw new ArgumentNullException("componentName");
            }
            this.ComponentName = componentName;
        }
    }
}
