// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Contains unattend pass.
    /// </summary>
    public partial class UnattendPassSettings
    {
        private string _passName;
        
        /// <summary>
        /// Required. Specifies the name of the pass that the content applies
        /// to.
        /// </summary>
        public string PassName
        {
            get { return this._passName; }
            set { this._passName = value; }
        }
        
        private IList<UnattendComponent> _unattendComponents;
        
        /// <summary>
        /// Optional. Specifies unattend components.
        /// </summary>
        public IList<UnattendComponent> UnattendComponents
        {
            get { return this._unattendComponents; }
            set { this._unattendComponents = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the UnattendPassSettings class.
        /// </summary>
        public UnattendPassSettings()
        {
            this.UnattendComponents = new LazyList<UnattendComponent>();
        }
        
        /// <summary>
        /// Initializes a new instance of the UnattendPassSettings class with
        /// required arguments.
        /// </summary>
        public UnattendPassSettings(string passName)
            : this()
        {
            if (passName == null)
            {
                throw new ArgumentNullException("passName");
            }
            this.PassName = passName;
        }
    }
}
