// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// A validation message for migrate deployment validation operation
    /// </summary>
    public partial class XrpMigrationValidateDeploymentMessage
    {
        private string _category;
        
        /// <summary>
        /// Optional. Category of this message item.
        /// </summary>
        public string Category
        {
            get { return this._category; }
            set { this._category = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Optional. Body of the message
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private string _resourceName;
        
        /// <summary>
        /// Optional. Name of the resource described in the message.
        /// </summary>
        public string ResourceName
        {
            get { return this._resourceName; }
            set { this._resourceName = value; }
        }
        
        private string _resourceType;
        
        /// <summary>
        /// Optional. Type of the resource described in the message.
        /// </summary>
        public string ResourceType
        {
            get { return this._resourceType; }
            set { this._resourceType = value; }
        }
        
        private string _virtualMachineName;
        
        /// <summary>
        /// Optional. Name of the virtual machine related to the message.
        /// </summary>
        public string VirtualMachineName
        {
            get { return this._virtualMachineName; }
            set { this._virtualMachineName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// XrpMigrationValidateDeploymentMessage class.
        /// </summary>
        public XrpMigrationValidateDeploymentMessage()
        {
        }
    }
}
