// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.ExpressRoute.Models
{
    /// <summary>
    /// Describes the Address Resolution Protocol (ARP) table statistic.
    /// </summary>
    public partial class AzureDedicatedCircuitPeeringArpInfo
    {
        private int _age;
        
        /// <summary>
        /// Optional. Specifies duration since the switch with a MAC address
        /// was mapped to the IP address.
        /// </summary>
        public int Age
        {
            get { return this._age; }
            set { this._age = value; }
        }
        
        private string _interface;
        
        /// <summary>
        /// Optional. Specifies switch interface where packets are forwarded.
        /// </summary>
        public string Interface
        {
            get { return this._interface; }
            set { this._interface = value; }
        }
        
        private string _ipAddress;
        
        /// <summary>
        /// Optional. Specifies IP address of the switch that the ARP table
        /// automatically maps to the MAC address of the switch.
        /// </summary>
        public string IpAddress
        {
            get { return this._ipAddress; }
            set { this._ipAddress = value; }
        }
        
        private string _macAddress;
        
        /// <summary>
        /// Optional. Specifies MAC address of the switch.
        /// </summary>
        public string MacAddress
        {
            get { return this._macAddress; }
            set { this._macAddress = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureDedicatedCircuitPeeringArpInfo class.
        /// </summary>
        public AzureDedicatedCircuitPeeringArpInfo()
        {
        }
    }
}
