// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.ExpressRoute.Models
{
    /// <summary>
    /// Describes VPNv4 information from the BGP database.
    /// </summary>
    public partial class AzureDedicatedCircuitPeeringRouteTableInfo
    {
        private string _locPrf;
        
        /// <summary>
        /// Optional. Specifies the local preference.
        /// </summary>
        public string LocPrf
        {
            get { return this._locPrf; }
            set { this._locPrf = value; }
        }
        
        private string _network;
        
        /// <summary>
        /// Optional. Specifies the network address from the BGP table.
        /// </summary>
        public string Network
        {
            get { return this._network; }
            set { this._network = value; }
        }
        
        private string _nextHop;
        
        /// <summary>
        /// Optional. Specifies the address of the BGP next hop.
        /// </summary>
        public string NextHop
        {
            get { return this._nextHop; }
            set { this._nextHop = value; }
        }
        
        private string _path;
        
        /// <summary>
        /// Optional. Specifies the BGP path per route.
        /// </summary>
        public string Path
        {
            get { return this._path; }
            set { this._path = value; }
        }
        
        private int _weight;
        
        /// <summary>
        /// Optional. Specifies the BGP weight.
        /// </summary>
        public int Weight
        {
            get { return this._weight; }
            set { this._weight = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureDedicatedCircuitPeeringRouteTableInfo class.
        /// </summary>
        public AzureDedicatedCircuitPeeringRouteTableInfo()
        {
        }
    }
}
