// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.ExpressRoute.Models
{
    /// <summary>
    /// Describes BGP path, prefix and attribute information for all
    /// connections to BGP neighbors.
    /// </summary>
    public partial class AzureDedicatedCircuitPeeringRouteTableSummary
    {
        private int _as;
        
        /// <summary>
        /// Optional. Specifies autonomous system number.
        /// </summary>
        public int AS
        {
            get { return this._as; }
            set { this._as = value; }
        }
        
        private string _neighbor;
        
        /// <summary>
        /// Optional. Specifies ip address of the neighbor.
        /// </summary>
        public string Neighbor
        {
            get { return this._neighbor; }
            set { this._neighbor = value; }
        }
        
        private string _statePfxRcd;
        
        /// <summary>
        /// Optional. Specifies current state of the BGP session.
        /// </summary>
        public string StatePfxRcd
        {
            get { return this._statePfxRcd; }
            set { this._statePfxRcd = value; }
        }
        
        private string _upDown;
        
        /// <summary>
        /// Optional. Specifies the length of time that the BGP session has
        /// been in the Established state, or the current status if not in the
        /// Established state.
        /// </summary>
        public string UpDown
        {
            get { return this._upDown; }
            set { this._upDown = value; }
        }
        
        private int _v;
        
        /// <summary>
        /// Optional. Specifies BGP version number spoken to the neighbor.
        /// </summary>
        public int V
        {
            get { return this._v; }
            set { this._v = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// AzureDedicatedCircuitPeeringRouteTableSummary class.
        /// </summary>
        public AzureDedicatedCircuitPeeringRouteTableSummary()
        {
        }
    }
}
