// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.ExpressRoute.Models
{
    /// <summary>
    /// Describes bytes in/ bytes out information at circuit level.
    /// </summary>
    public partial class AzureDedicatedCircuitStats
    {
        private ulong _primaryBytesIn;
        
        /// <summary>
        /// Optional. Specifies bytesin of the circuit on primary device.
        /// </summary>
        public ulong PrimaryBytesIn
        {
            get { return this._primaryBytesIn; }
            set { this._primaryBytesIn = value; }
        }
        
        private ulong _primaryBytesOut;
        
        /// <summary>
        /// Optional. Specifies bytesout of the circuit on primary device.
        /// </summary>
        public ulong PrimaryBytesOut
        {
            get { return this._primaryBytesOut; }
            set { this._primaryBytesOut = value; }
        }
        
        private ulong _secondaryBytesIn;
        
        /// <summary>
        /// Optional. Specifies bytesin of the circuit on secondary device.
        /// </summary>
        public ulong SecondaryBytesIn
        {
            get { return this._secondaryBytesIn; }
            set { this._secondaryBytesIn = value; }
        }
        
        private ulong _secondaryBytesOut;
        
        /// <summary>
        /// Optional. Specifies bytesout of the circuit on secondary device.
        /// </summary>
        public ulong SecondaryBytesOut
        {
            get { return this._secondaryBytesOut; }
            set { this._secondaryBytesOut = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AzureDedicatedCircuitStats class.
        /// </summary>
        public AzureDedicatedCircuitStats()
        {
        }
    }
}
