// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.Network.Models;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// The response to a ListLocalNetworkGateways request.
    /// </summary>
    public partial class ListLocalNetworkGatewaysResponse : AzureOperationResponse, IEnumerable<ListLocalNetworkGatewaysResponse.LocalNetworkGateway>
    {
        private IList<ListLocalNetworkGatewaysResponse.LocalNetworkGateway> _localNetworkGateways;
        
        /// <summary>
        /// Optional. The list of local network gateways.
        /// </summary>
        public IList<ListLocalNetworkGatewaysResponse.LocalNetworkGateway> LocalNetworkGateways
        {
            get { return this._localNetworkGateways; }
            set { this._localNetworkGateways = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ListLocalNetworkGatewaysResponse
        /// class.
        /// </summary>
        public ListLocalNetworkGatewaysResponse()
        {
            this.LocalNetworkGateways = new LazyList<ListLocalNetworkGatewaysResponse.LocalNetworkGateway>();
        }
        
        /// <summary>
        /// Gets the sequence of LocalNetworkGateways.
        /// </summary>
        public IEnumerator<ListLocalNetworkGatewaysResponse.LocalNetworkGateway> GetEnumerator()
        {
            return this.LocalNetworkGateways.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of LocalNetworkGateways.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
        
        public partial class LocalNetworkGateway
        {
            private IList<string> _addressSpace;
            
            /// <summary>
            /// Optional. Address space of local network gateway
            /// </summary>
            public IList<string> AddressSpace
            {
                get { return this._addressSpace; }
                set { this._addressSpace = value; }
            }
            
            private BgpSettings _bgpSettings;
            
            /// <summary>
            /// Optional. Local network gateway's BGP settings
            /// </summary>
            public BgpSettings BgpSettings
            {
                get { return this._bgpSettings; }
                set { this._bgpSettings = value; }
            }
            
            private string _gatewayName;
            
            /// <summary>
            /// Optional. The local network gateway Name.
            /// </summary>
            public string GatewayName
            {
                get { return this._gatewayName; }
                set { this._gatewayName = value; }
            }
            
            private Guid _id;
            
            /// <summary>
            /// Optional. The local network Gateway Id
            /// </summary>
            public Guid Id
            {
                get { return this._id; }
                set { this._id = value; }
            }
            
            private string _ipAddress;
            
            /// <summary>
            /// Optional. The IP address of local network gateway.
            /// </summary>
            public string IpAddress
            {
                get { return this._ipAddress; }
                set { this._ipAddress = value; }
            }
            
            /// <summary>
            /// Initializes a new instance of the LocalNetworkGateway class.
            /// </summary>
            public LocalNetworkGateway()
            {
                this.AddressSpace = new LazyList<string>();
            }
        }
    }
}
