// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// Parameters supplied to the Create Reserved IP operation.
    /// </summary>
    public partial class NetworkReservedIPCreateParameters
    {
        private string _deploymentName;
        
        /// <summary>
        /// Optional. The name of the deployment the IP belongs to, if used.
        /// </summary>
        public string DeploymentName
        {
            get { return this._deploymentName; }
            set { this._deploymentName = value; }
        }
        
        private string _label;
        
        /// <summary>
        /// Optional. The friendly identifier for the site.
        /// </summary>
        public string Label
        {
            get { return this._label; }
            set { this._label = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Optional. Location where the virtual network exists.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Name of the reserved IP.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _serviceName;
        
        /// <summary>
        /// Optional. The name of the service the IP belongs to, if used.
        /// </summary>
        public string ServiceName
        {
            get { return this._serviceName; }
            set { this._serviceName = value; }
        }
        
        private string _virtualIPName;
        
        /// <summary>
        /// Optional. The name of the virtual IP that we should reserve.
        /// </summary>
        public string VirtualIPName
        {
            get { return this._virtualIPName; }
            set { this._virtualIPName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NetworkReservedIPCreateParameters
        /// class.
        /// </summary>
        public NetworkReservedIPCreateParameters()
        {
        }
    }
}
