// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.Network.Models;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// A Network Security Group associated with your subscription.
    /// </summary>
    public partial class NetworkSecurityGroupGetResponse : AzureOperationResponse
    {
        private string _label;
        
        /// <summary>
        /// Optional. Gets or sets the description for the Network Security
        /// Group.
        /// </summary>
        public string Label
        {
            get { return this._label; }
            set { this._label = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Optional. Gets or sets the location where the Network Security
        /// Group exists.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the Network Security Group.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private IList<NetworkSecurityRule> _rules;
        
        /// <summary>
        /// Optional. Gets or sets the rules existing in the specified Network
        /// Security Group
        /// </summary>
        public IList<NetworkSecurityRule> Rules
        {
            get { return this._rules; }
            set { this._rules = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NetworkSecurityGroupGetResponse
        /// class.
        /// </summary>
        public NetworkSecurityGroupGetResponse()
        {
            this.Rules = new LazyList<NetworkSecurityRule>();
        }
    }
}
