// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// Represents the parameters necessary to the update a gateway connection
    /// </summary>
    public partial class UpdateGatewayConnectionParameters
    {
        private bool _enableBgp;
        
        /// <summary>
        /// Optional. Whether to establish a BGP session over this connection
        /// </summary>
        public bool EnableBgp
        {
            get { return this._enableBgp; }
            set { this._enableBgp = value; }
        }
        
        private int _routingWeight;
        
        /// <summary>
        /// Required. The Routing Weight
        /// </summary>
        public int RoutingWeight
        {
            get { return this._routingWeight; }
            set { this._routingWeight = value; }
        }
        
        private string _sharedKey;
        
        /// <summary>
        /// Optional. Ipsec share key
        /// </summary>
        public string SharedKey
        {
            get { return this._sharedKey; }
            set { this._sharedKey = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the UpdateGatewayConnectionParameters
        /// class.
        /// </summary>
        public UpdateGatewayConnectionParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the UpdateGatewayConnectionParameters
        /// class with required arguments.
        /// </summary>
        public UpdateGatewayConnectionParameters(int routingWeight)
            : this()
        {
            this.RoutingWeight = routingWeight;
        }
    }
}
