// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Scheduler.Models;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// Specifies the service bus authentication.
    /// </summary>
    public partial class JobServiceBusAuthentication
    {
        private string _sasKey;
        
        /// <summary>
        /// Required. Gets or sets the service bus SAS key.
        /// </summary>
        public string SasKey
        {
            get { return this._sasKey; }
            set { this._sasKey = value; }
        }
        
        private string _sasKeyName;
        
        /// <summary>
        /// Required. Gets or sets the service bus SAS key name.
        /// </summary>
        public string SasKeyName
        {
            get { return this._sasKeyName; }
            set { this._sasKeyName = value; }
        }
        
        private JobServiceBusAuthenticationType _type;
        
        /// <summary>
        /// Required. Gets or sets the service bus authentication type.
        /// </summary>
        public JobServiceBusAuthenticationType Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobServiceBusAuthentication class.
        /// </summary>
        public JobServiceBusAuthentication()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the JobServiceBusAuthentication class
        /// with required arguments.
        /// </summary>
        public JobServiceBusAuthentication(string sasKeyName, string sasKey, JobServiceBusAuthenticationType type)
            : this()
        {
            if (sasKeyName == null)
            {
                throw new ArgumentNullException("sasKeyName");
            }
            if (sasKey == null)
            {
                throw new ArgumentNullException("sasKey");
            }
            this.SasKeyName = sasKeyName;
            this.SasKey = sasKey;
            this.Type = type;
        }
    }
}
