// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// Specifies service bus brokered message properties.
    /// </summary>
    public partial class JobServiceBusBrokeredMessageProperties
    {
        private string _contentType;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// ContentType.
        /// </summary>
        public string ContentType
        {
            get { return this._contentType; }
            set { this._contentType = value; }
        }
        
        private string _correlationId;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// CorrelationId.
        /// </summary>
        public string CorrelationId
        {
            get { return this._correlationId; }
            set { this._correlationId = value; }
        }
        
        private bool _forcePersistence;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// ForcePersistence.
        /// </summary>
        public bool ForcePersistence
        {
            get { return this._forcePersistence; }
            set { this._forcePersistence = value; }
        }
        
        private string _label;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// Label.
        /// </summary>
        public string Label
        {
            get { return this._label; }
            set { this._label = value; }
        }
        
        private string _messageId;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// MessageId.
        /// </summary>
        public string MessageId
        {
            get { return this._messageId; }
            set { this._messageId = value; }
        }
        
        private string _partitionKey;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// PartitionKey.
        /// </summary>
        public string PartitionKey
        {
            get { return this._partitionKey; }
            set { this._partitionKey = value; }
        }
        
        private string _replyTo;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// ReplyTo.
        /// </summary>
        public string ReplyTo
        {
            get { return this._replyTo; }
            set { this._replyTo = value; }
        }
        
        private string _replyToSessionId;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// ReplyToSessionId.
        /// </summary>
        public string ReplyToSessionId
        {
            get { return this._replyToSessionId; }
            set { this._replyToSessionId = value; }
        }
        
        private System.DateTime? _scheduledEnqueueTimeUtc;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// ScheduledEnqueueTimeUtc.
        /// </summary>
        public System.DateTime? ScheduledEnqueueTimeUtc
        {
            get { return this._scheduledEnqueueTimeUtc; }
            set { this._scheduledEnqueueTimeUtc = value; }
        }
        
        private string _sessionId;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// SessionId.
        /// </summary>
        public string SessionId
        {
            get { return this._sessionId; }
            set { this._sessionId = value; }
        }
        
        private System.DateTime? _timeToLive;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// TimeToLive.
        /// </summary>
        public System.DateTime? TimeToLive
        {
            get { return this._timeToLive; }
            set { this._timeToLive = value; }
        }
        
        private string _to;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// To.
        /// </summary>
        public string To
        {
            get { return this._to; }
            set { this._to = value; }
        }
        
        private string _viaPartitionKey;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties
        /// ViaPartitionKey.
        /// </summary>
        public string ViaPartitionKey
        {
            get { return this._viaPartitionKey; }
            set { this._viaPartitionKey = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// JobServiceBusBrokeredMessageProperties class.
        /// </summary>
        public JobServiceBusBrokeredMessageProperties()
        {
        }
    }
}
