// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Scheduler.Models;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// Specifies service bus message for the base service bus action type
    /// </summary>
    public abstract partial class JobServiceBusMessage
    {
        private JobServiceBusAuthentication _authentication;
        
        /// <summary>
        /// Required. Gets or sets the service bus authentication.
        /// </summary>
        public JobServiceBusAuthentication Authentication
        {
            get { return this._authentication; }
            set { this._authentication = value; }
        }
        
        private JobServiceBusBrokeredMessageProperties _brokeredMessageProperties;
        
        /// <summary>
        /// Optional. Gets or sets the service bus brokered message properties.
        /// </summary>
        public JobServiceBusBrokeredMessageProperties BrokeredMessageProperties
        {
            get { return this._brokeredMessageProperties; }
            set { this._brokeredMessageProperties = value; }
        }
        
        private IDictionary<string, string> _customMessageProperties;
        
        /// <summary>
        /// Optional. Gets or sets the custom message properties.
        /// </summary>
        public IDictionary<string, string> CustomMessageProperties
        {
            get { return this._customMessageProperties; }
            set { this._customMessageProperties = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Required. Gets or sets the service bus message.
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private string _namespace;
        
        /// <summary>
        /// Required. Gets or sets the service bus namespace.
        /// </summary>
        public string Namespace
        {
            get { return this._namespace; }
            set { this._namespace = value; }
        }
        
        private JobServiceBusTransportType _transportType;
        
        /// <summary>
        /// Required. Gets or sets the service bus transport type.
        /// </summary>
        public JobServiceBusTransportType TransportType
        {
            get { return this._transportType; }
            set { this._transportType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobServiceBusMessage class.
        /// </summary>
        public JobServiceBusMessage()
        {
            this.CustomMessageProperties = new LazyDictionary<string, string>();
        }
    }
}
