// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a VM Network Subnet details object.
    /// </summary>
    public partial class VmNetworkSubnetDetails
    {
        private IList<string> _addressList;
        
        /// <summary>
        /// Required. VM network subnet address list.
        /// </summary>
        public IList<string> AddressList
        {
            get { return this._addressList; }
            set { this._addressList = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Required. VM Network subnet ID.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. VM network subnet name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VmNetworkSubnetDetails class.
        /// </summary>
        public VmNetworkSubnetDetails()
        {
            this.AddressList = new LazyList<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the VmNetworkSubnetDetails class with
        /// required arguments.
        /// </summary>
        public VmNetworkSubnetDetails(string id, string name, IList<string> addressList)
            : this()
        {
            if (id == null)
            {
                throw new ArgumentNullException("id");
            }
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (addressList == null)
            {
                throw new ArgumentNullException("addressList");
            }
            this.Id = id;
            this.Name = name;
            this.AddressList = addressList;
        }
    }
}
