// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// NicIPv4
    /// </summary>
    public partial class NicIPv4
    {
        private string _controller0IPv4Address;
        
        /// <summary>
        /// Optional. Gets or sets the Controller0IPv4Address
        /// </summary>
        public string Controller0IPv4Address
        {
            get { return this._controller0IPv4Address; }
            set { this._controller0IPv4Address = value; }
        }
        
        private string _controller1IPv4Address;
        
        /// <summary>
        /// Optional. Gets or sets the Controller1IPv4Address
        /// </summary>
        public string Controller1IPv4Address
        {
            get { return this._controller1IPv4Address; }
            set { this._controller1IPv4Address = value; }
        }
        
        private string _iPv4Address;
        
        /// <summary>
        /// Required. Gets or sets the IPv4 Address
        /// </summary>
        public string IPv4Address
        {
            get { return this._iPv4Address; }
            set { this._iPv4Address = value; }
        }
        
        private string _iPv4Gateway;
        
        /// <summary>
        /// Optional. Gets or sets the IPv4Gateway
        /// </summary>
        public string IPv4Gateway
        {
            get { return this._iPv4Gateway; }
            set { this._iPv4Gateway = value; }
        }
        
        private string _iPv4Netmask;
        
        /// <summary>
        /// Required. Gets or sets the IPv4Netmask
        /// </summary>
        public string IPv4Netmask
        {
            get { return this._iPv4Netmask; }
            set { this._iPv4Netmask = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NicIPv4 class.
        /// </summary>
        public NicIPv4()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the NicIPv4 class with required
        /// arguments.
        /// </summary>
        public NicIPv4(string iPv4Address, string iPv4Netmask)
            : this()
        {
            if (iPv4Address == null)
            {
                throw new ArgumentNullException("iPv4Address");
            }
            if (iPv4Netmask == null)
            {
                throw new ArgumentNullException("iPv4Netmask");
            }
            this.IPv4Address = iPv4Address;
            this.IPv4Netmask = iPv4Netmask;
        }
    }
}
