// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class respresents the details for clone request
    /// </summary>
    public partial class TriggerCloneRequest
    {
        private string _backupSetId;
        
        /// <summary>
        /// Required. The id of the backup set which the current snapshot is
        /// part of
        /// </summary>
        public string BackupSetId
        {
            get { return this._backupSetId; }
            set { this._backupSetId = value; }
        }
        
        private bool _returnWorkflowId;
        
        /// <summary>
        /// Optional. Determines whether or not the method will return the
        /// workflowId
        /// </summary>
        public bool ReturnWorkflowId
        {
            get { return this._returnWorkflowId; }
            set { this._returnWorkflowId = value; }
        }
        
        private Snapshot _sourceSnapshot;
        
        /// <summary>
        /// Required. Snapshot from a backup which is to be cloned
        /// </summary>
        public Snapshot SourceSnapshot
        {
            get { return this._sourceSnapshot; }
            set { this._sourceSnapshot = value; }
        }
        
        private IList<string> _targetACRIdList;
        
        /// <summary>
        /// Optional. List of existing access control records to add to the
        /// cloned volume
        /// </summary>
        public IList<string> TargetACRIdList
        {
            get { return this._targetACRIdList; }
            set { this._targetACRIdList = value; }
        }
        
        private IList<AccessControlRecord> _targetACRList;
        
        /// <summary>
        /// Optional. List of new access control records to add to the cloned
        /// volume
        /// </summary>
        public IList<AccessControlRecord> TargetACRList
        {
            get { return this._targetACRList; }
            set { this._targetACRList = value; }
        }
        
        private string _targetDeviceId;
        
        /// <summary>
        /// Required. The target device id, where the volume must be cloned to
        /// </summary>
        public string TargetDeviceId
        {
            get { return this._targetDeviceId; }
            set { this._targetDeviceId = value; }
        }
        
        private string _targetVolName;
        
        /// <summary>
        /// Required. Name of the cloned volume
        /// </summary>
        public string TargetVolName
        {
            get { return this._targetVolName; }
            set { this._targetVolName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the TriggerCloneRequest class.
        /// </summary>
        public TriggerCloneRequest()
        {
            this.TargetACRIdList = new List<string>();
            this.TargetACRList = new List<AccessControlRecord>();
        }
    }
}
